Prev |  |

## 2. Very detailed Change Log

This document intends to detail the change log for relatively recent work (roughly since the source code was tracked in Git).

### Note

This change log section represents git commits in range v2.6.0..HEAD (commits 8103b4e5c..541c2ecf0).

### 2.1. 2025-08-08 Jim Klimov <jimklimov+nut@gmail.com>

- configure.ac: for now do not require (pre-)release tagged commits to build changelog by default - keep doing it on systems where we can though
- configure.ac: rephrase the message about --enable-docs-changelog [#3019, #3053]
- ci_build.sh: limit default "configure --enable-docs-changelog=no" for CI builds on systems where CANBUILD_DOCS_ALL!=yes
- ci_build.sh: add support for WITH_CHANGELOG envvar to pass down as configure --enable-docs-changelog=…
- .github/workflows/codeql.yml: configure --disable-docs-changelog in CI builds
- configure.ac: for (pre-)release builds we default nut_enable_docs_changelog auto⇒yes - do so loudly, and default --with-doc man⇒auto as well for all builds to have a chance to try this
- docs/maintainer-guide.txt: update the guide
- docs/maintainer-guide.txt: commit that in tools/gitlog2version.sh: for development, set fallback NUT_VERSION_DEFAULT=X.Y.Z.1
- docs/maintainer-guide.txt: remind to double-check that release NUT_VERSION_DEFAULT in tools/gitlog2version.sh must be a triplet
- tools/gitlog2version.sh: for release, set fallback NUT_VERSION_DEFAULT=2.8.4
- appveyor.yml: SKIP for now NUT-Monitor prereqs

### 2.2. 2025-08-07 Jim Klimov <jimklimov+nut@gmail.com>

- appveyor.yml: parallelize "make install"
- appveyor.yml: also install gettext for NUT-Monitor resources
- appveyor.yml: disable back the docs-config attempt, we do not have tools nor time for that
- appveyor.yml: try to enable build of HTML docs, notably man pages
- appveyor.yml, NEWS.adoc: include mingw-w64-x86_64-python-pyqt6 [#3046]
- docs/config-prereqs.txt: suggest PyQt5/6 for Windows builds
- appveyor.yml: re-enable build with docs and installation, and zipping it Even if not really tested by that CI in recent iterations, or rather in the iteration which would result from this commit, this can help us get the artifacts made for a release build.
- appveyor.yml: re-enable some of the activity (except costlier NUT docs and checks so far)

### 2.3. 2025-08-06 Jim Klimov <jimklimov+nut@gmail.com>

- .github/workflows/PyNUTClient.yml, appveyor.yml, scripts/Windows/build-mingw-nut.sh, tools/gitlog2version.sh: Update versions for release of NUT v2.8.4
- docs/docinfo.xml.in: add docs increment summary for NUT v2.8.4 release
- NEWS.adoc: remove "PLANNED" from section title before NUT v2.8.4 release
- NEWS.adoc, UPGRADING.adoc, docs/docinfo.xml.in: finalize text before NUT v2.8.4 release
- docs/maintainer-guide.txt: revise instructions
- appveyor.yml: Revert "appveyor.yml: TEMPORARILY disable actual build/test of NUT, to re-cache prereqs and their ccache objects" This reverts commit 43376f874b8c0bc66d08136a522e60a80b9021af after https://ci.appveyor.com/project/nut-travis/nut cache was refreshed.
- appveyor.yml: cache built nut-win-deps before .ccache objects and pacman pkgs - v2
- appveyor.yml: cache built nut-win-deps before .ccache objects and pacman pkgs
- appveyor.yml: re-enable part of the recipe to do build NUT, just not test and install it …still saving time allowance to re-seed the caches; while fixing caches, skip docs build
- NEWS.adoc: mention rebalancing of Appveyor CI recipe to speed up the builds
- docs/docinfo.xml.in: fix typo in summary for NUT v2.8.3 release
- appveyor.yml: TEMPORARILY disable actual build/test of NUT, to re-cache prereqs and their ccache objects
- appveyor.yml: comment about reduced scope of build-mingw-prereqs.sh
- scripts/Windows/build-mingw-prereqs.sh: comment about netsnmp configure --disable-daemon
- scripts/Windows/build-mingw-prereqs.sh: log timing of configure, make, house-keeping operations
- scripts/Windows/build-mingw-prereqs.sh: reduce the scope of netsnmp build
- appveyor.yml: comment more about profiling/timing different build steps; comment away some more troubleshooting time-hogs
- appveyor.yml: do not update the MSYS2 ecosystem to bleeding edge, save some time to fit in the 1hr we are given

### 2.4. 2025-08-04 Jim Klimov <jimklimov+nut@gmail.com>

- ci_build.sh: try to increase ulimit
- docs/config-prereqs.txt, docs/nut.dict: suggest `ulimit` settings via /etc/login.conf for OpenBSD

### 2.5. 2025-08-03 Jim Klimov <jimklimov+nut@gmail.com>

- common/common.c, NEWS.adoc: warn that printf(%n) is deprecated on some newer platforms
- drivers/nutdrv_qx.c: avoid %n in printf nutdrv_qx.c:4499:27: error: %n specifier not supported on this platform [-Werror,-Wformat]

### 2.6. 2025-08-02 Jim Klimov <jimklimov+nut@gmail.com>

- docs/Makefile.am: fix SED syntax Kudos to Greg Troxel for the catch

### 2.7. 2025-08-01 Jim Klimov <jimklimov+nut@gmail.com>

- tools/nut-usbinfo.pl: find_usbdevs(): skip files that are not *.c or *.h [#3030]
- drivers/libusb0.c, drivers/libusb1.c: drivers/libusb{0,1}.c: nut_libusb_open(): for libusb specifically, we have a Wiki page about Insufficient Permissions [#3041]
- NEWS.adoc, common/common-nut_version.c, drivers/libusb0.c, drivers/libusb1.c, include/common.h: common/common-nut_version.c, include/common.h, drivers/libusb{0,1}.c, NEWS.adoc: introduce suggest_NDE_conflict() [#477, #3040]
- Makefile.am: check-parallel-builds: ensure that we are in the top_builddir when starting operations relative to it [#3030] Be pedantic to work around some quirk in NetBSD 9.2 bmake essentially.
- ci_build.sh: check-parallel-builds: pass CHECK_PARALLEL_BUILDS_REGEN=false as a make argument also, not just envvar [#3030]
- ci_build.sh: build_to_only_catch_errors_target(): fix "CI_PARMAKE_VERBOSITY=verbose" logging handling

### 2.8. 2025-07-31 Jim Klimov <jimklimov+nut@gmail.com>

- Makefile.am: check-parallel-builds: pre-clean before checking the source locations [#3033]
- Makefile.am: check-parallel-builds: for out-of-tree builds, check the source locations starting from the correct root [#3033]
- Makefile.am: check-parallel-builds: call automake portably - in a way detected by configure script [#3033]
- Makefile.am: check-parallel-builds: if called, automake must be in top_srcdir where configure.ac lives [#3033]
- .circleci/config.yml: drop explicit "make check-parallel-builds" [#3030] It is now invoked where applicable for scenarios with `BUILD_TYPE=default-all-errors*` and note it was not buildable as added anyway (earlier ci_build.sh wiped the work area).

### 2.9. 2025-07-30 Jim Klimov <jimklimov+nut@gmail.com>

- ci_build.sh: restore NEWS and README (if needed) between loops of default-all-errors [#3030]
- ci_build.sh: add a failsafe for CI via NUT_BUILD_CAPS=check-parallel-builds=no label [#3030]
- Makefile.am: spellcheck-quick/check-parallel-builds: refactor SET_PARMAKES_OPT() code to be reusable [#3030]
- Makefile.am: check-parallel-builds: fix suggested shell scriptlet to investigate failures [#3030] Notably, MAKEFLAGS may include the "make" options without the leading dash, or other values that did not have one originally. Better leave it as an environment variable and let the particular "make" program deal with it.
- ci_build.sh: optionally call "make check-parallel-builds" in BUILD_TYPE="default-all-errors*" [#3030]
- Makefile.am: check-parallel-builds: allow CHECK_PARALLEL_BUILDS_REGEN=false (to speed up runs where developer/CI did not change recipes anyway) [#3030]
- tools/nutconf/Makefile.am: libnutscan.la indirectly requires libcommonclient.la (for libupsclient-version.h) so bolt it into deps list [#3030]

### 2.10. 2025-07-29 Jim Klimov <jimklimov+nut@gmail.com>

- docs/man/.gitignore, docs/man/Makefile.am: docs/man/Makefile.am: linkman-driver{,tool}-names.txt: use unique "*.tmp.$$" filenames to fix parallel builds [#3030]
- scripts/upsdrvsvcctl/nut-driver-enumerator.sh.in, NEWS.adoc: fixed NDE to not consider "masked" systemd units as non-existent [#3033]
- NEWS.adoc: move voltronic-axpert to existing nutdrv_qx section [#1407]

### 2.11. 2025-07-28 Jim Klimov <jimklimov+nut@gmail.com>

- docs/man/phoenixcontact_modbus.txt: clarify that new options can be set only once (via init) at this time [#2986]
- NEWS.adoc: clarify how new options for phoenixcontact_modbus can be set [#2986]

### 2.12. 2025-07-27 Jim Klimov <jimklimov+nut@gmail.com>

- tools/gitlog2version.sh: do not pollute stdout [#3030]
- tools/gitlog2version.sh, docs/nut-versioning.adoc: tack on current commit if known, even if we fall back to built-in version otherwise [#3030]
- .github/workflows/codeql.yml: drop attempts to describe git-derived version better [#3030]
- tools/gitlog2version.sh: if we fail to "discover a NUT_VERSION_GIT_TRUNK" or "git describe", check and report if the current checkout is shallow [#3030] CI builds often do check out the built commit with minimal "depth" (often having just it), which is much faster, cheaper computationally and by traffic. This however precludes finding history intersections of current (single-commit) tree with other trees even if we fetch them.
- .github/workflows/codeql.yml: separate "make check-parallel-builds" from main build; troubleshoot gitlog2version [#3030]
- .circleci/config.yml, .github/workflows/codeql.yml, NEWS.adoc: .circleci/config.yml, .github/workflows/codeql.yml: invoke "make check-parallel-builds" [#3030]
- clients/Makefile.am, drivers/Makefile.am, server/Makefile.am, tests/Makefile.am, tools/nut-scanner/Makefile.am, tools/nutconf/Makefile.am: */Makefile.am: spell out known build order between out-of-dir dependencies [follows up from PR #2825, highlights why issue #2584 better be solved]
- Makefile.am, NEWS.adoc: introduced a `make check-parallel-builds` recipe [follows up from PR #2825]
- drivers/snmp-ups.c: re-order includes (keep eatons together)
- data/driver.list.in: update entry for Kebo UPS-1000D (add langid_fix and subdriver); add Tescom LEO Plus LCD 1500A which works with same config [#981]
- tools/nut-scanner/Makefile.am: ensure we only call NUT_SCANNER_DEPS and it has work to do only once [follows up from PR #2825] In practice we do call it as many times as there are listed dependency files, but it only generates them on the first run and quicky bails out later on. This should help avoid writing into same files in parallel, ending up with garbled or incomplete files when we want to use them.

### 2.13. 2025-07-24 Jim Klimov <jimklimov+nut@gmail.com>

- docs/images/ci/jenkins-nut.css: new style in town with Jenkins LTS 2.516.1

### 2.14. 2025-07-22 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/phoenixcontact_modbus.c: fix typo in what is now a formatting string [#2986]
- drivers/phoenixcontact_modbus.c, docs/man/phoenixcontact_modbus.txt: fix tweaks according to nut-names, use dstate (so standard variable default.* or override.* settings) [#2986]
- drivers/phoenixcontact_modbus.c: log FIXMEs for more use of NUT dstate overrides/defaults instead of addvar() tweaks
- drivers/phoenixcontact_modbus.c, docs/man/phoenixcontact_modbus.txt: fix according to nut-names: "(ups.)delay.shutdown" ⇒ "(battery.)energysave.delay" [#2986]
- drivers/phoenixcontact_modbus.c: fix whitespace in comments [#2986]

### 2.15. 2025-07-21 Jim Klimov <jimklimov+nut@gmail.com>

- configure.ac, docs/configure.txt: fix ASCIIDOC_TEMPLATE_LINKMANEXT* with HTML URL query part [#3027] …and a typo about quoting.
- configure.ac: define default ASCIIDOC_TEMPLATE_LINKMANEXT* according to target_os family (solarish, freebsd, openbsd; default=linux) [follow-up to #2797]
- configure.ac, docs/Makefile.am, docs/configure.txt, docs/man/Makefile.am: Support optional man page section rewrite also for linkmanext* references [follow-up to #2797]
- NEWS.adoc, configure.ac, docs/.gitignore, docs/{asciidoc.conf ⇒ asciidoc.conf.in}, docs/configure.txt, docs/man/.gitignore, docs/man/{asciidoc.conf ⇒ asciidoc.conf.in}: Do not hard-code linux.die.net (and its man sections) into generated linkmanext* that may vary by distro [follow-up to #2797]
- NEWS.adoc, docs/man/asciidoc.conf, docs/nut.dict: docs/man/asciidoc.conf, NEWS.adoc: fix generation of links to external manual pages [follow-up to #2797]

### 2.16. 2025-07-18 Jim Klimov <jimklimov+nut@gmail.com>

- common/common.c: minimize_formatting_string(): debug-log about "cosmetic" chars at level 7 [#2956]
- drivers/nutdrv_qx_voltronic.c: voltronic_mode(): word remaining alarms to be complete sentences [#2494]
- drivers/nutdrv_qx_voltronic.c: voltronic_mode(): add some debug logging [#2494]
- docs/man/nutdrv_qx.txt: fix quoting style from m4 to text
- drivers/nutdrv_qx_voltronic.c, NEWS.adoc: revise "vendor:voltronic:*" buzzword setting; these modes are not alarm material [#2494]

### 2.17. 2025-07-18 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- drivers/mge-hid.c: input.bypass.switch.on/off set flag quick update instead semi static

### 2.18. 2025-07-17 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/mge-hid.c: eaton_input_bypass_check_range(): fix typo checking for "value==1" [#2956]
- drivers/usbhid-ups.c: ups_alarm_set(): ignore ECOMODE, we handle it in ups_status_set() [#2956] Avoid extra work and occasional log messages that: str_add_unique_token: skip token vendor:default:ECO: was already set
- drivers/mge-hid.c: eaton_input_eco_mode_check_range(): refine log output if we remain in ECO/non-ECO mode [#2956]
- drivers/mge-hid.c: eaton_input_eco_mode_check_range(): sanity-check that value==1 [#2956]
- drivers/mge-hid.c: make "input.eco.switchable" a HU_FLAG_QUICK_POLL value [#2956] We want it evaluated on every quick-update loop, so that the correct buzzwords are always set (if device serves the feature). Also quick-update the bypass voltage and frequency, so we know relevant clues (keep semi-static settings as they were though).
- NEWS.adoc: NEWS.adoc, docs/nut.dict: summary mention for recent small PRs [#3019, #3021, #3022, #3023]
- drivers/mge-hid.c: convert "input.eco.switchable" definition from HU_FLAG_SEMI_STATIC to regular [#2956]
- drivers/mge-hid.c: move "input.eco.switchable" definition to end of mge_hid2nut[] table [#2956]
- Makefile.am: install-as-root: do not overly trust in systemctl preset-all It fails on systemd 252 (known issue): Failed to preset all units: Unit /run/systemd/transient/session-156053.scope is transient or generated.

### 2.19. 2025-07-16 Jim Klimov <jimklimov+nut@gmail.com>

- server/upsd.c: check_command(): try to print all command arguments (if debugging) [#3023]
- common/common.c: compareprocname(): Linux /proc/X/exe can end with " (deleted)" if the program was removed or replaced
- drivers/snmp-ups.c: su_setOID(): cast returned enum constants to int [#3017] Avoid error claimed by clang-20 et al: conditional expression between different enumeration types (enum (unnamed at ./upshandler.h:25:1) and enum (unnamed at ./upshandler.h:34:1)) [-Werror,-Wanon-enum-enum-conversion]
- docs/Makefile.am: ChangeLog ⇒ ChangeLog.adoc: avoid "$<" as this is not a suffix rule

### 2.20. 2025-07-15 Jim Klimov <jimklimov+nut@gmail.com>

- docs/Makefile.am: ChangeLog ⇒ ChangeLog.adoc: typo fix in fallback INPUT
- configure.ac, Makefile.am, docs/configure.txt, NEWS.adoc: introduce confgure option to customize git log ending point [#3019]
- tools/gitlog2changelog.py.in: allow specifying end of commit range, report it in text Technically a step to multi-section changelogs, covering each release separately as a range between git tags, regardless of timestamp overlap (with much older prepared commits going into much newer release later on).
- tools/gitlog2changelog.py.in: typo in comment
- docs/Makefile.am: ChangeLog ⇒ ChangeLog.adoc: revise definition of INPUT Actually saw it with two tokens recently, for the text and .prep-src-docs touch-file
- docs/Makefile.am: when writing temporary outputs, make sure they are not empty before moving to final name (else delete and bail out)
- docs/Makefile.am: .adoc ⇒ .adoc-parsed: double-check that input file exists If a recipe iteration is written incorrectly, make can skip work on some rules (evaluating them as true without writing outputs we need)
- configure.ac, docs/.gitignore, docs/Makefile.am, docs/configure.txt, docs/{docinfo.xml.sh ⇒ docinfo.xml.sh.in}: docs/docinfo.xml.sh.in: make it a template for configure script to generate and embed a @GITLOG_START_POINT@ value to consider
- configure.ac, Makefile.am, docs/configure.txt, NEWS.adoc: introduce confgure option to customize git log starting point
- ci_build.sh: configure --disable-docs-changelog in developer iterations
- configure.ac, docs/Makefile.am, docs/configure.txt, NEWS.adoc, docs/nut.dict: introduce option to "configure --enable-docs-changelog" (or not)
- docs/ci-farm-lxc-setup.txt: update link to conflict-aware-ondemand-strategy-plugin

### 2.21. 2025-07-14 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/mge-hid.c: fix back eaton_input_bypass_mode_on_info[]; update comments; make use of errno=0/EINVAL
- docs/nut.dict: add "nuf" to dict [#3017, #2956]
- drivers/usbhid-ups.c, NEWS.adoc: hid_ups_walk(HU_WALKMODE_INIT): report if exactly one of fun/nuf is defined in a one-line table, and it would preclude reads/writes [#2956]
- docs/nut.dict: add "nuf" to dict [#3017, #2956]
- drivers/mge-hid.c: introduce eaton_input_buzzwordmode_setvar_nuf() [#2956]
- drivers/usbhid-ups.c, NEWS.adoc: add a way for fun/nuf methods to report EINVAL for unsupported arguments, and bail out [#3017] Made for progresing on PR #2956
- drivers/nutdrv_qx.c, NEWS.adoc: add a way for item→preprocess() and qx_process() methods to report EINVAL for unsupported arguments, and bail out [#3017]
- drivers/snmp-ups.c: su_setOID(): refactor many elvises into one val_practical [#3017]
- drivers/usbhid-ups.c, NEWS.adoc: add a way for fun/nuf methods to report EINVAL for unsupported arguments, and bail out [#3017] Made for progresing on PR #2956
- drivers/snmp-ups.c, NEWS.adoc: add a way for fun/nuf methods to report EINVAL for unsupported arguments, and bail out [#3017]
- drivers/snmp-ups.c: su_setOID(): return *CONVERSION_FAILED where applicable; use upslog*_RESULT() in callers su_setvar()/su_instcmd() for maintainability
- drivers/snmp-ups.c: su_setOID(): rectify returns of STAT_SET_* vs. STAT_INSTCMD_* Be pedantically correct about these, even if they map to same numbers for logical names at the moment.
- drivers/upshandler.h: define loggers for CONVERSION_FAILED, and generally for common RESULT [#2957]
- drivers/mge-hid.c: fix indentations (TAB vs space) to be consistent [#2956]
- NEWS.adoc, common/common.c: common/common.c: minimize_formatting_string(): do not loudly log complaints about known cosmetic formatting chars [#2450]
- common/common.c: minimize_formatting_string(): update comments [#2450]

### 2.22. 2025-07-13 Axel Gembe <axel@gembe.net>

- docs/man/apc_modbus.txt: apc_modbus: Add another tested device model to the man page
- NEWS.adoc, drivers/apc_modbus.c: apc_modbus: Fix missing variables due to mismatching format string Calls to `dstate_setinfo_dynamic` were using a different format string in `fmt_dynamic` than spcified in `fmt_reference`. This causes the following variables to be missing: ``` battery.runtime experimental.output.energy ups.timer.shutdown ups.timer.start ups.timer.reboot input.transfer.high input.transfer.low ups.delay.shutdown ups.delay.start ups.delay.reboot outlet.group.0.delay.shutdown outlet.group.0.delay.start outlet.group.0.delay.reboot outlet.group.1.delay.shutdown outlet.group.1.delay.start outlet.group.1.delay.reboot outlet.group.2.delay.shutdown outlet.group.2.delay.start outlet.group.2.delay.reboot outlet.group.3.delay.shutdown outlet.group.3.delay.start outlet.group.3.delay.reboot ``` Since #2450 this caused this or similar error messages on our integer values: ``` [D1] validate_formatting_string: dynamic formatting string %u is not equivalent to expected %lu ``` This in turn caused the variable to not exist and later calls to `dstate_setflags` to output: ``` apc_modbus: dstate_setflags: base variable (battery.runtime) does not exist ``` We fix this by using the correct format string.

### 2.23. 2025-07-10 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/snmp-ups.c, NEWS.adoc: fix debug-logging of skipping SU_FLAG_STATIC entries [#3011]
- drivers/apc-mib.c, NEWS.adoc: fix "ups.test.date" from SU_FLAG_STATIC to SU_FLAG_SEMI_STATIC [#3011]

### 2.24. 2025-07-09 Jim Klimov <jimklimov+nut@gmail.com>

- NEWS.adoc: mention both APC BVKxxxM2 and BKxxxM2-CH in same fix for usbhid-ups

### 2.25. 2025-07-07 Jim Klimov <jimklimov+nut@gmail.com>

- scripts/systemd/nutshutdown.in, NEWS.adoc: bail out if MODE=none explicitly [#2935]
- drivers/mge-hid.c: refactor old (pegasus) and new (ECO/ESS) mapping tables with fun/nuf methods [#2956]
- drivers/mge-hid.c: comment which info_lkp_t[] tables are in fact wrong examples of mapping function usage [#2956]
- docs/man/phoenixcontact_modbus.txt: reconcile config setting names with strings used in the driver [#2986]
- docs/man/phoenixcontact_modbus.txt: align shutdown variables descriptions with comments in code [#2986]
- docs/man/nutupsdrv.txt: document `override.*` or `default.*` names for `var=val` settings
- docs/man/phoenixcontact_modbus.txt: wrap long lines; anticipate renaming/obsoletion of some driver-specific settings [#2986]
- NEWS.adoc: document recent changes to start-up messages and loop flushing in upsmon [#3003]
- clients/upsmon.c: report in debug-log which SHUTDOWNCMD/NOTIFYCMD would be used (and if no NOTIFYCMD was set) [#3003]
- clients/upsmon.c: fflush() at end of each main loop cycle, just in case
- clients/upsmon.c: make "Warning: no shutdown command defined" visible when the daemon starts Being a printf() to stdout, it got buffered and often only appeared on buffer flush when the daemon exited.
- NEWS.adoc, data/driver.list.in, docs/man/usbhid-ups.txt, docs/nut.dict, drivers/usbhid-ups.c: drivers/usbhid-ups.c: handle also APC BKnnnM2[_-]CH tweaks for lbrb_log_delay_without_calibrating/onlinedischarge_calibration [#3006, #2347] Update docs, data/driver.list.in suggestions; refactor the if-clause to detect if the tweak applies to the device being handled.

### 2.26. 2025-07-04 Jim Klimov <jimklimov+nut@gmail.com>

- NEWS.adoc: note further ECO mode updates in mge-hid [#2956]
- NEWS.adoc: clarify message for bcmxcp fix [#3002]
- NEWS.adoc: re-order ddriver updates alphabetically

### 2.27. 2025-07-03 desertwitch <24509509+desertwitch@users.noreply.github.com>

- NEWS.adoc: add bcmxcp fixes [#3002]
- drivers/bcmxcp.c: fix latched on to RB alarm

### 2.28. 2025-07-03 Jim Klimov <jimklimov+nut@gmail.com>

- docs/packager-guide.txt: suggest a nut-common package for shared stuff
- drivers/powervar_cx.c: remove space before parenthesis after status_set() to simplify review for issue [#2708]
- drivers/pijuice.c, NEWS.adoc: revise use of status_set() [#2708]

### 2.29. 2025-06-25 Jim Klimov <jimklimov+nut@gmail.com>

- NEWS.adoc: announce updates to phoenixcontact_modbus [#2986]
- docs/man/phoenixcontact_modbus.txt: fix asciidoc markup for man page [#2986] This is not directly a troff file
- drivers/phoenixcontact_modbus.c: fix CI complaints [#2986] * static methods * declarations before code * mismatches of int type vs printf formatting string (hex)
- docs/man/phoenixcontact_modbus.txt, docs/nut.dict: update authors/contributors list [#2986]
- drivers/phoenixcontact_modbus.c: fix author/contributor list [#2986]
- drivers/phoenixcontact_modbus.c: fix back broken whitespace [#2986]
- drivers/powervar_cx.c, drivers/powervar_cx_ser.c, drivers/powervar_cx_usb.c: drivers/powervar_cx*: fix more formatting string vs. int type mismatches [#2988]

### 2.30. 2025-06-25 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- drivers/mge-hid.c: try return int instead double to check compiler issue
- drivers/mge-hid.c: add some more debug

### 2.31. 2025-06-24 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/powervar_cx.c: instcmd(): fix int type of ShowTime [#2988]
- drivers/powervar_cx.c, drivers/powervar_cx.h: drivers/powervar_cx*: fix int type of GetSubstringPosition() [#2988]
- drivers/powervar_cx.c, drivers/powervar_cx.h, drivers/powervar_cx_usb.c: drivers/powervar_cx*: fix visibility of some declarations [#2988]
- drivers/powervar_cx.c: prefer snprintf() over strncpy() [#2988]
- drivers/powervar_cx.c, drivers/powervar_cx_ser.c, drivers/powervar_cx_usb.c: drivers/powervar_cx*.c: use same style for space after comma [#2988]
- drivers/powervar_cx.c, drivers/powervar_cx_usb.c: drivers/powervar_cx*.c: use same style for space after "if" [#2988]
- drivers/powervar_cx.c: avoid unbound strcpy() and strcat() [#2988]
- drivers/Makefile.am, drivers/powervar_cx.c, drivers/powervar_cx.h, drivers/powervar_cx_ser.c, drivers/powervar_cx_usb.c: powervar_cx_{ser,usb}: split helper code powervar_cx.{c,h} into a true C header and compiled C source (do not "include" the latter) [#2988]
- NEWS.adoc, docs/man/Makefile.am, docs/man/powervar_cx_ser.txt, docs/man/{powervar-cx.txt ⇒ powervar_cx_usb.txt}, drivers/Makefile.am, drivers/{powervar-cx.h ⇒ powervar_cx.h}, drivers/{powervar-cs.c ⇒ powervar_cx_ser.c}, drivers/{powervar-cu.c ⇒ powervar_cx_usb.c}: powervar_cx_{ser,usb}: rename sources, separate man pages [#2988]
- drivers/powervar-cu.c, drivers/powervar-cx.h: drivers/powervar-c*: avoid sub-standard "uint" type [#2988]
- drivers/powervar-cu.c: SendRequest(): revise nulling of outbuff[], add sanity-checks and comment about them [#2988]
- drivers/powervar-cu.c: fix upsdebugx(verbosity) vs upslogx(facility) [#2988]
- drivers/powervar-cu.c: SendRequest(), PowervarGetResponse(): align int vars with print format and return types [#2988]

### 2.32. 2025-06-24 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- data/cmdvartab, docs/nut-names.txt, drivers/mge-hid.c: rename enable/diasble to start/stop

### 2.33. 2025-06-24 Bill Elliot <bill@wreassoc.com>

- drivers/powervar_cx.c, drivers/powervar_cx.h, drivers/powervar_cx_usb.c: Add comment(s) in source about compiling common driver file. Add FIXME note.

### 2.34. 2025-06-23 Jim Klimov <jimklimov+nut@gmail.com>

- docs/man/powervar-cx.txt: fix NAME section to generate the alias man pages [#2988] NOTE: man aliases are special reference files, so the target powervar-cx.8 file must be delivered wherever *-cs and/or *-cu are the one(s) really needed.

### 2.35. 2025-06-20 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/powervar-cu.c: use NUT standard population of regex_array for USB config parameters [#2988]
- drivers/powervar-cu.c: fix int size mismatch [#2988] Code scanning / CodeQL: Comparison of narrow type with wide type in loop condition: Comparison between [i](1) of type uint8_t and [ReqLen](2) of wider type size_t.
- drivers/powervar-cu.c, drivers/powervar-cx.h: drivers/powervar-c*: fix clang complaints about method visibility/declaration [#2988]
- docs/man/Makefile.am: neuter powervar-c{s,u}.html (similar to other fictional HTML aliases) for now [#2988]
- drivers/powervar-cu.c, drivers/powervar-cx.h: drivers/powervar-c*: slightly revise C markup (indentations, declarations on top) [#2988]
- UPGRADING.adoc: note packaging of powervar-cX man pages [#2988]
- docs/man/Makefile.am: fix recipes to nominally deliver the powervar-c[us] pages, aliased from one powervar-cx [#2988]
- docs/man/powervar-cx.txt: fix asciidoc markup; clarify that there are two powervar* drivers (USB/Serial) at this time [#2988]
- NEWS.adoc: introduced powervar-cs and powervar-cu drivers [#2988]
- data/driver.list.in: update top comment with formatting requirements for markup of this file [#2988]
- data/driver.list.in: parsing scripts expect single-TAB separation of fields [#2988]

### 2.36. 2025-06-19 Jim Klimov <jimklimov+nut@gmail.com>

- docs/Makefile.am: specify VPATH for sub-makes doing spellcheck
- docs/Makefile.am, docs/man/Makefile.am, NEWS.adoc: only SED text source files for *-prepped (man page section, nut-website, etc.) rewrites [#2989]
- clients/upsmon.c: when warning about no SHUTDOWNCMD, check about no MINSUPPLIES too (maybe not a problem)
- scripts/systemd/nutshutdown.in: update notes on purpose, location and likely variations
- conf/upsmon.conf.sample.in: update notes on Windows SHUTDOWNCMD
- conf/upsmon.conf.sample.in: update notes on semi-required settings

### 2.37. 2025-06-16 haul <ulfathasangarayev@gmail.com>

- docs/man/phoenixcontact_modbus.txt, drivers/phoenixcontact_modbus.c: Fix issues from previous PR review

  - Bumped internal version to 0.09 (two-digit format) - Replaced single-line // comments with /* … */ block comments - Added missing variable descriptions to the man page - Preserved original authors in metadata - Standardized config variable names to align with nut-names.txt where possible - Declared all variables at top of scope as per C89 style Feedback originally provided by @jimklimov on PR #2986 (superseded by this commit)

### 2.38. 2025-06-16 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- drivers/mge-hid.c: try again in one func eaton_input_eco_mode_auto_on_off_info()
- drivers/mge-hid.c: Fix value ("1") in nuf
- drivers/mge-hid.c: for test value after compile

### 2.39. 2025-06-15 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- drivers/mge-hid.c: separate on / off as only fisrt command is used in this case

### 2.40. 2025-06-13 haul <haul@tgw-group.com>

- drivers/phoenixcontact_modbus.c: Add support for shutdown variables, mode selector, PC reset timing, and battery switch threshold - Introduced new variables to the phoenixcontact_modbus driver especially for QUINTS 4 USB: - shutdown variables - mode selector 9 = PC_MODE - PC reset delay after main power recovers - automatic switch to battery mode if main power is below or above a defined threshold.

### 2.41. 2025-06-12 Jim Klimov <jimklimov@gmail.com>

- docs/man/nut.txt, docs/man/index.txt: introduce "ifndef::included-skip-title[]" toggle [nut-website#61]

### 2.42. 2025-06-12 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- drivers/mge-hid.c: return on/off
- drivers/mge-hid.c: another typo
- drivers/mge-hid.c: double, small fixes
- drivers/mge-hid.c: convert from two functions to one `eaton_input_eco_mode_auto_on_off_fun/[nuf]()`
- drivers/mge-hid.c: return double (0.0 and 0.1) instead of named double

### 2.43. 2025-06-11 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/apc_modbus.c, NEWS.adoc: bump version, add summary [#2982]
- docs/man/pijuice.txt, docs/nut.dict: some more nuances [#2985]
- lib/libupsclient-config.in: single-quote ConfigFlags value
- lib/libupsclient-config.in: define commonly customized dirs so ConfigFlags do not emit warnings when configure script parses the template
- configure.ac: nut-common-tmpfiles.conf: own PIDPATH as root if not overlapping with unprivileged patgs
- docs/man/pijuice.txt, docs/nut.dict: update with nuances of PiJuice HAT UPS setup from practice
- Makefile.am: install-as-root: fix for new installs with systemd

### 2.44. 2025-06-11 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- drivers/mge-hid.c: double fix
- drivers/mge-hid.c: small fixes
- drivers/mge-hid.c: added dummy and Conversion back of `eaton_input_eco_mode_auto_off[on]_fun()`

### 2.45. 2025-06-10 Hector Martin <marcan@marcan.st>

- drivers/apc_modbus.c: Fix interframe delay The delay is supposed to be from end of a frame to start of the next. Also fix the type used for timestamp calculations (useconds_t is not big enough and overflows). Fixes: #2609

### 2.46. 2025-06-08 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/nutdrv_qx_megatec.c: specify that we accept 38\+ bytes as answer for "I" query, and any length after byte 28 till end of reply is ups.firmware [#2980] Also finally bump the subdriver version for this PR
- NEWS.adoc, UPGRADING.adoc: note the 38 vs 39 byte expected response to "I" in nutdrv_qx::megatec subdriver [#2980]

### 2.47. 2025-06-06 Bill Elliot <bill@wreassoc.com>

- docs/acknowledgements.txt, docs/man/powervar-cx.txt, docs/nut.dict: Text and NUT.dict tweaks to pass distcheck-light

### 2.48. 2025-06-05 Bill Elliot <bill@wreassoc.com>

- docs/man/Makefile.am, docs/man/powervar-cx.txt: Man page fixes. Crossing T’s and dotting I’s.
- docs/acknowledgements.txt: Fix web link in, and add support note to, acknowledgements.txt
- drivers/powervar-cs.c, drivers/powervar-cu.c: Change versions from 0.80 to 1.00 to prepare for release.

### 2.49. 2025-06-04 gksmsk <90905316+gksmsk@users.noreply.github.com>

- drivers/nutdrv_qx_megatec.c: Update nutdrv_qx_megatec.c Added a parameter battery.runtime

### 2.50. 2025-06-04 Jim Klimov <jimklimov+nut@gmail.com>

- configure.ac, docs/configure.txt: suggest a --with-drvpath that is not bindir but rather libexecdir
- NEWS.adoc: Updated `megatec` protocol for more detailed responses to `I` query [#2980]
- drivers/nutdrv_qx_megatec.c: revise comments for "I" query updates
- docs/man/nut.txt: reword coupling of upsmon with upssched
- docs/man/huawei-ups2000.txt: fix title
- docs/man/clone-outlet.txt, docs/man/clone.txt, docs/man/dummy-ups.txt, docs/man/failover.txt, docs/man/nut.txt, docs/man/tripplite_usb.txt: docs/man/*: fix man page section references for upsc/upscmd/upsrw/NUT-Monitor/upsmon/upssched (1 ⇒ 8)

### 2.51. 2025-06-03 Jim Klimov <jimklimov+nut@gmail.com>

- NEWS.adoc, UPGRADING.adoc: report recent documentation/recipe improvements [#2976, #2946]
- docs/nut-versioning.adoc: version-related code moved from common.c to common-nut_version.c [#2913, #2097] …to reduce the rebuild/relink scope.
- docs/man/.gitignore, docs/man/Makefile.am, docs/man/index.txt, docs/nut.dict: docs/man/index.txt, docs/man/Makefile.am, docs/man/.gitignore: report the effect of DOC_INSTALL_SELECTED_MANS_PROGS_BUILT on delivered docs and indexed man pages

### 2.52. 2025-06-02 Jim Klimov <jimklimov+nut@gmail.com>

- docs/man/Makefile.am: linkman-*.txt: depend on Makefile after all (adapt to varying configure choices)
- docs/man/Makefile.am: trace GENERATE-LINKMAN events during build
- docs/man/Makefile.am: actually honour DOC_INSTALL_SELECTED_MANS_BUILTPROGS toggle for linkman*.txt generation [nut-website#60] Probably a lot more can be enhanced later, to also consider this in delivery of HTML MAN page renders, or finer-grained selections for even more optional drivers (nhs_ser on linux), clients (Python UI), development-only tools (like sockdebug), or platform-specific progs (nut.exe), etc.
- Makefile.am, docs/configure.txt, docs/maintainer-guide.txt: suggest or ensure `configure --enable-docs-man-for-progs-built-only=no` for dist/distcheck builds [nut-website#60]
- ci_build.sh: if we end up building and/or installing documentation, do parse all files (even if we do not build some programs here) [nut-website#60]
- configure.ac, docs/configure.txt, docs/nut.dict: configure.ac, docs/configure.txt: convert to use of separate option --enable-docs-man-for-progs-built-only=<yes\|no> [nut-website#60]
- configure.ac, docs/configure.txt: introduce --with-docs=(all=)mans-builtprogs vs. mans-all [nut-website#60]
- docs/man/Makefile.am, docs/man/.gitignore: refactor generation of linkman-*.txt to pick up new driver lists in persistent NUT building workspaces [nut-website#60]
- docs/man/Makefile.am: linkman-*-names.txt: re-generate if the Makefile.am changes [nut-website#60]

### 2.53. 2025-05-30 Jim Klimov <jimklimov+nut@gmail.com>

- ci_build.sh: default-all-errors: report count of SUCCEEDED and FAILED builds
- Makefile.am, NEWS.adoc: check-files-quick: only spellcheck-quick by default if we `configure --enable-spellcheck`
- configure.ac: NUT_REPORT_FEATURE(WITH_SPELLCHECK), not just AM_CONDITIONAL() it quietly
- conf/upsmon.conf.sample.in, docs/man/upsmon.conf.txt, docs/man/usbhid-ups.txt: mention that there are different "POLLFREQ" settings between upsmon and some drivers [#2974]

### 2.54. 2025-05-28 Sebastian Kuttnig <sebastian.kuttnig@gmail.com>

- drivers/failover.c, drivers/failover.h: drivers/failover.{c,h}: make UPS priorities more readable in code
- drivers/failover.c: improve guarding of ups→status against NULL dereference Adds checks to ensure ups→status is not NULL before use, preventing a possible NULL pointer dereference.
- drivers/failover.c, drivers/failover.h: drivers/failover.{c,h}: store runtimes in UPS struct These changes avoid constant lookups in the variable table for better performance.
- drivers/failover.c: minor improvements to order and debug levels
- docs/man/failover.txt, docs/nut.dict: introduce checkruntime argument
- drivers/failover.c, drivers/failover.h: drivers/failover.{c,h}: introduce checkruntime argument
- tests/nut-driver-enumerator-test.sh: reflect recent enumerator changes in test expectations [#2962]
- docs/man/failover.txt, drivers/failover.c, drivers/failover.h: drivers/failover.{c,h}, docs/man/failover.txt: use _sockfn() for one-shot connections This change removes the dependency on splitting socket names into UPS and driver names. We now rely on the user to provide valid sockets: if it connects, it connects. This enables the use of full paths in the port argument also, improving flexibility and enhancing scriptability.

### 2.55. 2025-05-28 Jim Klimov <jimklimov+nut@gmail.com>

- ci_build.sh, NEWS.adoc: default-all-errors: refactor to use of a common BUILDSTODO_LIST with one processing loop
- ci_build.sh: default-all-errors: report why we list e.g. 8 scenarios and plan 7 runs (due to unmapped)
- ci_build.sh: default-all-errors: refactor BUILDSTODO_(SSL|USB\|UNMAPPED) determination as size of bash array, not via expr maths
- ci_build.sh: default-all-errors: first pass conversion of NUT_(USB|SSL\|UNMAPPED)_VARIANTS from strings to bash arrays
- ci_build.sh: default-all-errors: refactor FAILED/SUCCEEDED tracking as bash arrays
- ci_build.sh: default-all-errors: first steps to separate this BUILD_TYPE into "quick" and "exhaustive" variants
- docs/man/nut.txt, docs/man/index.txt: do not reference nut(7) when including the man page index for rendering the page itself [#2945]
- docs/man/nut.txt: rephrase NDE text
- docs/man/nut.txt: fix "notable clients" bullet-list rendering
- docs/man/nut-driver-enumerator.txt: update intro, mention driver-on-drver dependencies [#2962]
- NEWS.adoc: mention NDE change to track inter-driver dependency [#2962]
- NEWS.adoc: revise a few recent fixes

### 2.56. 2025-05-27 Sebastian Kuttnig <sebastian.kuttnig@gmail.com>

- drivers/dummy-ups.c: make upsdrv_cleanup() conditional on actual allocs, not mode
- drivers/dummy-ups.c: free ctx in upsdrv_cleanup() whenever allocated
- drivers/main.c: free temporary buffer in splitxarg()

### 2.57. 2025-05-26 Sebastian Kuttnig <sebastian.kuttnig@gmail.com>

- drivers/failover.c: use str_to_int() also in instcmd()
- drivers/failover.c: make csv_arg_to_array() more reusable
- drivers/failover.c: remove magic -1 from str_arg_to_int(), use INT_MIN/MAX instead
- drivers/failover.c: safer string to numeric conversions, improved argument handling

### 2.58. 2025-05-26 Jim Klimov <jimklimov+nut@gmail.com>

- NEWS.adoc: revise announcement of upsdrvquery API updates [#2969]
- Link to PR, since we already have one shared by the different highlighted achievements * Revise style to be same as in other lists
- scripts/upsdrvsvcctl/nut-driver-enumerator.sh.in: report if other device uses unexpected driver [#2962]
- m4/nut_check_libnss.m4: add Mozilla MPS headers to "-isystem" bunch (CLANG/GCC builds)
- Jenkinsfile-dynamatrix: use same naming style (no parenthesis around C/C+\+ std version)
- docs/man/netxml-ups.txt, docs/man/snmp-ups.txt: fix title casing
- docs/man/skel.txt, docs/man/tripplite_usb.txt, docs/man/ups.conf.txt, docs/security.txt: docs/*: fix remaining links to man pages of external tools
- docs/man/bestups.txt, docs/man/upsd.txt, docs/man/upsmon.txt, docs/man/upssched.conf.txt, docs/man/upsset.cgi.txt: docs/man/*.txt: fix linkman references to conf-file man pages (default section 5 not 8)
- docs/man/nut.txt, docs/man/upsmon.conf.txt, docs/man/upsmon.txt, docs/nut.dict: Update upsmon(.conf) pages regarding SHUTDOWNCMD and root [#2970] Closes: #2970
- docs/documentation.txt: refer to docs/man/nut.html from rendered docs [#2950]
- docs/man/Makefile.am: fix publication of nut.html on nut-website [#2950]
- docs/man/index.txt: publish nut(7) [#2950]

### 2.59. 2025-05-24 Sebastian Kuttnig <sebastian.kuttnig@gmail.com>

- drivers/upsdrvquery.c: drop redundant parentheses [#2963]
- drivers/upsdrvquery.c: consistent guarding of _read_timeout() ret cast [#2963] The value of ret never exceeds the size of conn→buf, which is defined as LARGEBUF. However, defensive guarding against exceeding the buffer size was already in place for upsdebug_hex(), so make upsdebugx() call consistent with it.
- drivers/upsdrvquery.c: cast _read_timeout() ret directly to int [#2963] The value of ret never exceeds the size of conn→buf, which is defined as LARGEBUF. A direct cast to int is safe in this context and avoids tautological comparison warnings on some platforms.
- drivers/upsdrvquery.c: make _restore_broadcast() return values consistent with _prepare() A caller does not know about the underlying _write() call and should not care about the number of bytes written. Return -1 or 1 consistently, as already done the same in _prepare().
- NEWS.adoc: announce upsdrvquery API updates
- drivers/upsdrvquery.c, drivers/upsdrvquery.h: drivers/upsdrvquery.{c,h}: add _restore_broadcast(), call after _oneshot_conn() (best-effort) The _oneshot_conn() function does not own the connection, so it should make a best-effort attempt to restore the connection chatter (re-enabling broadcast) before returning. This ensures the caller receives the connection back in a reasonably consistent state.
- drivers/upsdrvquery.c: revise ownership of connections in _prepare and _request
- docs/man/failover.txt: fix incompatible characters
- drivers/Makefile.am: add failover.h for dists

### 2.60. 2025-05-23 Sebastian Kuttnig <sebastian.kuttnig@gmail.com>

- drivers/upsdrvquery.c, drivers/upsdrvquery.h: drivers/upsdrvquery.{c,h}: revise ownership and freeing of one-shot connections
- drivers/upsdrvquery.c, drivers/upsdrvquery.h: drivers/upsdrvquery.{c,h}: new oneshot functions, refactor existing without breaking API
- NEWS.adoc, docs/nut.dict: introduce upsdrvquery changes
- docs/man/failover.txt: add 3rd party tool use case for rationale
- docs/man/failover.txt: add limitations
- docs/man/failover.txt: add note to factor in network or lock-picking delays for inittime
- docs/man/failover.txt: make hyphens consistent
- drivers/failover.c: remove progname from non fatal log message
- docs/man/failover.txt: polish documentation and add rationale
- drivers/failover.c: safeguard ups_promote_primary against NULL or double promotion
- drivers/failover.c: show truncation content at end of log message
- drivers/failover.c: remove redundant _init() calls for status/alarm
- drivers/failover.c: do not fatalx on no connectable drivers, keep trying instead
- drivers/failover.c, drivers/failover.h: drivers/failover.{c,h}: introduce failover.h for defines, typedefs
- drivers/failover.c: use enum for priorities
- drivers/failover.c: use NUT_STRARG helper for null checks in various places

### 2.61. 2025-05-23 Jim Klimov <jimklimov+nut@gmail.com>

- docs/config-notes.txt: fix reference to Augeas chapter in developer-guide [#2968]
- docs/man/nut_usb_addvars.txt: clarify the optionality and dangers of bus/busport/device settings [#2447]

### 2.62. 2025-05-22 Sebastian Kuttnig <sebastian.kuttnig@gmail.com>

- drivers/failover.c: reword shutdown to be more clear

### 2.63. 2025-05-22 Jim Klimov <jimklimov+nut@gmail.com>

- scripts/upsdrvsvcctl/nut-driver-enumerator.sh.in: add support for "drivers=…" media type for dependencies, and failover driver using that [#2962]
- docs/nut.dict: add "resizing"
- Jenkinsfile-dynamatrix: extend "GNU C89/C\+\+98 … with GCC" (BUILD_WARNFATAL=yes BUILD_WARNOPT=auto) to also cover Strict C in all CI runs Note: this differs from "Strict ANSI C" builds done in fightwarn branches, those try "minimal" and "hard" BUILD_WARNOPT types.
- Jenkinsfile-dynamatrix: "GNU C99+/C++11+" and "GNU C89/C\+\+98 … with GCC" should nowadays be BUILD_WARNFATAL=yes when BUILD_WARNOPT=auto
- Jenkinsfile-dynamatrix: "A build with all driver types…for other C/C+\+ revisions" - disable C99/C\+\+98 checked as main revision
- Jenkinsfile-dynamatrix: update build scenario names to reflect warnings levels and standard versions
- tools/nut-scanner/nut-scanner.c, drivers/mge-hid.c, drivers/hwmon_ina219.c: fix source markup to remain compatible with C89 syntax
- NEWS.adoc: document fixes for adaptive varargs sizing [#2963]
- common/common.c: fix typo in comment

### 2.64. 2025-05-22 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- drivers/mge-hid.c: upsdebugx in bypass and ecomode functions updated with %s: and func for easy debug later

### 2.65. 2025-05-20 Sebastian Kuttnig <sebastian.kuttnig@gmail.com>

- drivers/upsdrvquery.c: safer comparison for printable_len [#2963]
- include/common.h: do not assume va_copy() to be a macro on all systems [#2963]
- configure.ac: more portable va_copy() checks [#2963]
- common/common.c: fix comment [#2963]
- drivers/upsdrvquery.c: fix comment [#2963]
- drivers/upsdrvquery.c: revise signed/unsigned comparison, account for ret < 0 [#2963]
- common/common.c: condense declarations and comments for va_copy() [#2963]
- common/common.c, configure.ac, include/common.h: configure.ac, common/common.{c,h}: define va_copy with __va_copy where needed/available [#2963]
- drivers/upsdrvquery.c: fix assumption about ret [#2963]
- drivers/upsdrvquery.c: account for non-null-terminated buffers [#2948]
- common/common.c: only upsize buffer in vupslog() if va copying is supported [#2948]
- configure.ac: test for va_copy and __va_copy

### 2.66. 2025-05-19 Sebastian Kuttnig <sebastian.kuttnig@gmail.com>

- drivers/failover.c: make defensive freeing consistent throughout the file
- drivers/failover.c: preserve which port value failed the argument parsing process
- drivers/failover.c: clean dstate after fsdmode 0, remove now freed var from exit debug
- drivers/failover.c: free parse_port_argument() tmp on premature exit [#2962]
- drivers/failover.c: add shutdown non-handling
- drivers/failover.c, NEWS.adoc: fixes for compiler warnings, add PR number to news entry [#2962]
- NEWS.adoc: introduce failover driver
- server/netget.c: rewrite upstream prefix for proxying drivers
- docs/man/Makefile.am, docs/man/failover.txt, docs/nut.dict, drivers/Makefile.am, drivers/failover.c: drivers/, docs/: introduce failover driver

### 2.67. 2025-05-18 Jim Klimov <jimklimov+nut@gmail.com>

- Makefile.am: EXTRA_DIST ci_build.sh along with ci_build.adoc
- Makefile.am: Revert "Makefile.am: as long as we do not tarball ci_build.sh, do not deliver its doc either" This reverts commit 7a2e5d771c57f5768ced35e5d2994ed9f214a491: the doc is part of qa-guide. Makes more sense to also dist the script instead.

### 2.68. 2025-05-16 Jim Klimov <jimklimov+nut@gmail.com>

- m4/ax_c_pragmas.m4: AX_C_PRINTF_STRING_NULL: detect also if gcc/clang would refuse printf("%s",NULL) if warnings are enabled (so NUT_STRARG must be enabled if auto)
- Makefile.am: as long as we do not tarball ci_build.sh, do not deliver its doc either
- ci_build.sh: default-all-errors: if CI_FAILFAST is triggered in SSL/USB loops, do not go for NUT_UNMAPPED_VARIANT either
- drivers/dstate.c: sock_fail(): suggest more ways to "ps\|grep" [#2959]

### 2.69. 2025-05-16 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- data/cmdvartab, docs/nut-names.txt, drivers/mge-hid.c: rename to `experimental.bypass.ecomode.start[stop]` from `experimental.ecomode.start[stop].auto`

### 2.70. 2025-05-15 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/solis.c: cast NULL as "char*" when sending it to print
- drivers/dstate.c, NEWS.adoc: sock_fail(): suggest things to try if a (maybe non-socket) filesystem object already exists
- drivers/dstate.c: sock_fail(): limit the impact of failed getpwuid() when reporting the problem
- NEWS.adoc, drivers/adelsystem_cbi.c, drivers/al175.c, drivers/apc_modbus.c, drivers/apcsmart-old.c, drivers/apcsmart.c, drivers/bcmxcp.c, drivers/belkin.c, drivers/belkinunv.c, drivers/bestfcom.c, drivers/bestfortress.c, drivers/bestuferrups.c, drivers/bestups.c, drivers/bicker_ser.c, drivers/blazer.c, drivers/clone.c, drivers/dummy-ups.c, drivers/etapro.c, drivers/everups.c, drivers/gamatronic.c, drivers/generic_modbus.c, drivers/huawei-ups2000.c, drivers/isbmex.c, drivers/liebert-esp2.c, drivers/liebert-gxe.c, drivers/macosx-ups.c, drivers/main.c, drivers/masterguard.c, drivers/metasys.c, drivers/mge-utalk.c, drivers/microdowell.c, drivers/microsol-common.c, drivers/netxml-ups.c, drivers/nut-ipmipsu.c, drivers/nutdrv_atcl_usb.c, drivers/nutdrv_hashx.c, drivers/nutdrv_qx.c, drivers/nutdrv_qx_voltronic.c, drivers/nutdrv_siemens_sitop.c, drivers/oneac.c, drivers/optiups.c, drivers/pijuice.c, drivers/powercom.c, drivers/powerman-pdu.c, drivers/powerp-bin.c, drivers/powerp-txt.c, drivers/rhino.c, drivers/richcomm_usb.c, drivers/riello_ser.c, drivers/riello_usb.c, drivers/safenet.c, drivers/skel.c, drivers/sms_ser.c, drivers/snmp-ups.c, drivers/solis.c, drivers/tripplite.c, drivers/tripplite_usb.c, drivers/tripplitesu.c, drivers/upscode2.c, drivers/usbhid-ups.c, drivers/victronups.c: drivers/.c, NEWS.adoc: revise logging of instcmd() where upslog_INSTCMD_POWERSTATE() macros shine
- drivers/upshandler.h: introduce upslog_INSTCMD_POWERSTATE*() macros and LOG_INSTCMD_POWERSTATE level
- clients/upsclient.c: avoid using upslog*() methods with numeric log level instead of a syslog macro
- drivers/powerman-pdu.c, drivers/snmp-ups.c, drivers/tripplite_usb.c, drivers/usbhid-ups.c, drivers/ve-direct.c: drivers/: avoid using upslog() methods with numeric log level instead of a syslog macro
- drivers/dummy-ups.c: setvar(): update a FIXME comment

### 2.71. 2025-05-14 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/adelsystem_cbi.c, drivers/al175.c, drivers/apc_modbus.c, drivers/apcsmart-old.c, drivers/apcsmart.c, drivers/bcmxcp.c, drivers/belkin.c, drivers/belkinunv.c, drivers/bestfcom.c, drivers/bestfortress.c, drivers/bestuferrups.c, drivers/bestups.c, drivers/bicker_ser.c, drivers/blazer.c, drivers/blazer_ser.c, drivers/blazer_usb.c, drivers/clone.c, drivers/dstate.c, drivers/dummy-ups.c, drivers/etapro.c, drivers/everups.c, drivers/gamatronic.c, drivers/generic_modbus.c, drivers/huawei-ups2000.c, drivers/isbmex.c, drivers/ivtscd.c, drivers/liebert-esp2.c, drivers/liebert-gxe.c, drivers/macosx-ups.c, drivers/main.c, drivers/masterguard.c, drivers/metasys.c, drivers/mge-utalk.c, drivers/microdowell.c, drivers/microsol-common.c, drivers/netxml-ups.c, drivers/nut-ipmipsu.c, drivers/nutdrv_atcl_usb.c, drivers/nutdrv_hashx.c, drivers/nutdrv_qx.c, drivers/nutdrv_qx_blazer-common.c, drivers/nutdrv_siemens_sitop.c, drivers/oneac.c, drivers/optiups.c, drivers/pijuice.c, drivers/powercom.c, drivers/powerman-pdu.c, drivers/powerp-bin.c, drivers/powerp-txt.c, drivers/rhino.c, drivers/richcomm_usb.c, drivers/riello_ser.c, drivers/riello_usb.c, drivers/safenet.c, drivers/skel.c, drivers/sms_ser.c, drivers/snmp-ups.c, drivers/solis.c, drivers/tripplite.c, drivers/tripplite_usb.c, drivers/tripplitesu.c, drivers/upscode2.c, drivers/usbhid-ups.c, drivers/ve-direct.c, drivers/victronups.c: drivers/*.c: revise logging of instcmd() and setvar() or their equivalents to be consistent across all drivers [WIP]
- drivers/dummy-ups.c: instcmd(), setvar(): test conversion to new logging macros Testing: :; NUT_STATEPATH=/tmp ./drivers/dummy-ups -DDDDDD -s test -x port= & :; (echo NOBROADCAST ; echo "INSTCMD qqq" ; sleep 3 ; echo "INSTCMD qqq arg" ; sleep 3 ; echo "SET qqq" ; sleep 3 ; echo "SET qqq 123" ; sleep 10; ) \| ./server/sockdebug /tmp/dummy-ups-test Outputs: 8.003940 [D6] sock_arg: Driver on /tmp/dummy-ups-test is now handling INSTCMD with 2 args 8.003974 [D2] entering main_instcmd(qqq, (null)) for [test] on socket 5 8.003982 [D2] shared main_instcmd() does not handle command qqq, proceeding to driver-specific handler 8.004017 [D1] Starting dummy-ups.c::instcmd(qqq, (null)) 8.004049 instcmd: unknown command [qqq] [(null)] 8.004059 [D6] sock_arg: Driver on /tmp/dummy-ups-test is now handling INSTCMD with 3 args 8.004068 [D2] entering main_instcmd(qqq, arg) for [test] on socket 5 8.004075 [D2] shared main_instcmd() does not handle command qqq, proceeding to driver-specific handler 8.004080 [D1] Starting dummy-ups.c::instcmd(qqq, arg) 8.004086 instcmd: unknown command [qqq] [arg] (apparently the two got coalesced by delay between main.c loops) 11.504627 [D6] sock_arg: Driver on /tmp/dummy-ups-test is now handling SET with 2 args 11.504669 Unknown command on socket: 11.504675 arg 0: SET 11.504678 arg 1: qqq (SET must have an argument) 14.004807 [D6] sock_arg: Driver on /tmp/dummy-ups-test is now handling SET with 3 args 14.004856 [D2] entering main_setvar(qqq, 123) for [test] on socket 5 14.004867 [D2] shared main_setvar() does not handle variable qqq, proceeding to driver-specific handler 14.004874 [D1] Starting dummy-ups.c::setvar(qqq, 123) 14.004930 [D2] find_info: unknown variable: qqq 14.004979 [D1] Unknown data. Committing anyway… 14.004992 [D2] find_info: unknown variable: qqq 14.004997 [D1] Unknown data. Committing value anyway… 14.005062 [D5] send_to_all: SETINFO qqq "123" 14.005113 [D2] find_info: unknown variable: qqq 14.005125 [D2] setvar: unknown variable (qqq), using default flags 14.005133 [D5] send_to_all: SETFLAGS qqq RW STRING 14.005144 [D5] send_to_all: SETAUX qqq 32
- drivers/upshandler.h, NEWS.adoc: introduce macros for common syslog level definitions and message wording for beginning and failing instcmd() or setvar() consistently in different drivers
- drivers/mge-utalk.c: setvar(): return STAT_SET_HANDLED when due
- drivers/oneac.c: instcmd(): use consistent method argument markup (spaces)
- NEWS.adoc, drivers/usbhid-ups.c, drivers/usbhid-ups.h: drivers/usbhid-ups.{c,h}, NEWS.adoc: rename HU_FLAG_CMD_PARAM_REQUIRED ⇒ HU_FLAG_PARAM_REQUIRED and extend to setvar() too [#2955, #2860]

### 2.72. 2025-05-14 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- data/cmdvartab, docs/nut-names.txt, drivers/mge-hid.c: added cmd "experimental.ecomode.start.auto" "experimental.ecomode.stop.auto"

### 2.73. 2025-05-13 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/usbhid-ups.h, drivers/usbhid-ups.c, NEWS.adoc, docs/nut.dict: introduce HU_FLAG_CMD_PARAM_REQUIRED and a HU_TYPE_CMD_PARAM_REQUIRED shortcut for setting in the mapping tables Complete the feature started in commit 7991e4592e042f16f5e0757083f0fd58503e8a5e which became a regression of NUT v2.8.3 [#2860].
- drivers/usbhid-ups.c: drop EOL from single-line upsdebugx() reports
- drivers/usbhid-ups.h: bump ©
- drivers/usbhid-ups.h: revise comment markup

### 2.74. 2025-05-12 penghong <penghong20000102@163.com>

- data/driver.list.in: Added some descriptions of UPS equipment.

### 2.75. 2025-05-12 Jim Klimov <jimklimov+nut@gmail.com>

- tools/driver-list-format.sh: refactor VALID_LINE definition [#2953]
- tools/driver-list-format.sh, data/Makefile.am: recognize caller-provided srcdir or builddir; use the latter for output files; include "/data" part inside DRVLIST_PATH
- data/driver.list.in: fix markup of older entries
- tools/driver-list-format.sh: document the updated purpose, add copyrights
- tools/driver-list-format.sh: do not replace original file if it is same (do not confuse "make" and mess up archive timestamps)
- tools/driver-list-format.sh: fix also separators made of more than one TAB or a mix of TABs and spaces
- tools/driver-list-format.sh: verify that lines are either empty, all-comments, or have six fields (and optional comment)
- tools/driver-list-format.sh: prefix lines with script name to help see it in "make" log; revise message in case something "needs to be fixed"
- tools/driver-list-format.sh: TAB-separate the optional trailing comment from the last required field
- tools/driver-list-format.sh: rearrange the logic as a chain for better maintenance; use single-quotes around regex with a dollar
- tools/driver-list-format.sh: document the SED logic
- data/Makefile.am, data/.gitignore: take care of driver.list{,.in}.tabbed files if they are left over
- Makefile.am, data/Makefile.am, tools/driver-list-format.sh, tools/Makefile.am: add a check (not change) mode for driver.list markup [#2952]
- docs/man/Makefile.am, docs/man/apc_modbus.txt, docs/man/generic_modbus.txt, docs/man/networked_hostnames.txt, docs/man/netxml-ups.txt, docs/man/nut-ipmipsu.txt, docs/man/powerman-pdu.txt, docs/man/snmp-ups.txt: Introduce docs/man/networked_hostnames.txt caveat, include it into networked driver man pages

### 2.76. 2025-05-12 Jim Klimov <jim@jimklimov.com>

- docs/man/blazer_ser.txt, docs/man/blazer_usb.txt: inject a dummy "linkman" for .txt-prepped rewriter to patch up the man section [#2950]
- docs/man/nut.txt: elaborate more on "File or directory not found" messages, permissions, config files and nut-scanner
- docs/man/nut.txt: point to NUT Configuration Examples book

### 2.77. 2025-05-11 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/dstate.c, tests/driver_methods_utest.c: check that LB can be set and status set\+commit+set+commit (without init in the middle) adds reported tokens [#2934]

### 2.78. 2025-05-11 Jim Klimov <jim@jimklimov.com>

- docs/configure.txt: note that "datadir" for NUT must include the "/nut" part
- NEWS.adoc, UPGRADING.adoc, configure.ac, docs/configure.txt, docs/man/Makefile.am: configure.ac, docs/configure.txt, docs/man/Makefile.am: introduce "configure --with-docs-man-dir-as-base"
- …/python/app/locale/fr/LC_MESSAGES/NUT-Monitor.mo, …/python/app/locale/it/LC_MESSAGES/NUT-Monitor.mo, …/python/app/locale/ru/LC_MESSAGES/NUT-Monitor.mo: scripts/python/app/locale/*/LC_MESSAGES/NUT-Monitor.mo: update after Qt6 bump [#2946]
- docs/man/nut.txt, docs/nut.dict: docs/man/nut.txt: add a chapter on NUT Run-time Nuances
- configure.ac, docs/configure.txt, docs/man/Makefile.am: configure.ac: auto-tune man page sections by platform (Solaris/illumos, and everyone else)
- configure.ac: line-break test for strdup()

### 2.79. 2025-05-11 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- data/cmdvartab, docs/nut-names.txt, drivers/mge-hid.c: remove experimental.ecomode.[start/stop].auto var/cmd funtions for working in another pr and clean this pr

### 2.80. 2025-05-10 Jim Klimov <jimklimov+nut@gmail.com>

- NEWS.adoc, drivers/dstate.c, tests/driver_methods_utest.c: Update asciidoc and C markup, and © headings [#2934]

### 2.81. 2025-05-10 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- drivers/mge-hid.c: removed unused vars
- drivers/mge-hid.c: experimental.ecomode.stop/start.auto added as commands for test after compiled
- drivers/mge-hid.c: input.bypass.switch.on", "disabled (useless, onlly on,off can be runned) to "input.bypass.switch.off", "off" ,aded function of eaton_input_bypass_check_range(value); , eaton_input_eco_mode_check_range(value);

### 2.82. 2025-05-09 Jim Klimov <jimklimov+nut@gmail.com>

- docs/man/usbhid-ups.txt, NEWS.adoc, UPGRADING.adoc: revise whitespace/markup [#2944]

### 2.83. 2025-05-09 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- drivers/mge-hid.c: change place of 0-1 in eaton_input_eco_mode_auto_on_off_info()
- data/cmdvartab, docs/nut-names.txt, drivers/mge-hid.c: experimental.ecomode.[start/stop] to experimental.ecomode.auto

### 2.84. 2025-05-08 Sebastian Kuttnig <sebastian.kuttnig@gmail.com>

- NEWS.adoc: introduce NUT-Monitor-py3qt6
- docs/man/Makefile.am: introduce NUT-Monitor-py3qt6
- configure.ac: handle both py3qt5 and py3qt6 or either
- docs/configure.txt, docs/man/NUT-Monitor.txt, docs/new-clients.txt, docs/nut.dict: docs/*: introduce NUT-Monitor-py3qt6
- scripts/python/Makefile.am, scripts/python/app/NUT-Monitor: handle PyQt5 and PyQt6
- scripts/python/README.adoc, scripts/python/app/NUT-Monitor-py3qt6.in, scripts/python/app/README.adoc, scripts/python/app/nut-monitor-py3qt6.desktop: scripts/python/app/*: introduce Py3Qt6 port for NUT Monitor
- scripts/python/app/.gitignore, scripts/python/app/locale/NUT-Monitor.pot, scripts/python/app/locale/fr/fr.po, scripts/python/app/locale/it/it.po, scripts/python/app/locale/ru/ru.po, scripts/python/app/ui/aboutdialog1.ui, scripts/python/app/ui/gui-1.3.glade, scripts/python/app/ui/gui-1.3.glade.h: scripts/python/app/*: bump structure, version for Qt6

### 2.85. 2025-05-08 Jim Klimov <jimklimov+nut@gmail.com>

- docs/config-prereqs.txt: update for Python3 \+ Qt6 since 2025 distros [#2946]
- scripts/python/app/NUT-Monitor-py3qt6.in: fix exec bit and whitespace alignment [#2946]
- NEWS.adoc, UPGRADING.adoc: document introducing the text for a way to "man nut" [#2945]
- docs/man/index.txt, docs/man/nut.txt, docs/nut.dict: docs/man/nut.txt, docs/man/index.txt: revise inclusion of index into "man nut" and restore the "Platform Management" sub-sectioning
- docs/man/index.txt: drop colons from section names
- docs/man/index.txt: add placeholder sections for more Platform Management types (to be documented)
- docs/man/index.txt: avoid deep section title layers
- docs/maintainer-guide.txt: no need to edit any files to publish a NUT for Windows build artifact
- docs/download.txt: add a link for NUT for Windows artifact
- docs/maintainer-guide.txt: update with AppVeyor CI artifact publication (NUT for Windows)

### 2.86. 2025-05-08 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- drivers/mge-hid.c: experimental.ecomode.[start/stop].auto move to uprw \+ set NULL to last argument for bypass and ecomode cmds

### 2.87. 2025-05-07 invario <67800603+invario@users.noreply.github.com>

- docs/nut.dict: Updated nut.dict after spellcheck
- NEWS.adoc, UPGRADING.adoc, data/driver.list.in, docs/man/usbhid-ups.txt, drivers/usbhid-ups.c: Update adds APC BVKnnnnM2 to list of devices being affected by spurious LB/RB issues and allows users to apply corresponding tweaks

### 2.88. 2025-05-07 Jim Klimov <jimklimov+nut@gmail.com>

- docs/man/Makefile.am, docs/man/nut.txt, docs/nut.dict: introduce a way to "man nut"
- NEWS.adoc, UPGRADING.adoc, configure.ac, docs/Makefile.am, docs/configure.txt, docs/man/Makefile.am: configure.ac, docs/Makefile.am, docs/man/Makefile.am etc.: introduce support for MAN_SECTION_MISC
- docs/Makefile.am: ChangeLog.html-contentchecked: entry_filter(): refactor the regex for special-char escaping for pure(r)-POSIX portability [#2940]
- NEWS.adoc: rephrase innovart31 protocol support in nutdrv_qx [#2938]

### 2.89. 2025-05-06 Jim Klimov <jimklimov+nut@gmail.com>

- NEWS.adoc: announce nutdrv_hashx driver [#2940]
- docs/Makefile.am: ChangeLog.html-contentchecked: entry_filter(): escape some content characters that are special for regex later [#2940]
- docs/Makefile.am: ChangeLog.html-contentchecked: refactor with a common entry_filter()
- drivers/nutdrv_hashx.c: fix status_bytes_size printing [#2940]
- data/driver.list.in: fix markup: TAB before optional comment
- NEWS.adoc: announce new innovart33 protocol support in nutdrv_qx [#2938]

### 2.90. 2025-05-05 Marco Trevisan (Treviño) <mail@3v1n0.net>

- docs/nut-names.txt, drivers/nutdrv_hashx.c: drivers/nutdrv_hashx: Add Implement start / stop beeper test
- data/cmdvartab, docs/nut-names.txt: data/nut-names: Add experimental commands to test the UPS beeper/buzzer Various UPS have this command to test the hardware beep, but NUT is not providing the command. I feel this could be not experimental, but let’s make it as such for now since we only need for one driver AFAIK
- data/driver.list.in: data/drivers.list: Mention other UPS that nutdrv_hashx should support Update the drivers list based on what the official websites of the producers say, as these all are expected to work with PowerManager\+, and so they should also work with nitdrv_hashx
- drivers/nutdrv_hashx.c: drivers/nutdrv_hashx: Add support for running instant actions Support running commands for instant actions so that it’s possible to interactively run them from NUT too
- drivers/skel.c: drivers/skel: Fix reference to nut-names doc file

### 2.91. 2025-05-04 desertwitch <24509509+desertwitch@users.noreply.github.com>

- drivers/clone.c: refactor core driver logic, minor fixes around previous work [#2936]

### 2.92. 2025-05-04 Viktor Drobot <linux776@gmail.com>

- docs/man/nutdrv_qx.txt, docs/nutdrv_qx-subdrivers.txt, drivers/Makefile.am, drivers/nutdrv_qx.c, drivers/nutdrv_qx_blazer-common.c, drivers/nutdrv_qx_blazer-common.h, drivers/nutdrv_qx_innovart33.c, drivers/nutdrv_qx_innovart33.h: Add support (experimental) for Ippon Innova RT 3/3

### 2.93. 2025-05-04 Marco Trevisan (Treviño) <mail@3v1n0.net>

- AUTHORS, data/driver.list.in, docs/man/Makefile.am, docs/man/nutdrv_hashx.txt, docs/nut.dict, drivers/Makefile.am, drivers/nutdrv_hashx.c: drivers/nutdrv_hashx: Add new driver for PowerManager\+ supported devices Add an initial driver for the "*" protocol support that is used by many UPS out there that rely on the proprietary software suites PowerMaster\+, PowerMaster, PowerGuide and so on… The naming of the driver has been chosen since all the UPS replies start with an "", while there’s not a definitive common pattern for the queries or commands. Apparently the same protocol is used by various UPS devices, both online and line-interactive (given that many producers advertise to use the said programs), and only in serial mode (AFAIK). Although this driver has solely been tested with the Atlantis Land S1200 line-interactive UPS. So there may be missing features (such as the bypass mode) or lack of information. However most of the decoding has been done and the driver is enough to update the UPS status for monitoring and shutdown purposes. As for now, only the status updates features have been implemented. Closes: #2769

### 2.94. 2025-05-03 desertwitch <24509509+desertwitch@users.noreply.github.com>

- drivers/clone.c: reduce redundant argument parsing, debug messages [#2936]
- drivers/clone.c: further improve outlet status detection, debug messages [#2936]
- drivers/clone.c: revise outlet status logic, raise OFF for turned-off outlets No longer evaluate outlet status in instant command handling, but rather in the main update cycle. Raising OFF for a turned-off outlet aligns with the behavior of the clone-outlet driver.
- drivers/clone-outlet.c: fix whitespace [#2936]
- NEWS.adoc, drivers/clone-outlet.c, drivers/clone.c: drivers/clone{,-outlet}.c, NEWS.adoc: modernize status handling
- NEWS.adoc: fill in pull request numbers for recent changes
- NEWS.adoc: add nhs_ser, nutdrv_qx_ablerex modern alarm and status handling changes
- drivers/nutdrv_qx_ablerex.c: modernize alarm handling
- drivers/dummy-ups.c, docs/man/dummy-ups.txt, NEWS.adoc: introduce ALARM instruction for dummy modes

### 2.95. 2025-05-01 desertwitch <24509509+desertwitch@users.noreply.github.com>

- drivers/nhs_ser.c: modernize status and alarm handling
- AUTHORS, docs/nut.dict: add desertwitch
- tests/driver_methods_utest.c, NEWS.adoc: bump subdriver version, announce dstate changes
- docs/developers.txt: fix typo [#2932]

### 2.96. 2025-04-30 desertwitch <24509509+desertwitch@users.noreply.github.com>

- drivers/dstate.c: do not add whitespace on lone alarm [#2931]
- tests/driver_methods_utest.c: adapt for legacy and modern alarms [#2931]
- clients/upsmon.c: clarifications and beautifications for legacy alarms [#2931]
- drivers/dstate.c: keep legacy alarms unchanged, do not decouple from status [#2931]
- docs/new-drivers.txt: clarify alarm state handling

### 2.97. 2025-04-30 Jim Klimov <jimklimov+nut@gmail.com>

- docs/config-prereqs.txt, docs/nut.dict: generalize the title/intro for chapter on APT-based Debian-derived Linux systems [#2923]
- NEWS.adoc: clarify "driver updates" in section title
- docs/man/nutdrv_qx.txt: typo fix (extra spaces)
- ci_build.sh: add NUT_UNMAPPED_VARIANTS to BUILD_TYPE="default-all-errors" matrix
- ci_build.sh: revise default stance towards WITH_UNMAPPED_DATAPOINTS values

### 2.98. 2025-04-29 Jim Klimov <jimklimov+nut@gmail.com>

- docs/Makefile.am: .adoc-parsed generator: rewrite "\+" in URLs to "%2B" [#1407] Help with ChangeLog entry for an old URL buried in commit message years ago, from a branch getting merged just now.
- docs/nut.dict: teach all systems that "inverters" is also a word [#1407]
- tests/Makefile.am: restructure and comment cppunittest_LDADD and cppnit_LDADD [#2744] One positive result of experiments in PR #2744 which otherwise did not lead far, yet…
- docs/Makefile.am: .adoc-parsed generator: rewrite "\+" in URLs to "%2B" [#1407] Help with ChangeLog entry for an old URL buried in commit message years ago, from a branch getting merged just now.
- NEWS.adoc: URL-encode the plus character in GitHub URL (branch name part) [#1407]
- NEWS.adoc: document the fix of failed `configure --with-drivers=dummy-ups` scenario [#2927]
- configure.ac: get_drivers_makefile_value(): recurse to expand make variables in discovered values [#2927]
- configure.ac: rename get_drvlist() ⇒ get_drivers_makefile_value() [#2927]
- configure.ac: get_drvlist(): do not forget dollar chars; do drop $(EXEEXT) though [#2927]
- configure.ac: get_drvlist(): trim multiple repetitive SPACES per combined line into one space each [#2927]
- configure.ac: get_drvlist(): quick-return from the loop after we finish reading the assignment (may be multi-line) [#2927]
- docs/nut.dict: teach all systems that "inverters" is also a word [#1407]

### 2.99. 2025-04-28 Jim Klimov <jimklimov+nut@gmail.com>

- docs/nut.dict: teach all systems that "photovoltaic" is a word [#1407]
- drivers/nutdrv_qx_ablerex.c, drivers/nutdrv_qx_ablerex.h, drivers/powervar-hid.h: drivers/nutdrv_qx_ablerex.{c,h}, drivers/powervar-hid.h: fix POSIX attrs in git
- docs/nutdrv_qx-subdrivers.txt: clarify how the "protocol" names are determined
- docs/nut.dict: teach all systems that "photovoltaic" is a word [#1407]
- drivers/nutdrv_qx_voltronic-axpert.c: voltronic_sunny_fault(): use alarm[LARGEBUF] so that item→value[SMALLBUF] can fit with added markup [#1407] …not that we expect problems with this, but compiler warns they are feasible: error: %s directive output may be truncated writing up to 511 bytes into a region of size 497 [-Werror=format-truncation=]
- drivers/nutdrv_qx_voltronic-axpert.c: use double-TABs with TESTING_AXPERT* macro definitions for better visibility [#1407]
- drivers/nutdrv_qx_voltronic-axpert.c: suggest how to timker with TESTING_AXPERT* macros [#1407]
- docs/man/nutdrv_qx.txt, docs/nut.dict: add voltronic-axpert info [#1407]
- drivers/nutdrv_qx_ablerex.c, drivers/nutdrv_qx_ablerex.h, drivers/powervar-hid.h: drivers/nutdrv_qx_ablerex.{c,h}, drivers/powervar-hid.h: fix POSIX attrs in git
- docs/nutdrv_qx-subdrivers.txt: clarify how the "protocol" names are determined
- configure.ac, scripts/Windows/dllldd.sh: use question mark in grep regex, that seems to work everywhere and suits the purpose better [#2920]

### 2.100. 2025-04-27 Jim Klimov <jimklimov+nut@gmail.com>

- docs/man/victronups.txt: fix a few typos
- docs/man/ve-direct.txt: fix man page markup to NUT v2.8.3 patterns, fix a few typos [#440]
- docs/daisychain.txt: docs/daisychain.txt" fix typo (duplicate "the the")
- configure.ac: quieter grep for unbuildable doc formats
- configure.ac: clarify why unbuildable doc formats are just warnings initially
- configure.ac, NEWS.adoc: fix regression of `configure --with-docs=all` released with NUT v2.8.3 Fallout of #2842, used wrong variable name for checking the requested list of doc types
- configure.ac: fix indentation
- configure.ac: make use of NUT_REPORT_FEATURE() arg #6 to produce saner message wording
- m4/nut_report_feature.m4: NUT_REPORT_FEATURE: allow other prefixes than "whether to"
- configure.ac: NUT_REPORT_FEATURE("requested to build and install documentation") to also report the decided nut_doc_build_list of specific required formats
- configure.ac: use better portable regex syntax
- scripts/Windows/dllldd.sh: use better portable regex syntax
- tools/gitlog2version.sh: use better portable regex syntax

### 2.101. 2025-04-26 desertwitch <24509509+desertwitch@users.noreply.github.com>

- drivers/cps-hid.c: bump subdriver version, rename nominal power constant [#2919]
- NEWS.adoc: cps-hid nominal power reporting fixes
- drivers/cps-hid.c: consider also non-broken ConfigActivePower descriptors [#2919]
- drivers/cps-hid.c: add report descriptor fix for ConfigActivePower

### 2.102. 2025-04-26 Jim Klimov <jimklimov+nut@gmail.com>

- NEWS.adoc: added a ve-direct driver for Victron Energy UPS/solar panels monitoring [#440]
- drivers/ve-direct.c: cast the int type for hex scanf() [#440]
- NEWS.adoc, docs/nut.dict: NEWS.adoc: introduced Voltronic Axpert inverter subdriver [#1407]

### 2.103. 2025-04-25 Jim Klimov <jimklimov@gmail.com>

- drivers/ve-direct.c: fix code style (markup, declarations before code) [#440]

### 2.104. 2025-04-25 Jim Klimov <jimklimov+nut@gmail.com>

- ci_build.sh: introduce (or guess) WITH_UNMAPPED_DATAPOINTS optional toggle
- ci_build.sh: add --with-unmapped-data-points for non-production builds
- docs/developers.txt, docs/nut.dict: document avoiding VLA
- drivers/ve-direct.c: fix declaration after code [#440]
- drivers/nutdrv_qx_voltronic-axpert.c: name "experimental.*" values in the mapping table as such; comment a few of them [#1407]
- drivers/nutdrv_qx_voltronic-axpert.c: fence yet-unmapped data points and commands (and their processing methods) better than "#if 0" [#1407]
- ci_build.sh: introduce (or guess) WITH_UNMAPPED_DATAPOINTS optional toggle
- ci_build.sh: add --with-unmapped-data-points for non-production builds
- drivers/nutdrv_qx_voltronic-axpert.c: fix whitespace [#1407]
- drivers/nutdrv_qx_voltronic-axpert.c: fix to use snprintf_dynamic() to check dynamic formating string sanity at run-time [#1407]
- drivers/nutdrv_qx_voltronic-axpert.c: avoid direct comparison of int and float [#1407]
- drivers/nutdrv_qx_voltronic-axpert.c: avoid variable-length buffer init [#1407]
- drivers/nutdrv_qx_voltronic-axpert.c: avoid missing field initializers [#1407]
- drivers/nutdrv_qx_voltronic-axpert.c: avoid daclarations after code [#1407]
- drivers/nutdrv_qx_voltronic-axpert.c: voltronic_axpert_crc(): annotate NUT_UNUSED_VARIABLE(item) [#1407]
- drivers/nutdrv_qx_voltronic-axpert.c: annotate NUT_UNUSED_VARIABLE(len) in some methods [#1407]
- docs/developers.txt, docs/nut.dict: document avoiding VLA
- drivers/common_voltronic-crc.c: avoid variable-length buffer init [#1407]
- drivers/nutdrv_qx.c: armac_command() reconcile use of now known cmdlen arg vs. strlen(cmd) content [#1407]
- drivers/nutdrv_qx.c: gtec_command(): add cmdlen arg and use it for sanity-check along the way [#1407]
- drivers/nutdrv_qx.c: ablerex_command(): use cmdlen arg for sanity-check along the way [#1407]
- drivers/ve-direct.c: trivialize upsdrv_help() [#440] Suggestion to RTFM is now centralized in NUT code base

### 2.105. 2025-04-24 Jim Klimov <jimklimov+nut@gmail.com>

- Jenkinsfile-dynamatrix: constrain shellcheck to "nut-builder" agents normally Avoid firing up QEMU builders on the NUT CI farm, unless we want QEMU tests
- clients/upsclient.c, common/common.c, include/common.h, server/upsd.c: Constrain pre-processor visibility and impact of inet_ntopXX() methods with NUT_WANT_INET_NTOP_XX macro [#2916]
- include/common.h: fix includes for inet_ntopXX [#2916]
- Jenkinsfile-dynamatrix: constrain shellcheck to "nut-builder" agents normally Avoid firing up QEMU builders on the NUT CI farm, unless we want QEMU tests
- NEWS.adoc, clients/upsclient.c, common/common.c, docs/nut.dict, include/common.h, server/upsd.c: Refactor inet_ntopSS() and inet_ntopAI() into common code, simplify upsclient and upsd
- server/upsd.c: add a sanity check into inet_ntopW() [#2915]
- server/upsd.c: introduce inet_ntopAI() specifically for struct addrinfo conversion [#2915]
- NEWS.adoc: fixed upsd printing of "further addresses ignored" [#2915]

### 2.106. 2025-04-23 Jim Klimov <jimklimov+nut@gmail.com>

- Makefile.am: group check-files-quick (spellcheck-quick check-man) before check-recursive which is the Autotools implementation behind "make check"
- common/common-nut_version.c: nut_report_config_flags(): report not only bitness but also target CPU if available [#2097]
- clients/Makefile.am: libupsclient.la and libnutclient.la do not actually include libcommonversion.la [#2097]
- Makefile.am: add a goal for libupsclient-version.h shortcut, just to be on par with an existing nut_version.h goal [#2097]
- Makefile.am, tools/nut-scanner/Makefile.am: current nut-scanner does not actually depend on nut_version.h (or not directly, just via libcommonversion.la) [#2097]
- Makefile.am, clients/Makefile.am, common/Makefile.am, drivers/Makefile.am, scripts/Windows/Makefile.am, server/Makefile.am, tools/nut-scanner/Makefile.am, tools/nutconf/Makefile.am: /Makefile.am: refactor with a separate libcommonversion.la [#2097] Avoid multiple rebuilds and relinks of libcommon.la and their dependants when nut_version.h changes. Now there is just one library impacted by this, included to LDFLAGS across the board for Makefiles of directories with consumers of methods exported from common-nut_version.c (declared by common.h still).
- common/common-nut_version.c: nut_report_config_flags(): try to also report build bitness, if known [#2097]
- NEWS.adoc, common/Makefile.am, common/common-nut_version.c, common/common.c: common/common-nut_version.c, common/common.c: evict UPS_VERSION and its consumers into a separate compilation unit [#2097]
- drivers/dstate.c: Implement dstate_addenum_dynamic() [#2450]
- common/common.c, drivers/dstate.c, drivers/mge-utalk.c: Update comments about remaining FORMAT_NONLITERAL and/or FORMAT_SECURITY pragmas to quiesce compiler warnings [#2450]
- common/common.c: minimize_formatting_string(): address error: switch missing default label [#2450, #2460]

### 2.107. 2025-04-23 Jeremy Cooper <jeremy.gthb@baymoo.org>

- server/upsd.c: Fix issue #2914: upsd misprint/buffer overflow.

### 2.108. 2025-04-22 Jim Klimov <jimklimov+nut@gmail.com>

- NEWS.adoc: fix entry for RPATH to NUT libs (was first planned for 2.8.4 but got into 2.8.3 ultimately) [#2782, #2865]
- tools/gitlog2version.sh: Reapply "tools/gitlog2version.sh: bump NUT_VERSION_DEFAULT=2.8.3.1 for next development cycle" This reverts commit 70faea2af378aec996e5f7284413df23d1e73410: finally released NUT v2.8.3, preparing for v2.8.4 cycle now.
- NEWS.adoc, UPGRADING.adoc, docs/docinfo.xml.in: Revert "Revert "Revert "NEWS.adoc, UPGRADING.adoc, docs/docinfo.xml.in: finalize text before NUT v2.8.3 release""" This reverts commit 051b49d9f0e693613d958837baf3e9bd1c0fa624: finally released NUT v2.8.3, preparing for v2.8.4 cycle now.
- docs/maintainer-guide.txt: a few more suggestions
- drivers/generic_gpio_libgpiod.c: align another print format with int type [#2911]

### 2.109. 2025-04-21 Jim Klimov <jimklimov+nut@gmail.com>

- configure.ac, common/common.c, include/Makefile.am, docs/nut-versioning.adoc: integrate NUT_VERSION_QUERY=IS_PRERELEASE support
- tools/gitlog2version.sh, docs/nut-versioning.adoc: extend NUT SEMVER with support for (rc|alpha\|beta) tags or VERSION_FORCED file contents; queries and variables for PRERELEASE info
- docs/maintainer-guide.txt, docs/nut-versioning.adoc, tools/gitlog2version.sh: tools/gitlog2version.sh, docs/maintainer-guide.txt: introduce support for NUT_VERSION_QUERY="UPDATE_FILE_GIT_RELEASE"
- docs/nut.dict: fix order and count
- docs/maintainer-guide.txt: suggest RC naming in VERSION_FORCED, and a way to protect these files from accidental deletion

### 2.110. 2025-04-20 Jim Klimov <jimklimov+nut@gmail.com>

- configure.ac: always detect if we have_disted_doc_man
- configure.ac: report something reasonable if we skipped checking for have_disted_doc_man

### 2.111. 2025-04-18 desertwitch <24509509+desertwitch@users.noreply.github.com>

- common/nutwriter.cpp, tests/nutconf_ut.cpp: streamline ALARMCRITICAL writer/expectations with documentation [#2909]
- scripts/augeas/nutupsmonconf.aug.in: introduce ALARMCRITICAL setting
- common/nutwriter.cpp: introduce upsmon ALARMCRITICAL setting
- common/nutconf.cpp, include/nutconf.hpp, tests/nutconf_ut.cpp: introduce upsmon ALARMCRITICAL setting
- scripts/augeas/nutupsmonconf.aug.in: introduce OVERDURATION setting
- common/nutwriter.cpp: introduce upsmon OVERDURATION setting
- common/nutconf.cpp, include/nutconf.hpp, tests/nutconf_ut.cpp: introduce upsmon OVERDURATION setting
- NEWS.adoc, docs/nut.dict: introduce OVERDURATION setting
- conf/upsmon.conf.sample.in, docs/man/upsmon.conf.txt: introduce OVERDURATION setting
- clients/upsmon.c, clients/upsmon.h: introduce OVERDURATION setting

### 2.112. 2025-04-18 Jim Klimov <jimklimov+nut@gmail.com>

- tests/nutconf_ut.cpp: fix expectations for ALARMCRITICAL [#2909]
- tools/nut-usbinfo.pl: comment a TODO
- Makefile.am, tools/Makefile.am: fix parallel rebuilds of nut-scanner (generate sources via nut-scanner-deps/tools only once) [#2825]
- drivers/hwmon_ina219.c: rephrase message about invalid "port" value
- drivers/nutdrv_qx.c: warn user if setting both port!="auto" and settings for USB mode [#2906]
- drivers/nutdrv_qx.c: avoid extra lookup for dstate_getinfo("driver.parameter.port")

### 2.113. 2025-04-17 Jim Klimov <jimklimov+nut@gmail.com>

- Makefile.am, docs/Makefile.am, scripts/Solaris/Makefile.am, tests/Makefile.am: */Makefile.am: report work skipped by design as " SKIP description" (separated by TAB chars)
- Makefile.am, common/Makefile.am, docs/Makefile.am, docs/man/Makefile.am, scripts/Solaris/Makefile.am, scripts/python/module/Makefile.am: */Makefile.am: where we echo " TOKEN description", separate them by TAB chars

### 2.114. 2025-04-16 Jim Klimov <jimklimov+nut@gmail.com>

- Jenkinsfile-dynamatrix: skip macos for Default Autotools builds (fightwarn/qemu scenarios) At least now that the worker available to NUT CI farm requires hacks for HomeBrew with -Wno-poison-system-directories …
- UPGRADING.adoc: revise notes for NUT v2.8.3 release to upper-case starts of sentences
- NEWS.adoc: revise notes for NUT v2.8.3 release to group some themes and to upper-case starts of sentences
- NEWS.adoc: modbus drivers now report NUT_MODBUS_LINKTYPE_STR [#2897]
- drivers/phoenixcontact_modbus.c, drivers/generic_modbus.c, drivers/huawei-ups2000.c, drivers/socomec_jbus.c, drivers/adelsystem_cbi.c: report NUT_MODBUS_LINKTYPE_STR
- drivers/apc_modbus.c: report NUT_MODBUS_LINKTYPE_STR
- m4/nut_check_libmodbus.m4: detect NUT_MODBUS_LINKTYPE_STR
- m4/nut_check_libmodbus.m4: only define NUT_MODBUS_HAS_USB if nut_have_libmodbus also
- configure.ac: detect LDD early, so everyone can use it if available
- common/common.c, NEWS.adoc: upsnotify(): default to not spam if our first message to be suppressed is already about stopping the program [#1590]

### 2.115. 2025-04-15 Jim Klimov <jimklimov+nut@gmail.com>

- docs/maintainer-guide.txt: more notes to check code/recipe quality before release
- docs/config-prereqs.txt, docs/nut.dict: wrap most long lines, reword a few

### 2.116. 2025-04-14 Jim Klimov <jimklimov+nut@gmail.com>

- docs/man/upscmd.txt, docs/man/upsrw.txt: clarify "OK" vs. waiting for result [#2900]
- docs/Makefile.am: ensure qa-guide-docinfo.xml made for qa-guide.adoc-prepped generally
- Jenkinsfile-dynamatrix: use ci_build.sh extended to support BUILD_TYPE="default-spellcheck-quick"
- ci_build.sh: extend to support BUILD_TYPE="default-spellcheck-quick" as well as CLI shortcuts for quick interactive and normal spellchecks
- ci_build.sh: help troubleshoot invalid CPP setting
- ci_build.sh: build_to_only_catch_errors_check(): call from default build routine too instead of "make check"
- ci_build.sh: build_to_only_catch_errors_check(): handle spellcheck-quick before other checks
- configure.ac, NEWS.adoc: extend enable_inplace_runtime mode to consider also cgipath, drvpath, datadir, libdir [#2895]
- docs/maintainer-guide.txt: note to check for library changes (exposed API) [#2895]
- docs/maintainer-guide.txt: note to not rush, and do use RC tags
- clients/Makefile.am, tools/nut-scanner/Makefile.am, UPGRADING.adoc: flip library version-info to new "current" numbers (more symbols exported now) [#2895]
- docs/configure.txt, docs/nut.dict: docs/configure.txt: tell more about the --datadir option vs. --datarootdir
- configure.ac: typo fix in comment
- configure.ac: suggest comparing the "in-place" FS layout before installing it live [#2895]
- INSTALL.nut.adoc: in-place upgrades: document how to compare new build FS layout to existing deployment to be overwritten
- INSTALL.nut.adoc: fix dashes in "Building NUT for in-place upgrades or non-disruptive tests" chapter title and references (Unicode⇒ASCII)

### 2.117. 2025-04-12 Scott Shambarger <devel@shambarger.net>

- scripts/external_apis/enphase/enphase-monitor.in: scripts/external_apis/enphase: correct neg number conversion, retry api Negative floats, and floats 0.08/0.09 were resulting in invalid octal numbers. The envoy API occasionally stalls; extended timeout to 10s and added a single retry to avoid spurious "nocomms" state.

### 2.118. 2025-04-11 Jim Klimov <jimklimov+nut@gmail.com>

- common/unsetenv.c, configure.ac, include/proto.h: Introduce fallback unsetenv() e.g. for WIN32 [#2890]
- NEWS.adoc: note the changes for upssched and NIT [#2890]
- clients/upssched.c: also writepid() and unsetenv() in WIN32 builds [#2890]
- clients/upssched.c: unsetenv("NOTIFYTYPE") and unsetenv("UPSNAME") when starting the timer loop [#2890]
- clients/upssched-cmd: use UTC date in sample reports [#2890]
- scripts/misc/notifyme-debug: also print envvar and other details to stderr if calling upssched and NUT_DEBUG_LEVEL>0 [#2890]
- tests/NIT/nit.sh: track down PID_UPSSCHED in more cases, try to report via env file for sandbox [#2890]
- tests/NIT/nit.sh: make sure we have upslog and upssched to test [#2890]
- tests/NIT/nit.sh: support per-tool NUT_DEBUG_LEVEL_* settings [#2890]
- scripts/misc/notifyme-debug: allow a separate NUT_DEBUG_LEVEL_UPSSCHED [#2890]
- tests/NIT/nit.sh: stop_daemons(): pick up PID_UPSSCHED from $NUT_PIDPATH/upssched.pid if possible [#2890]
- clients/upssched.c: writepid() from the timer daemon child loop [#2890]
- scripts/misc/notifyme-debug, tests/NIT/nit.sh: call upssched for testing as part of upsmon NOTIFYME [#2890]
- tests/NIT/nit.sh, tests/NIT/upssched.conf.in: tests/NIT/nit.sh: generatecfg_upsmon_trivial(): populate also upssched.conf [#2890]
- clients/upssched-cmd: make the sample script a bit more useful [#2890]
- tools/nutconf/nutconf-cli.cpp: do not declare var inside for()
- drivers/generic_gpio_libgpiod.c: do not declare var inside for()

### 2.119. 2025-04-10 Jim Klimov <jimklimov+nut@gmail.com>

- tests/generic_gpio_liblocal.c: declare variables at top of scope
- tests/generic_gpio_utest.c: fix casting for %u printing of literal numbers (via macro)
- drivers/hwmon_ina219.c: fix format strings for %u printing
- drivers/asem.c: fix casting for %x printing and maths
- drivers/generic_gpio_libgpiod.c: declare variables at top of scope
- drivers/generic_gpio_libgpiod.c: fix casting for %x printing
- docs/config-prereqs.txt: update for Debian 13 (python3-pyqt5, systemd-dev, java 21)
- Makefile.am: install-as-root: consider nut-udev-settle.service [#2638]
- scripts/systemd/nut-udev-settle.service: it suffices to NOT RemainAfterExit and still be Type=oneshot to get triggered for driver restart(s) [#2638]

### 2.120. 2025-04-09 Scott Shambarger <devel@shambarger.net>

- scripts/external_apis/enphase/enphase-monitor.in, scripts/external_apis/enphase/enphase-monitor@.service.in: scripts/external_apis/enphase - correct number conversion, service file Floats <1.0 were being handled as octal, corrected to use decimal. Corrected path substitution in enphase-monitor service file.

### 2.121. 2025-04-09 Jim Klimov <jimklimov+nut@gmail.com>

- scripts/systemd/Makefile.am: actually deliver nut-udev-settle.service [#2638]
- scripts/python/Makefile.am: fix delivery of install-data-hook-app-locale-symlinks [#2857]
- scripts/upsdrvsvcctl/nut-driver-enumerator.sh.in: upsconf_getDriverMedia(): comment a FIXME for more media types of recently added driver concepts
- NEWS.adoc, UPGRADING.adoc: document nut-udev-settle.service [#2638]
- scripts/systemd/nut-server.service.in: small typos in comments
- scripts/systemd/nut-udev-settle.service, scripts/systemd/nut-systemd.preset, scripts/upsdrvsvcctl/nut-driver-enumerator.sh.in: pull in nut-udev-settle.service when needed [#2638]
- scripts/systemd/nut-udev-settle.service: modify Description and optional dependencies [#2638]
- scripts/systemd/nut-udev-settle.service: import systemd-udev-settle.service from systemd for adaptation as part of NUT; update only header comment so far [#2638]
- scripts/upsdrvsvcctl/nut-driver-enumerator.sh.in: fix typo about systemd-udevd.service [#2638]
- clients/.gitignore, clients/Makefile.am, include/.gitignore, include/Makefile.am: include/Makefile.am, clients/Makefile.am: fix possible clashes of parallel re-generation of nut_version.h and/or libupsclient-version.h [#2875]
- docs/man/nutdrv_qx.txt: warn that detection of Qx dialect can take a minute [#2885]
- NEWS.adoc: document changes for upsdrvctl [#2885, #2888]
- drivers/upsdrvctl.c, docs/man/upsdrvctl.txt, docs/man/ups.conf.txt, conf/ups.conf.sample: bump default maxstartdelay from 45 to 75 sec [#2885]
- drivers/upsdrvctl.c, drivers/main.c, docs/man/ups.conf.txt, conf/ups.conf.sample: make "maxtries" and "retrydelay" configurable at driver level too [#2888]
- drivers/upsdrvctl.c: do not allow invalid "maxretry" settings [#2888]
- drivers/main.c: tolerate driver-level maxstartdelay setting (for upsdrvctl) [#2885, #2888]
- drivers/upsdrvctl.c: report applicable (global/device) maxstartdelay values when they are exceeded [#2885]
- docs/man/upsdrvctl.txt, drivers/upsdrvctl.c: document defaults for maxstartdelay, maxretry and retrydelay [#2885]

### 2.122. 2025-04-09 Bill Elliot <bill@wreassoc.com>

- drivers/powervar-cu.c: Add setting of ups.vendorid and ups.productid.

### 2.123. 2025-04-08 Jim Klimov <jimklimov+nut@gmail.com>

- UPGRADING.adoc: mention NUT_DEFAULT_CONNECT_TIMEOUT among new envvars
- appveyor.yml: handle also FTY and fightwarn branches
- .github/workflows/codeql.yml: handle also FTY and fightwarn branches
- Makefile.am: nut-scanner does directly depend on clients after all
- NEWS.adoc, UPGRADING.adoc, docs/docinfo.xml.in: Revert "Revert "NEWS.adoc, UPGRADING.adoc, docs/docinfo.xml.in: finalize text before NUT v2.8.3 release"" This reverts commit b12eac3bb52ce0a348bb9601ddab30e47b8b218d. Re-releasing v2.8.3 after small but important recipe bumps.
- tools/gitlog2version.sh: Revert "tools/gitlog2version.sh: bump NUT_VERSION_DEFAULT=2.8.3.1 for next development cycle" This reverts commit 52214a8fc9b8cf30375d411eb71629181115e3dd. Re-releasing v2.8.3 after small but important recipe bumps.
- include/Makefile.am: nut_version.h: propagate failure (if there ever is one) writing the temporary output
- clients/.gitignore, clients/Makefile.am: clients/Makefile.am: libupsclient-version.h: take a transactional approach to changing (or not) the file others depend on

### 2.124. 2025-04-08 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- drivers/mge-hid.c: ecomode cmd functions addon

### 2.125. 2025-04-07 Jim Klimov <jimklimov+nut@gmail.com>

- tools/gitlog2version.sh: bump NUT_VERSION_DEFAULT=2.8.3.1 for next development cycle
- NEWS.adoc, UPGRADING.adoc, docs/docinfo.xml.in: Revert "NEWS.adoc, UPGRADING.adoc, docs/docinfo.xml.in: finalize text before NUT v2.8.3 release" This reverts commit d3427d7fd3c83b8f5b61c8e369139e2bd6168203 after the NUT release v2.8.3.
- .github/workflows/PyNUTClient.yml, appveyor.yml, scripts/Windows/build-mingw-nut.sh, tools/gitlog2version.sh: Update versions for release of NUT v2.8.3
- docs/maintainer-guide.txt: update correct way of setting VERSION_FORCED* files
- tools/gitlog2version.sh: rephrase comments about NUT_VERSION_FORCED(_SEMVER)
- docs/nut-versioning.adoc: rephrase about NUT_VERSION_FORCED(_SEMVER)
- docs/maintainer-guide.txt: revise procedure on version-bump commit vs. docinfo increment …and that edits of `configure.ac` (`AC_INIT` macro) forth and back are no longer needed
- docs/maintainer-guide.txt: make use of "make dist-files" goal
- docs/docinfo.xml.in: add docs increment summary for NUT v2.8.3 release
- docs/maintainer-guide.txt: update markup and a bit of contents
- NEWS.adoc: remove "PLANNED" from section title before NUT v2.8.3 release
- NEWS.adoc, UPGRADING.adoc, docs/docinfo.xml.in: finalize text before NUT v2.8.3 release
- Makefile.am: revise dependency for all-libs-local/tools/nut-scanner
- include/wincompat.h: fix NUT_WIN32_INCOMPLETE*() printout [#1479, #2882] The LINE is an integer, not string
- INSTALL.nut.adoc, docs/nut.dict: INSTALL.nut.adoc: Windows installation: suggest Zadig tool for USB drivers [#1690, #2881]
- drivers/libusb0.c, drivers/libusb1.c: drivers/libusb{0,1}.c: in WIN32 builds, suggest Zadig tool if failed to find any drivers [#2881] May be duplicated if we issued the suggestion also for suspicious report descriptor sizes and ultimately failed to find a device.
- include/timehead.h: tag fallback gmtime_r()/localtime_r() with NUT_WIN32_INCOMPLETE [#1483]
- clients/message.c, clients/nutclient.cpp, clients/upsc.c, clients/upsclient.c, clients/upscmd.c, clients/upslog.c, clients/upsmon.c, clients/upsmon.h, clients/upsrw.c, clients/upssched.c, clients/upssched.h, clients/upsset.c, common/common.c, common/nutipc.cpp, common/nutstream.cpp, common/state.c, common/wincompat.c, drivers/apc_modbus.c, drivers/apcsmart-old.h, drivers/apcsmart.c, drivers/apcsmart.h, drivers/apcupsd-ups.c, drivers/bcmxcp_usb.c, drivers/belkin.h, drivers/belkinunv.c, drivers/bestfortress.c, drivers/blazer_ser.c, drivers/blazer_usb.c, drivers/clone-outlet.c, drivers/clone.c, drivers/dstate.c, drivers/dstate.h, drivers/dummy-ups.c, drivers/genericups.c, drivers/isbmex.c, drivers/libusb0.c, drivers/libusb1.c, drivers/main.c, drivers/main.h, drivers/mge-hid.c, drivers/mge-utalk.c, drivers/mge-xml.c, drivers/netxml-ups.c, drivers/nutdrv_atcl_usb.c, drivers/powercom.h, drivers/richcomm_usb.c, drivers/riello_ser.c, drivers/riello_usb.c, drivers/serial.c, drivers/serial.h, drivers/snmp-ups.h, drivers/upsdrvctl.c, drivers/upsdrvquery.c, drivers/usb-common.c, drivers/usbhid-ups.c, include/common.h, include/nutipc.hpp, include/nutstream.hpp, scripts/Windows/wininit.c, server/conf.c, server/netssl.c, server/nut_ctype.h, server/sstate.c, server/stype.h, server/upsd.c, server/upsd.h, server/upstype.h, server/user.c, tests/generic_gpio_utest.c, tests/nutipc_ut.cpp, tests/nutstream_ut.cpp, tools/nut-scanner/nut-scanner.c, tools/nut-scanner/nutscan-init.c, tools/nut-scanner/nutscan-ip.c, tools/nut-scanner/nutscan-ip.h, tools/nut-scanner/nutscan-serial.c, tools/nut-scanner/scan_eaton_serial.c, tools/nut-scanner/scan_nut.c, tools/nut-scanner/scan_snmp.c, tools/nut-scanner/scan_usb.c, tools/nut-scanner/scan_xml_http.c: Mark up WIN32 code paths with NUT_WIN32_INCOMPLETE where applicable [#1479] * also ensure that for every `#if(n)def WIN32` we have annotated the matching `#else` and `#endif` to help navigate in that code base * update some comments * move a few WIN32-specific declarations to start of scope
- common/common.c, include/nutipc.hpp, clients/upsmon.c: fix markup to include wincompat.h
- clients/nutclient.cpp, common/nutconf.cpp, common/nutipc.cpp, common/nutstream.cpp, common/nutwriter.cpp, include/nutconf.hpp, include/nutipc.hpp, include/nutstream.hpp, include/nutwriter.hpp, tests/cpputest-client.cpp, tests/cpputest.cpp, tests/nutclienttest.cpp, tests/nutconf_parser_ut.cpp, tests/nutconf_ut.cpp, tests/nutipc_ut.cpp, tests/nutstream_ut.cpp: C+\+ code: bump copyrights, bring non-test headings into common format
- drivers/belkinunv.c: use NUT_WIN32_INCOMPLETE_DETAILED() [#1479]
- include/wincompat.h: introduce NUT_WIN32_INCOMPLETE() and NUT_WIN32_INCOMPLETE_DETAILED(str) macros [#1479]

### 2.126. 2025-04-06 Jim Klimov <jimklimov+nut@gmail.com>

- docs/Makefile.am: docinfo-since-v2.8.3.xml: bump OLDEST_REL to 2.8.3 actually
- Jenkinsfile-dynamatrix: typo in comment
- configure.ac: hide back CONFIGURE-DEVEL-DEBUG of SCRIPTFILE parsing variants
- Jenkinsfile-dynamatrix: update "Default autotools" build rules for fightwarn to relax distcheck (not all dependencies are available on some agents)
- m4/nut_report_feature.m4, configure.ac: introduce NUT_REPORT_TARGET_WITHOUT_AC_DEFINE() to work around possibly multi-line values
- ci_build.sh: pass --enable-configure-debug option to configure script
- m4/ax_c_pragmas.m4, m4/nut_check_libgd.m4, m4/nut_check_libusb.m4: make use of nut_enable_configure_debug toggle
- configure.ac, docs/configure.txt: introduce --enable-configure-debug option, convert debug-loggers to use it Some loggers were "noisy" and default; others were hidden as commented away
- Makefile.am: distcheck-light-DIST_ALL_PAGES-docs-skipped: ensure docs/man/.prep-src-docs exists and is older than (possibly faked) man pages, so "make dist" does not waste time building them
- Makefile.am: refactor distcheck-valgrind with reusable distcheck-light-DIST_ALL_PAGES-docs-skipped
- include/Makefile.am: track when nut_version.h gets re-populated (or not) Its timestamp changes cause re-generation of common.o and so libupsclient.so etc.
- m4/nut_check_libgpiod.m4: fix typo in called command (test not text)

### 2.127. 2025-04-04 Jim Klimov <jimklimov+nut@gmail.com>

- docs/nut-names.txt: clarify semi-syntax of experimental.ups.mode.buzzwords [#2708]
- docs/nut-names.txt: clarify semi-syntax of ups.status and ups.alarm [#2708]
- m4/ax_realpath_lib.m4: fall-back to detect myLIBPATH if compiler does not resolve it [#2431] On NetBSD it returns the library name, not the full path - seems to ignore -R/-L options for /usr/pkg/lib …
- drivers/phoenixcontact_modbus.c: fix for loop and variable type
- clients/upsmon.c: is_ups_critical(): treat OVER/TRIM/BYPASS as not critical [#1074]
- clients/upsmon.c: is_ups_critical() report ST_CAL/ST_BYPASS after possible non-critical states that may contribute to fatality of the situation
- docs/new-drivers.txt: document the initial "WAIT" value of `ups.status` (set by `upsd` internally) [#2708]
- clients/upssched-cmd: update the sample script with some comments and logging

### 2.128. 2025-04-03 Jim Klimov <jimklimov+nut@gmail.com>

- NEWS.adoc, clients/upsmon.c, clients/upsmon.h, common/nutconf.cpp, common/nutwriter.cpp, conf/upsmon.conf.sample.in, docs/man/nutconf.txt, docs/man/upsmon.conf.txt, docs/man/upsmon.txt, docs/nut.dict, include/nutconf.hpp, scripts/augeas/nutupsmonconf.aug.in, tools/nutconf/nutconf-cli.cpp: clients/upsmon.{c,h} et al: introduce {NOT,}{OVER,TRIM,BOOST} notifications [#1074] Closes: #1074
- configure.ac: revise script markup/comments

### 2.129. 2025-04-02 Jim Klimov <jimklimov+nut@gmail.com>

- Makefile.am, docs/Makefile.am: spellcheck* rules: revise work with "make -k -s …" [#2871]
- Makefile.am: adjust SUBDIR_MAKE_VERBOSE during spellcheck rule handling (default vs. explicit 0/1) [#2871]
- .gitignore, docs/Makefile.am: docs/Makefile.am et al: implement parallelized non-interactive spellcheck for many files in one dir (if NUT_MAKE_SKIP_FANOUT!=true) [#2871]
- Makefile.am: spellcheck*: fix to use SPELLCHECK_TGT to avoid breaking prep-src-docs [#2871]
- Makefile.am: do not hard-code a SUBDIR_MAKE_VERBOSE=… for spellcheck* recipes anymore [#2871]
- include/nutconf.hpp: BoolInt: equality operator: ignore failed getters, if any - consider not-set
- include/nutconf.hpp: BoolInt: clearWithBool01() in default constructor too
- include/nutconf.hpp: BoolInt: introduce clearWithBool01() to refactor setters from BoolInt instances
- include/nutconf.hpp: BoolInt: quiesce older compilers with HAVE_PRAGMA_GCC_DIAGNOSTIC_IGNORED_MAYBE_UNINITIALIZED
- m4/ax_c_pragmas.m4: introduce HAVE_PRAGMA_GCC_DIAGNOSTIC_IGNORED_MAYBE_UNINITIALIZED(_BESIDEFUNC)
- Makefile.am: spellcheck(-interactive): mitigate possible early failure of fanned-out attempt [#2871]
- NEWS.adoc: document new `make spellcheck-interactive-quick` and related changes [#2871]
- docs/man/Makefile.am: revise to not require HTML man page building to check them if not enabled (although possible)
- Makefile.am: merge back spellcheck and spellcheck-interactive into one definition; honour NUT_MAKE_SKIP_FANOUT
- tools/nut-scanner/Makefile.am: be sure to use both LIBSSL_LIBS and LIBSSL_LDFLAGS_RPATH when linking both libnutscan.la library and nut-scanner program [#2870]

### 2.130. 2025-04-01 Jim Klimov <jimklimov+nut@gmail.com>

- Makefile.am: spellcheck-interactive: refactor with SPELLCHECK_DIRS too
- Makefile.am: spellcheck: convert the goal to SUBDIR_TGT_RULE parallelizable style
- Makefile.am: spellcheck-quick: support MAXPARMAKES toggle on NUT CI farm or ci_build.sh
- Makefile.am: introduce SUBDIR_TGT_RULE ability for recipes to define custom TGT and/or DIR values (not parsed from $@ always)
- Makefile.am: introduce SUBDIR_MAKE_VERBOSE toggle for quieter tracing
- Makefile.am: split spellcheck-quick from spellcheck-interactive-quick
- m4/nut_report_feature.m4: report linker program and flags in the end
- docs/config-prereqs.txt: NetBSD: fix symlinks for versioned GCC
- docs/config-prereqs.txt, docs/nut.dict: NetBSD: Not only openipmi, but also net-snmp, packages need CHECK_OSABI=no in /etc/pkg_install.conf [#2870]
- docs/config-prereqs.txt, docs/nut.dict: docs/config-prereqs.txt: NetBSD: note that having OpenIPMI does not help NUT at the moment
- docs/config-prereqs.txt: NetBSD: hide dblatex suggestion, seems AWOL
- ci_build.sh: detect_platform_PKG_CONFIG_PATH_and_FLAGS(): hacks for NetBSD libltdl dependency to be found out of the box
- Jenkinsfile-dynamatrix: avoid "default autotools" builds on NetBSD for now [#2870]
- ci_build.sh: detect_platform_PKG_CONFIG_PATH_and_FLAGS(): hacks for NetBSD pkgsrc dependencies to be found out of the box
- docs/config-prereqs.txt: NetBSD now provides also gcc-14
- drivers/mge-xml.c: do not encroach on reserved C token namespace [#2870] Just renamed the private enum values. Earlier code complained with NetBSD clang-18: mge-xml.c:76:2: error: identifier UNEXPECTED is reserved because it starts with followed by a capital letter [-Werror,-Wreserved-identifier] 76 \| UNEXPECTED, | ^ mge-xml.c:77:2: error: identifier _PARSEERROR is reserved because it starts with followed by a capital letter [-Werror,-Wreserved-identifier] 77 \| _PARSEERROR, | \^ 2 errors generated.
- docs/config-prereqs.txt: NetBSD: expand on Python versions and UI dependencies for NUT-Monitor
- docs/config-prereqs.txt, docs/nut.dict: docs/config-prereqs.txt: update NetBSD prereqs a bit "make" package is absent, `/usr/bin/make` appears from something I could not track down; however there is a separate but similar "bmake" as `/usr/pkg/bin/bmake` that can be installed. Probably a difference of system vs. userland tooling variants.
- docs/config-prereqs.txt, docs/nut.dict: NetBSD: more info about pkgsrc and its pkgin tool
- scripts/upsdrvsvcctl/nut-driver-enumerator.sh.in: fix portability of numeric\+alpha sort [#2870] Thanks to Greg Troxel @gdt for the hint and fruitful discussion.

### 2.131. 2025-03-31 Jim Klimov <jimklimov+nut@gmail.com>

- clients/upsclient.c: upscli_tryconnect(): revise addrinfo printout [#2847, #85] Clang complained about explicit pointers: upsclient.c:1187:37: error: cast from struct sockaddr * to struct sockaddr_in * increases required alignment from 2 to 4 [-Werror,-Wcast-align] 1187 \| struct sockaddr_in *addr_in = (struct sockaddr_in *)ai→ai_addr; \| ~~~~~~~~~~~~~~~~ upsclient.c:1192:39: error: cast from struct sockaddr * to struct sockaddr_in6 * increases required alignment from 2 to 4 [-Werror,-Wcast-align] 1192 \| struct sockaddr_in6 *addr_in6 = (struct sockaddr_in6 *)ai→ai_addr; \| ~~~~~~~~~~~~~~~~\~ 2 errors generated.
- docs/config-prereqs.txt: NetBSD 9.2: bump openjdk to 21 and document profile edits
- common/common.c, drivers/powerp-txt.c, drivers/nutdrv_qx.c: cast char to unsigned char when using as array subscript [#823] This may be an implicit array, such as tolower() implementation as a ctype(3) macro rather than function.
- clients/cgilib.c, clients/upssched.c, clients/upsset.c, clients/upsstats.c, common/common.c, common/nutstream.cpp, common/upsconf.c, common/wincompat.c, drivers/dstate.c, drivers/dummy-ups.c, drivers/hwmon_ina219.c, drivers/main.c, drivers/nhs_ser.c, drivers/snmp-ups.c, drivers/upsdrvctl.c, drivers/upsdrvquery.c, drivers/upsdrvquery.h: drivers/, clients/, common/*: fix pathname budders to be NUT_PATH_MAX\+1 to allow for ending NUL char [#823]
- docs/config-prereqs.txt, docs/nut.dict: docs/config-prereqs.txt: NetBSD 9.2: require mozilla-rootcerts-openssl for GitHub to work
- clients/upsclient.c: upscli_tryconnect(): report more errors including timeout for particular addrinfo [#2847, #85]
- NEWS.adoc, UPGRADING.adoc, clients/upsc.c, clients/upsclient.c, clients/upsclient.h, clients/upscmd.c, clients/upsimage.c, clients/upslog.c, clients/upsmon.c, clients/upsrw.c, clients/upsset.c, clients/upsstats.c, docs/man/Makefile.am, docs/man/index.txt, docs/man/upscli_connect.txt, docs/man/upscli_get_default_connect_timeout.txt, docs/man/upscli_get_default_timeout.txt, docs/man/upscli_init.txt, …txt ⇒ upscli_init_default_connect_timeout.txt}, ….txt ⇒ upscli_set_default_connect_timeout.txt}: client/*, docs: Rename upscli_*default_timeout to upscli*_default_connect_timeout [#2847]
- docs/man/upsc.txt, docs/man/upscmd.txt, docs/man/upslog.txt, docs/man/upsmon.txt, docs/man/upsrw.txt: docs/man/{upsc,upscmd,upsrw,upslog,upsmon}.txt: document "COMMON OPTIONS" including the new "-W secs" [#2847]
- clients/upsc.c, clients/upscmd.c, clients/upsimage.c, clients/upslog.c, clients/upsmon.c, clients/upsmon.h, clients/upsrw.c, clients/upsset.c, clients/upsstats.c: clients/*.c, clients/upsmon.h: rename macros, variables and usage text to stress that "default network timeout" is about "initial connection" [#2847]
- docs/man/upscli_init_default_timeout.txt: clarify why we may want a non-blocking connection timeout [#2847]
- clients/upsclient.c, docs/man/upscli_connect.txt, docs/man/upscli_init.txt, docs/man/upscli_init_default_timeout.txt: clients/upsclient.c, docs/man/upscli_*.txt: track if we have upscli_default_timeout_initialized [#2847] If not, auto-init in upscli_init() and upscli_connect() once, to help clients not modified to call upscli_init_default_timeout() explicitly to still benefit from NUT_DEFAULT_CONNECT_TIMEOUT envvar.
- clients/upsclient.c: upscli_init_default_timeout(): upslogx(LOG_WARNING,…) about timeout strings that we failed to parse [#2847]
- clients/upsclient.h: comment about upscli_get_default_timeout() [#2847]
- docs/nut.dict: update for docs/man/upscli_get_default_timeout.txt [#2847]
- docs/man/Makefile.am, docs/man/index.txt, docs/man/upscli_connect.txt, docs/man/upscli_init_default_timeout.txt, docs/man/upscli_set_default_timeout.txt, docs/nut.dict: docs/man/*: document upscli_init_default_timeout() and upscli_set_default_timeout()
- docs/man/upscli_connect.txt, docs/man/index.txt, docs/man/Makefile.am, docs/nut.dict: document upscli_tryconnect() too

### 2.132. 2025-03-30 Scott Shambarger <devel@shambarger.net>

- UPGRADING.adoc, clients/upsclient.c, clients/upsclient.h, clients/upscmd.c, clients/upsimage.c, clients/upslog.c, clients/upsmon.c, clients/upsmon.h, clients/upsrw.c, clients/upsset.c, clients/upsstats.c, docs/man/Makefile.am, docs/man/index.txt, docs/man/upscli_get_default_timeout.txt, docs/man/upscli_set_default_timeout.txt: clients: added -W <secs> argument Added -W <secs> network timeout arg to all clients to match upsc usage. Updated help message with "common args" section for -h/-W/-V args. Added upscli_get_default_timeout (used by upsmon)

### 2.133. 2025-03-30 Jim Klimov <jimklimov@gmail.com>

- docs/Makefile.am: docs/Makefile.am, docs/.gitignore: support also qa-guide-docinfo.xml (fix 2)
- docs/Makefile.am: docs/Makefile.am, docs/.gitignore: support also qa-guide-docinfo.xml (fix)
- docs/maintainer-guide.txt, docs/user-manual.txt: update Author Initials
- docs/Makefile.am, docs/.gitignore: support also qa-guide-docinfo.xml

### 2.134. 2025-03-30 Jim Klimov <jimklimov+nut@gmail.com>

- clients/upsclient.c: define both fields of upscli_default_timeout explicitly after all [#2847] Antique clang (3.4) refuses the standard-required single-token init of aggregate types: upsclient.c:162:50: error: missing field tv_usec initializer [-Werror,-Wmissing-field-initializers] static struct timeval [upsclient.lo] Error 1
- clients/upsc.c: convert to upscli_init_default_timeout() [#2847]
- clients/Makefile.am, NEWS.adoc: export nut_debug_level* from libupsclient so that clients can be usefully debugged
- docs/qa-guide.adoc, docs/nut.dict: refer to docinfo-since-v2.8.3.xml which we want to use [#2832] And fix some spellings and/or dictionary
- docs/documentation.txt, docs/nut.dict: link to Dan Langille’s blog post about NUT shutdown testing
- docs/documentation.txt, docs/nut.dict: link to Jeff Geerling’s blog post about NUT
- clients/upsclient.c: upscli_init(): only check getenv("NUT_QUIET_INIT_SSL") if not already upscli_initialized
- clients/upsclient.c, clients/upsclient.h: clients/upsclient.{c,h}: introduce upscli_init_default_timeout(), restore upscli_init() which is for SSL [#2847]
- NEWS.adoc, UPGRADING.adoc, clients/upsclient.c, clients/upsclient.h, conf/nut.conf.sample: clients/upsclient.{c,h}, conf/nut.conf.sample: upscli_init(): introduce NUT_DEFAULT_CONNECT_TIMEOUT envvar [#2847]
- clients/upsclient.c: upscli_init(): be sure to (re-)set upscli_default_timeout to 0 [#2847]
- NEWS.adoc, UPGRADING.adoc: many clients fixed to at least UPSCLI_CONN_TRYSSL [#2847]
- NEWS.adoc, UPGRADING.adoc: upscli_set_default_timeout() introduced, many clients changed to 10-second default timeout instead of blocking [#2847]
- clients/upsclient.c: upscli_default_timeout(): be sure parsed "0" is applied as such
- clients/upsc.c: fix code style (white spaces)
- clients/upsclient.c: upscli_default_timeout: be sure to zero-init The standard says that static-storage arithmetic values are pre-initialized to zero implicitly, but better safe than sorry with arithmetic entities to be zero-inited for each component should be supported since at least C89 standard.
- clients/upsclient.c: upscli_set_default_timeout(): use str_to_double() to avoid dependency on env (locale)
- common/str.c: strtof() fallback: comment about dependency on env (locale)
- clients/upsclient.c: upscli_connect(): comment about default behavior of the method remaining as it was
- clients/upsclient.c: fix code style (white spaces)
- Makefile.am: EXTRA_DIST the new ci_build.adoc [#2832]

### 2.135. 2025-03-29 Jim Klimov <jimklimov+nut@gmail.com>

- docs/.gitignore, docs/Makefile.am: docs/Makefile.am: use a shorter docinfo-since-v2.8.3.xml for qa-guide.pdf [#2832, #2866]
- ci_build.sh: add support for "--with-docs*" CLI arg spelling (same as "docs*" before)
- docs/qa-guide.adoc: add a chapter on CodeQL [#2832]
- docs/qa-guide.adoc: add a chapter on cppcheck [#2832]
- docs/nut-qa.txt: modernize notes regarding Buildbot, GitHub and LGTM.com
- docs/download.txt, docs/nut-qa.txt: revise links to security notes
- docs/docinfo.xml.sh: revise recommentation after doc maintenance [#2866]
- docs/docinfo.xml.in: add heading comment about (re-)generation [#2832, #2866]
- docs/docinfo.xml.sh: allow to populate a new docinfo.xml variant from scratch [#2866, #2832]
- docs/docinfo.xml.sh: allow to customize DOCINFO_OLDEST_TAG [#2866, #2832]
- docs/Makefile.am: revise inclusion of ../ci_build.adoc(-parsed) into qa-guide [#2866]

### 2.136. 2025-03-28 Scott Shambarger <devel@shambarger.net>

- clients/upsc.c: upsc: Minor fix to error message

### 2.137. 2025-03-28 Jim Klimov <jimklimov+nut@gmail.com>

- docs/ci-farm-do-setup.adoc, docs/nut.dict: populate DigitalOcean chapters with text adapted from #2192
- docs/configure.txt: nut *.pc files may deliver RPATH settings; detail what this is about and how to disable if this causes issues [#2782, #2865]
- UPGRADING.adoc, docs/nut.dict: UPGRADING.adoc: nut *.pc files may deliver RPATH settings; detail how to disable if this causes issues [#2782, #2865]
- Makefile.am, docs/maintainer-guide.txt: introduce "make dist-files" to prepare the set in one go

### 2.138. 2025-03-27 Jim Klimov <jimklimov+nut@gmail.com>

- m4/ax_realpath_lib.m4: fix library search path detection for mingw/MSYS * lacked separation into lines * on MSYS2 might have "C:/mingw/…" patterns
- configure.ac: for --enable-ldflags-nut-rpath(-cxx)=auto consult DEFAULT_SEARCH_DIRS [#2782] Also report why selection failed or had other comments
- configure.ac: make use of hardcode_libdir_flag_spec(_CXX) vars from LT_INIT to set default LDFLAGS_NUT_RPATH(_CXX) [#2782]
- configure.ac, lib/libnutclient.pc.in, lib/libnutconf.pc.in: separate LDFLAGS_NUT_RPATH_CXX from LDFLAGS_NUT_RPATH [#2782]
- lib/libupsclient-config.in: update license (GPLv2 and newer)
- lib/libupsclient-config.in: also provide optional @LDFLAGS_NUT_RPATH@ [#2782]
- configure.ac, lib/libnutclient.pc.in, lib/libnutclientstub.pc.in, lib/libnutconf.pc.in, lib/libnutscan.pc.in, lib/libupsclient.pc.in: configure.ac, lib/*.in: introduce @LDFLAGS_NUT_RPATH@ to only set rpath when needed and in a way supported by linker [#2782] TODO (later commit): Detect support/format of the linker option if passed
- drivers/mge-hid.c: fix whitespace [#2850]

### 2.139. 2025-03-27 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- drivers/mge-hid.c: eaton_input_eco_mode_auto_on_off_info func fix name

### 2.140. 2025-03-26 RikyPlaza <rikyrod2001@gmail.com>

- drivers/phoenixcontact_modbus.c: fixed typo
- drivers/phoenixcontact_modbus.c: fixed typo
- drivers/phoenixcontact_modbus.c: updated version
- drivers/phoenixcontact_modbus.c: initialized tab_reg and PartNumber variables to 0
- drivers/phoenixcontact_modbus.c: added application exit both mrir on upsdrv_initups fail

### 2.141. 2025-03-26 Jim Klimov <jimklimov+nut@gmail.com>

- docs/ci-farm-do-setup.adoc, docs/nut.dict: docs/ci-farm-do-setup.adoc: add Design trade-offs chapter [#2832]
- NEWS.adoc: announce the new NUT Quality Assurance and Build Automation Guide [#2832]
- docs/qa-guide.adoc, docs/developers.txt: transplant "Build automation tools and scripts" chapter from developers.txt into different sections of qa-guide [#2832]
- ci_build.adoc, docs/Makefile.am, docs/qa-guide.adoc: elaborate the chapter on ci_build.sh [#2832] …with a dedicated document, which was lifted from a chapter originally in docs/developers.txt
- docs/config-prereqs.txt, docs/developers.txt, docs/qa-guide.adoc, docs/user-manual.txt: Various docs: fix references to ci-farm-lxc-setup.txt to be … [#2832]
- docs/ci-farm-lxc-setup.txt, docs/configure.txt, docs/developers.txt, scripts/Windows/Installer/README.adoc, scripts/Windows/README.adoc, scripts/python/app/README.adoc: Various docs: fix references to config-prereqs.txt to be … [#2832]
- docs/Makefile.am: config-prereqs.txt, ci-farm-do-setup.adoc and ci-farm-lxc-setup.txt are no longer among USER_MANUAL_DEPS [#2832]
- docs/qa-guide.adoc: slightly elaborate CI_NUT_SELFTESTS, Jenkins_Dynamatrix_Library and Jenkins_Dynamatrix_Pipeline sections with pointers to info available elsewhere
- docs/nut.dict, docs/qa-guide.adoc: docs/qa-guide.adoc: elaborate the chapter on spellcheck [#2832]
- docs/qa-guide.adoc: elaborate the chapter on static analysis a bit (intro paragraph) [#2832]
- docs/nut.dict, docs/qa-guide.adoc: docs/qa-guide.adoc: elaborate the chapter on shellcheck [#2832]
- docs/documentation.txt, docs/qa-guide.adoc: re-title the document, it covers NUT Build Automation as well [#2832]
- tests/NIT/README.adoc: make a note about envvars used by nit.sh script [#2832]
- docs/qa-guide.adoc: elaborate the chapter on NIT by including its README [#2832]
- docs/qa-guide.adoc: extend the chapters on static analysis and ci_build.sh with references to developers.txt [#2832]
- docs/qa-guide.adoc: default the top_srcdir=.. and use it for include macro [#2832]
- docs/nut.dict, docs/qa-guide.adoc: docs/qa-guide.adoc: elaborate the chapter on valgrind [#2832]
- docs/qa-guide.adoc: move note about leveloffset to top [#2832]
- docs/qa-guide.adoc: elaborate the chapter on GNU Autotools and distcheck [#2832]
- docs/ci-farm-do-setup.adoc: reword the intro
- docs/qa-guide.adoc: asciidoctor (as used in IDEs) dislikes old-style anchors before (old-style) titles
- docs/nut-names.txt, drivers/mge-hid.c, data/cmdvartab: revert "experimental.ecomode.start.auto" [#2708, #2850]

### 2.142. 2025-03-26 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- drivers/mge-hid.c: comment about 9E stuck in ECO
- data/cmdvartab, docs/nut-names.txt, drivers/mge-hid.c: experimental.ecomode.stop.auto function added
- data/cmdvartab, docs/nut-names.txt, drivers/mge-hid.c: autoecomode addon without last function needed for 9E model but then stuck in ecomode

### 2.143. 2025-03-25 Jim Klimov <jimklimov+nut@gmail.com>

- docs/Makefile.am, docs/ci-farm-do-setup.adoc, docs/nut.dict, docs/qa-guide.adoc: Introduce docs/ci-farm-do-setup.adoc (as a chapter of qa-guide) [#2192]
- docs/nut.dict, docs/qa-guide.adoc: docs/qa-guide.adoc: populate the chapter on multi-platform multi-CI-vendor testing
- Jenkinsfile-dynamatrix: extend autotools-based checks to parallelize with "make -j 4"

### 2.144. 2025-03-24 RikyPlaza <rikyrod2001@gmail.com>

- drivers/phoenixcontact_modbus.c: Fixed low battery register reading for TRIO_2G UPS

### 2.145. 2025-03-24 Jim Klimov <jimklimov+nut@gmail.com>

- docs/nut-names.txt: fix outlet.n.protect.status and input.eco.switchable definitions to "opaque string" [#2708]
- data/cmdvartab, drivers/mge-hid.c, drivers/usbhid-ups.c, docs/nut-names.txt: move "ecomode" and "essmode" INSTCMDs into "experimental." namespace [#2708]
- drivers/mge-hid.c: bump © for recent committers
- drivers/usbhid-ups.c: anticipate NULL hidups_item→dfl for commands that require a caller-provided argument (no defaults), or return STAT_INSTCMD_CONVERSION_FAILED
- NEWS.adoc, server/upsd.c, server/upsd.h: server/upsd.{c,h}: handle TRACKING value for STAT_CONVERSION_FAILED [#2184]
- docs/man/upscli_strerror.txt: do not link to self
- drivers/dstate.c: sock_arg(): if INSTCMD returns STAT_INSTCMD_UNKNOWN, let it be known to the TRACKING clients [#656, #2686]

### 2.146. 2025-03-23 Jim Klimov <jimklimov+nut@gmail.com>

- NEWS.adoc, UPGRADING.adoc, docs/man/Makefile.am, docs/man/index.txt, docs/man/upscli_str_add_unique_token.txt, docs/man/upscli_str_contains_token.txt, docs/man/upsclient.txt, docs/nut.dict: docs/man/* et al: document upscli_str_contains_token() and upscli_str_add_unique_token() [#2852, #2859]
- clients/Makefile.am, clients/upsclient.c, clients/upsclient.h, include/common.h: clients/Makefile.am, clients/upsclient.h, include/common.h: re-expose str_add_unique_token() and str_contains_token() with upscli_ prefix to surely avoid link/include conflicts
- clients/Makefile.am, clients/upsclient.h, include/common.h: expose str_add_unique_token() and str_contains_token() for NUT clients who need to parse ups.status

### 2.147. 2025-03-23 Jim Klimov <jim@jimklimov.com>

- scripts/python/app/NUT-Monitor: clarify which implementation gets started in the end [#2845]
- configure.ac: adjust to different builds of Python in subdirs on Solarish platforms [#2845]
- scripts/python/app/NUT-Monitor-py3qt5.in, scripts/python/app/ui/gui-1.3.glade: update translators list with Russian [#2845]
- UPGRADING.adoc, scripts/python/Makefile.am, scripts/python/app/README.adoc, scripts/python/app/locale/fr/fr_FR.UTF-8.po, scripts/python/app/locale/fr_FR.UTF-8, scripts/python/app/locale/it/it_IT.UTF-8.po, scripts/python/app/locale/it_IT.UTF-8, scripts/python/app/locale/ru/ru_RU.UTF-8.po, scripts/python/app/locale/ru_RU.UTF-8: scripts/python/Makefile.am: deliver app/locale symlinks with "xx_XX.UTF-8" naming [#2845] For NUT-Monitor GUI: on some platforms, glib/gtk2 or qt5 require the full stack of names to be addressable this way; on others it is more relaxed.

### 2.148. 2025-03-21 RikyPlaza <rikyrod2001@gmail.com>

- drivers/phoenixcontact_modbus.c: drivers/phoenixcontact.c: sanity check and fix on mrir mistake

### 2.149. 2025-03-21 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/apc_modbus.c, drivers/mge-hid.c, drivers/nutdrv_qx.c, drivers/nutdrv_qx_voltronic.c, drivers/usbhid-ups.c: drivers/{apc_modbus,usbhid-ups,mge-hid,nutdrv_qx,nutdrv_qx_voltronic}.c: convert to buzzmode*() instead of invmode*() [#2708]
- clients/upsmon.c: pollups(), parse_status(), get_var(): consider "(experimental.)ups.mode.buzzwords" instead of "output.inverter.mode" for "vendor:VENDORNAME:MODENAME" containing ECO equivalents [#2708]
- docs/new-drivers.txt, docs/nut.dict, drivers/dstate.c, drivers/dstate.h: drivers/dstate.{c,h}, docs/new-drivers.txt: rename invmode_* methods and data to buzzmode_* [#2708] …and report `experimental.ups.mode.buzzwords` instead of `output.inverter.mode` in dstate
- docs/nut-names.txt: replace `output.inverter.mode` by `ups.mode` and `experimental.ups.mode.buzzwords` [#2708]

### 2.150. 2025-03-20 Jim Klimov <jimklimov+nut@gmail.com>

- docs/documentation.txt: refer to qa-guide [#2192, #2832]
- NEWS.adoc, lib/libnutclient.pc.in, lib/libnutclientstub.pc.in, lib/libnutconf.pc.in, lib/libnutscan.pc.in, lib/libupsclient.pc.in: lib/*.pc.in: propagate RPATH to NUT library installation location (by default not in system prefix) to help third-party clients link with us [#2782]
- Makefile.am: introduce "make spellcheck-interactive-quick" ability
- Makefile.am: maintainer-asciidocs: suggest to spellcheck before committing updated asciidoc macros
- INSTALL.nut.adoc, README.adoc, docs/nut.dict: Update NUT documentation sources with current docs/asciidoc-vars.conf: a6bd83d48 (2025-03-20)
- docs/asciidoc-vars.conf: document that linkdoc may have further args
- Makefile.am: maintainer-asciidocs: really fix handling of lines ending in backslash
- docs/user-manual.txt: highlight that NUT for Windows only ships same clients as POSIX builds
- .gitignore: GitIgnore .adoc-parsed. (e.g. docs/.ChangeLog.adoc-parsed.latest)
- docs/Makefile.am: spellcheck-interactive: update/fix non-reporting of dict changes (when there were none)
- Makefile.am: spellcheck-interactive: require SPELLCHECK_REPORT_MAYBE_UPDATED_DICT=yes only for the last entry, to reduce noise by default
- docs/Makefile.am: spellcheck*: track $(NUT_SPELL_DICT).bak-pre-interactive separately from $(NUT_SPELL_DICT).bak-pre-sorting
- docs/Makefile.am: spellcheck-interactive: do not report "Custom dictionary … may have been updated" all the time, add a way to quiesce that (and check if it actually changed)
- NEWS.adoc: fix announcement of `scripts/external_apis` - they landed into trunk before 2.8.3 release [#2807, #2813]
- lib/libnutconf.pc.in, lib/libnutscan.pc.in: add sysconfdir/statepath/nutuser as in other *.pc.in templates

### 2.151. 2025-03-19 Jim Klimov <jimklimov+nut@gmail.com>

- docs/FAQ.txt, docs/nut.dict: document downgrading OpenSSL capabilities when required [#1899, #1900] Closes: #1900
- server/upsd.c, NEWS.adoc: failure due to getaddrinfo() now reports the disliked host name [#2665] Closes: #2665

### 2.152. 2025-03-17 Jim Klimov <jimklimov+nut@gmail.com>

- INSTALL.nut.adoc, docs/asciidoc.conf, docs/ci-farm-lxc-setup.txt, docs/qa-guide.adoc, docs/user-manual.txt: docs/user-manual.txt et al: drop chapters with config-prereqs.txt and ci-farm-lxc-setup.txt, refer to qa-guide now (also from other docs) [#2832]
- docs/qa-guide.adoc: revise markup to have some contents in sections and pass xmllint [#2832]
- docs/nut-qa.txt, docs/qa-guide.adoc: docs/nut-qa.txt: revise markup to be a chapter, not book [#2832]
- docs/Makefile.am: refactor QA_GUIDE_DEPS [#2192, #2832]
- docs/.gitignore, docs/Makefile.am, docs/qa-guide.adoc: docs/Makefile.am: introduce docs/qa-guide.adoc (skeleton so far) [#2192, #2832]
- docs/Makefile.am: support building from *.adoc (not only *.txt) origins
- docs/Makefile.am: depend .prep-src-docs on Makefile too [#2825]
- docs/user-manual.txt: formulate a NUT Support Policy (same as in /README.adoc)
- README.adoc: formulate a NUT Support Policy
- docs/user-manual.txt: import text from README.adoc about support for older systems
- docs/nut.dict, docs/user-manual.txt: docs/user-manual.txt: update about Windows and third-party distributions

### 2.153. 2025-03-16 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/nutdrv_qx_voltronic.c: invmode_set() voltronic eco and eco_adv states [#2708]
- drivers/nutdrv_qx.c: upsdrv_updateinfo(): add invmode_init/commit() into the loop [#2708]
- drivers/mge-hid.c: convert to use invmode_set() [#2708]
- drivers/usbhid-ups.c: upsdrv_updateinfo(): add invmode_init/commit() into the loop [#2708]
- clients/upsmon.c, common/nutconf.cpp, common/nutwriter.cpp: comment about ECO/NOTECO use for notifications even if not via ups.status [#2708]
- docs/man/nut.exe.txt: fix markup
- docs/man/Makefile.am: include index.html to DIST_ALL_HTML_PAGES [#2825]
- docs/man/Makefile.am: introduce dist-html:DIST_ALL_HTML_PAGES and dist-man:DIST_ALL_MAN_PAGES goals [#2842]
- docs/man/Makefile.am: populate DIST_ALL_HTML_PAGES [#2842]
- docs/man/Makefile.am: revise DIST_ALL_PAGES into DIST_ALL_MAN_PAGES; differentiate from DIST_ALL_HTML_PAGES [#2842]
- ci_build.sh: typo fix

### 2.154. 2025-03-15 Jim Klimov <jimklimov@gmail.com>

- docs/man/Makefile.am: consider index.html part of HTML_MANS [#2825]
- docs/man/Makefile.am: .prep-src-docs: depend also on Makefile [#2825]

### 2.155. 2025-03-15 Jim Klimov <jimklimov+nut@gmail.com>

- docs/man/index.txt: reference nut.exe and NUT-Monitor tools pages added since NUT v2.8.2 release
- docs/nut.dict: cover docs/man/index.txt spelling [#2825]
- configure.ac: double-check if we care about DOC_CANNOTBUILD_LIST contents for particular document types [#2842]
- docs/man/Makefile.am: avoid building mans even if HAVE_ASCIIDOC but KNOWN_UNABLE_MANS [#2842]
- docs/man/Makefile.am: do not default to ALL_TGT\+=all-man if KNOWN_UNABLE_MANS [#2842]
- configure.ac: track and report have_disted_doc_man=yes-placeholder (for distcheck-ci sub-builds) [#2842]
- docs/man/Makefile.am: do not default to FAKE_PAGES_BUMP_SRC also if DOC_INSTALL_DISTED_MANS [#2842]
- docs/man/Makefile.am: do not default to FAKE_PAGES_BUMP_SRC if KNOWN_UNABLE_MANS [#2842]
- Makefile.am: introduce distcheck-light-DIST_ALL_PAGES to simplify recipes that tolerate placeholders for pre-built man pages [#2842]
- Makefile.am: distcheck-fake-man: be sure to pass through caller’s DISTCHECK_FLAGS (if any) [#2842]
- configure.ac: maintain DOC_CANNOTBUILD_LIST as we go, based on performed test results [#2843]
- configure.ac: report ultimate DOC_BUILD_LIST/DOC_CANNOTBUILD_LIST/DOC_SKIPBUILD_LIST [#2843]
- configure.ac: track KNOWN_UNABLE_MANS more intensively [#2842]
- configure.ac: clarify that subsequent "build specific documentation" NUT_REPORT_FEATURE is about the ability (aligned with caller request) [#2842]
- Makefile.am, docs/Makefile.am, docs/man/Makefile.am: move docs/man to SUBDIRS of main Makefile; avoid two definitions of "all" goal there [#2842, #2825]
- configure.ac: clarify that initial "build and install documentation" NUT_REPORT_FEATURE is about the caller request (may be auto, etc.) [#2842]
- NEWS.adoc, UPGRADING.adoc: document "make distcheck-ci" and "distcheck-fake-man" [#2842]
- Makefile.am: introduce dist-ci and dist-fake-man goals for good measure [#2842]
- configure.ac, Makefile.am: track if this env is KNOWN_UNABLE_MANS [#2842]
- docs/man/Makefile.am: add index.txt to SRC_ALL_PAGES Fix generation of index.html which on published nut-website was > Last updated 2023-09-14 14:43:49 UTC — Network UPS Tools 2.8.0.1
- docs/man/Makefile.am: add index.txt to SRC_ALL_PAGES Fix generation of index.html which on published nut-website was > Last updated 2023-09-14 14:43:49 UTC — Network UPS Tools 2.8.0.1

### 2.156. 2025-03-14 RikyPlaza <rikyrod2001@gmail.com>

- drivers/phoenixcontact_modbus.c: removed battery.charge for TRIO UPS since not available.
- drivers/phoenixcontact_modbus.c: fixed connection method
- drivers/phoenixcontact_modbus.c: new partnumber calculation method
- drivers/phoenixcontact_modbus.c: drivers/phoenixcontact_modus.c: corrections
- drivers/phoenixcontact_modbus.c: corrections
- drivers/phoenixcontact_modbus.c: updated version
- drivers/phoenixcontact_modbus.c: Updated alarms with supplier info.
- drivers/phoenixcontact_modbus.c: Update addresses with supplier information.

### 2.157. 2025-03-13 Jim Klimov <jimklimov+nut@gmail.com>

- docs/nut-versioning.adoc: document some consumers of data derived from gitlog2version.sh script [#1949]
- docs/nut-versioning.adoc: mention NUT versioning with even/odd minors until 2.6, per README.adoc [#1949]
- README.adoc: revise older approach to NUT versioning (as obsolete) and refer to docs/nut-versioning.adoc [#1949]
- docs/nut-versioning.adoc: document the nut_version.h macros derived from gitlog2version.sh script [#1949]
- docs/nut-versioning.adoc, docs/nut.dict: document the configure.ac variables derived from gitlog2version.sh script [#1949]
- docs/nut-versioning.adoc, docs/nut.dict: document the gitlog2version.sh script and its variables [#1949]
- docs/developers.txt: refer to nut-versioning with three-arg form of linkdoc() [#1949]
- docs/nut-versioning.adoc, docs/Makefile.am, docs/developer-guide.txt, docs/maintainer-guide.txt, docs/nut.dict, NEWS.adoc, UPGRADING.adoc, tools/gitlog2version.sh: document historic and current approaches to NUT versioning [#2842, #1949]
- tools/gitlog2version.sh: report NUT_VERSION_QUERY=TRUNK [#1949]
- tools/gitlog2version.sh, configure.ac: fix SEMVER generation to more closely follow the standard [#2842, #1949] There should not be two dash-separated components, this confuses some packaging tools. Inspired by discussion in https://github.com/networkupstools/nut/pull/2842#issuecomment-2719241404
- scripts/python/app/README.adoc: note localization of standard UI elements made by the framework itself
- scripts/python/app/locale/NUT-Monitor.pot, scripts/python/app/locale/fr/fr.po, scripts/python/app/locale/it/it.po, scripts/python/app/locale/ru/ru.po, scripts/python/app/ui/gui-1.3.glade, scripts/python/app/ui/gui-1.3.glade.h: scripts/python/app/{ui,locale}/*: maintain plaintext (py2gtk2) and HTML (py3qt5) translations of About dialog text
- scripts/python/app/NUT-Monitor-py2gtk2.in, scripts/python/app/README.adoc: scripts/python/app/NUT-Monitor-py2gtk2.in: TRY TO fix UTF-8 resource reading in Windows
- scripts/python/app/README.adoc, docs/nut.dict: note environments to test both py2 and py3 versions
- scripts/python/app/NUT-Monitor-py2gtk2.in: fix rewriting of About dialog text
- scripts/python/app/NUT-Monitor-py2gtk2.in: fix list copy syntax for Python2
- scripts/python/app/NUT-Monitor-py2gtk2.in: change to script dir, to find localization files reliably
- scripts/python/app/NUT-Monitor-py3qt5.in: change to script dir, to find localization files reliably

### 2.158. 2025-03-12 Scott Shambarger <devel@shambarger.net>

- clients/upsc.c, clients/upsclient.c, clients/upsclient.h, clients/upscmd.c, clients/upsimage.c, clients/upslog.c, clients/upsmon.c, clients/upsrw.c, clients/upsset.c, clients/upsstats.c: clients: update clients to timeout in 10 secs, try SSL Many clients currently have no network timeout; connections can take several minutes to fail (or longer if multiple addresses are resolved). Added upscli_set_default_timeout() to assign a default timeout, honored by upscli_connect(). Adds a 10 second timeout to all client connections. upsmon especially benefits from the patch as one unavailable ups could delay processing of other ups’s, and also cause the watchdog to fire. upsc has a new option -W <secs> to set the network timeout. Many ups clients were also not attempting SSL, even ones that use authentication to perform actions. Patch adds flag to attempt (but not require) it.
- m4/nut_check_python.m4: use sysconfig to find site-packages python3.2\+ supports sysconfig module to locate the site-packages. Patch to use it if it’s available. Also, minor fix for --without-python still running python.

### 2.159. 2025-03-12 Jim Klimov <jimklimov+nut@gmail.com>

- scripts/python/app/README.adoc: clarify what was wrong with localization of Py3 variant
- NEWS.adoc, scripts/python/app/NUT-Monitor, scripts/python/app/README.adoc: Revert "scripts/python/app/*, NEWS.adoc: NUT-Monitor-py3qt5 localization issues are resolved, prefer it if both implementations are available" This reverts commit 64d82b5de2878d539c1b0fca78ae0e7d88760523 : stash for future completion. Currently there are still problems with menu names, dialog field labels, etc.
- NEWS.adoc, scripts/python/app/NUT-Monitor, scripts/python/app/README.adoc: scripts/python/app/*, NEWS.adoc: NUT-Monitor-py3qt5 localization issues are resolved, prefer it if both implementations are available
- NEWS.adoc, scripts/python/app/NUT-Monitor-py2gtk2.in, scripts/python/app/NUT-Monitor-py3qt5.in, scripts/python/app/README.adoc, scripts/python/app/locale/NUT-Monitor.pot, scripts/python/app/locale/fr/fr.po, scripts/python/app/locale/it/it.po, scripts/python/app/locale/ru/ru.po, scripts/python/app/ui/aboutdialog1.ui, scripts/python/app/ui/gui-1.3.glade, scripts/python/app/ui/gui-1.3.glade.h: scripts/python/app/, NEWS.adoc: bump NUT-Monitor-py releases to 2.0.2
- docs/man/Makefile.am: be sure to use builddir/doc/man in LIST_FILES/FAKE_FILES/FAKE_FILES_RM/distcheck-light-DIST_ALL_PAGES snippets [#2842]
- Makefile.am: be sure to use builddir/doc/man in distcheck-* variant setups [#2842]
- scripts/python/app/NUT-Monitor-py3qt5.in: troubleshoot the localization data path of About dialog
- scripts/python/app/locale/NUT-Monitor.pot, scripts/python/app/locale/fr/fr.po, scripts/python/app/locale/it/it.po, scripts/python/app/locale/ru/ru.po, scripts/python/app/ui/aboutdialog1.ui, scripts/python/app/ui/gui-1.3.glade, scripts/python/app/ui/gui-1.3.glade.h: scripts/python/app/{ui,locale}/*: adjust localization of About dialog with HTML Markup of aboutdialog1.ui file [#722]
- scripts/python/app/NUT-Monitor-py2gtk2.in, scripts/python/app/NUT-Monitor-py3qt5.in: scripts/python/app/NUT-Monitor-{py2gtk2,py3qt5}.in: gui_about_dialog(): substitute NUT_WEBSITE_BASE and PACKAGE_VERSION in real time [#722]
- scripts/python/app/NUT-Monitor-py3qt5.in: whitespace fixes
- docs/man/Makefile.am: all (automake): mention .prep-src-docs among BUILT_SOURCES so it is made early [#2825, #2842]
- docs/man/Makefile.am: all: comment its overriding place in decision chain [#2825, #2842]
- docs/man/Makefile.am: all: tell more about when we do nothing [#2825, #2842]
- docs/man/Makefile.am: do not list DIST_ALL_PAGES into BUILT_SOURCES, this may cause generation before we are well ready for it; EXTRA_DIST should suffice for our issue #2842
- Makefile.am: distcheck-*: report starting the scenario, and a successful finish with overview of what it was [#2842]
- Jenkinsfile-dynamatrix: "make distcheck-ci" in plain autotools checks [#2842]
- ci_build.sh: introduce DISTCHECK_TGT to guess the best variant for this build agent and BUILD_TYPE (or use the caller-provided value) [#2842]
- Makefile.am: introduce distcheck-fake-man and distcheck-ci goals [#2842]
- docs/man/Makefile.am: rectify "make clean" where we use placeholders [#2842]
- docs/man/Makefile.am: fix DIST_ALL_PAGES for serial drivers [#2842]
- docs/man/Makefile.am: check for prebuilt man pages in source dir too [#2842] Concerns fake placeholder files for `make distcheck-light` too.
- drivers/ecoflow-hid.c: update comments about some readings which behave differently in various tested devices [#2837]

### 2.160. 2025-03-11 Jim Klimov <jimklimov+nut@gmail.com>

- docs/man/Makefile.am: Only clean away build products, and track them as BUILT_SOURCES, if we can reproduce them [#2842]
- drivers/ecoflow-hid.c: fix battery.runtime - needs ecoflow_runtime_conversion_lkp
- docs/man/Makefile.am: update comment regarding dist-warning
- Makefile.am, docs/man/Makefile.am: fix "make distcheck-light" to pass on systems without asciidoc (use distcheck-light-DIST_ALL_PAGES to fake pre-built man pages) [#2842]
- configure.ac: NUT_REPORT the DOC_INSTALL_DISTED_MANS value [#2842]
- docs/man/Makefile.am: do not fail a "make dist" attempt just because !WITH_MANS !SKIP_MANS, only warn about it [#2842] We may have the pages from tarball, or actually know about the tools needed to build them.
- docs/Makefile.am, docs/man/Makefile.am: parameterize NUT_*_BASE and *_VERSION substitutable from templates [#722]
- docs/man/Makefile.am: redefine construction of man page lists to track ALL those we know about (for dist) vs. those we want in this build configuration [#2842, #2829]
- docs/man/Makefile.am: fix nhs_ser.txt inclusion into SRC_SERIAL_PAGES (sources - always)
- docs/man/Makefile.am: fix LIBNUTCLIENT_*_DEPS markup
- docs/man/Makefile.am: introduce helper recipes to print-X and check-list-X (where X in [MAN_MANS, HTML_MANS, SRC_ALL_PAGES])
- docs/man/Makefile.am: line-wrap SRC_TOOL_PAGES/MAN_TOOL_PAGES/HTML_TOOL_MANS definitions [#2842]
- docs/man/Makefile.am: group manXXXdir and manXXX_DATA pre-definitions on top of file [#2842]
- docs/man/Makefile.am: Make sure pages are built for the dist archive [#2842]
- tools/nut-scanner/Makefile.am: note that "make dist" can cause libupsclient.la compilation [#2842]
- include/Makefile.am, clients/Makefile.am: announce GENERATE-HEADER events to help recipe tracing [#2842]

### 2.161. 2025-03-10 Jim Klimov <jimklimov+nut@gmail.com>

- …/python/app/locale/fr/LC_MESSAGES/NUT-Monitor.mo, …/python/app/locale/it/LC_MESSAGES/NUT-Monitor.mo, …/python/app/locale/ru/LC_MESSAGES/NUT-Monitor.mo: scripts/python/app/locale/{fr,it,ru}/LC_MESSAGES/NUT-Monitor.mo: regenerate due to changes in translation sources [#722] Note that we keep verbatim @NUT PACKAGE_VERSION@ and @NUT_WEBSITE_BASE@ in text (About dialog) and substitute them in real-time. This allows us to keep the document wording static, while certain strings depend on build circumstances. Unlike other resources, this dialog is shared with py2 code which is not localized in same manner as sequences).
- docs/config-prereqs.txt, docs/nut.dict: suggest MacOS tuning for being a CI agent
- drivers/mge-hid.c, NEWS.adoc: support Eaton 5S1200AU [#2380]
- docs/man/Makefile.am: roll back changes about *.txt-prepped [#2842]
- docs/nut.dict: update for index.txt contents [#2842]

### 2.162. 2025-03-09 Scott Shambarger <devel@shambarger.net>

- docs/man/Makefile.am, scripts/external_apis/Makefile.am: docs/Makefile.am: fixed make dist, fix custom man sections `make dist` was failing to build all man pages. Changed how the *-prepped file dependencies are handled to fix. Custom man sections were being implemented in configure, but automake runs before they are chosen, so the Makefile.in were missing the install logic. Changed to use _DATA targets with directories that can be chosen at configure time Also added index.txt to DIST target to fix distcheck Fixed substitution bug in external_apis/Makefile.am

### 2.163. 2025-03-09 Jim Klimov <jimklimov+nut@gmail.com>

- scripts/python/app/NUT-Monitor-py3qt5.in, scripts/python/app/locale/NUT-Monitor.pot, scripts/python/app/locale/fr/fr.po, scripts/python/app/locale/it/it.po, scripts/python/app/locale/ru/ru.po, scripts/python/app/ui/aboutdialog1.ui, scripts/python/app/ui/gui-1.3.glade, scripts/python/app/ui/gui-1.3.glade.h: scripts/python/app/{ui,locale}/*: revise About dialog and license info [#722] * refer to @NUT_WEBSITE_BASE@ and @PACKAGE_VERSION@; * add NUT Community copyright; * fix phrasing and markup; * aboutdialog1.ui: render NUT_WEBSITE_BASE as a clickable link * update link to lestat original page (now it is a wiki)
- tools/nut-usbinfo.pl: find_usbdevs(): skip subdirs for now
- data/driver.list.in: fix the entry for DEXP LCD EURO 1200VA [#2839]
- Floating-point numbers are dot-separated * Add the comment with a link to PR for details
- NEWS.adoc, UPGRADING.adoc, docs/nut.dict: announce the fix for DEXP and novendir in nutdrv_qx [#2839]
- tests/generic_gpio_liblocal.c: protect against builds with unknown WITH_LIBGPIO_VERSION [#2833]
- tests/Makefile.am: fix builds of gpiotest against different libgpiod implementations [#2833]
- drivers/generic_gpio_libgpiod.c, drivers/generic_gpio_libgpiod.h, tests/generic_gpio_liblocal.c, tests/generic_gpio_utest.c: Merge remote-tracking branch modrisb-gpiod2/master into issue-2833\+modrisb Take advantage of WITH_LIBGPIO_VERSION defined by NUT configure.ac to select the code path and signal it in DRIVER_VERSION for troubleshooting.
- drivers/generic_gpio_libgpiod.c: protect against builds with unknown WITH_LIBGPIO_VERSION [#2833]
- m4/nut_check_libgpiod.m4, drivers/generic_gpio_libgpiod.c: report the WITH_LIBGPIO_VERSION_STR a driver was built against [#2833]

### 2.164. 2025-03-08 mcrodar <mcrodar@gmail.com>

- data/driver.list.in, drivers/nutdrv_qx.c: use novendor param as flag for don’t read vendro name, need for dexp ups

### 2.165. 2025-03-08 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/apc_modbus.c: use invmode_{init,get,set,commit}() methods for ECO state [#2708]
- drivers/usbhid-ups.c: comment ECO and ESS status handling as obsolete [#2708]
- docs/new-drivers.txt, docs/nut.dict, drivers/dstate.c, drivers/dstate.h: drivers/dstate.{c,h}, docs/new-drivers.txt, docs/nut.dict: introduce invmode_{init,get,set,commit}() methods [#2708]
- data/driver.list.in: list Gtec ZP120N as supported with updated nutdrv_qx [#2818, #2834]
- drivers/ecoflow-hid.c: complete the merge of parallel developments [#2740, #2837] * import back comments about findings in PR #2740,
- apply reasonable number precision and HU_FLAG* where two codebases differed, * clean up "unmapped." entries that are actually exposed as standard or experimental data points, or in some cases drop the "experimental." ones (it is easy to build code with settings which would show the same values as "unmapped.*")

### 2.166. 2025-03-07 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/ecoflow-hid.c: merge "unmapped" entries and comments from ykuksenko variant [#2837]
- drivers/ecoflow-hid.c: uncomment "unmapped" entries already hidden by "#if WITH_UNMAPPED_DATA_POINTS" [#2837]
- drivers/ecoflow-hid.c: change ECOFLOW_HID_VERSION to double digits; add © of contributors [issue #2735, PRs #2740, #2837]
- NEWS.adoc, docs/nut.dict, data/driver.list.in: Ecoflow device support added [issue #2735, PRs #2740, #2837]
- drivers/usbhid-ups.c: bump DRIVER_VERSION due to EcoFlow support [issue #2735, PRs #2740, #2837]

### 2.167. 2025-03-06 M. Greyson Christoforo <grey@christoforo.net>

- drivers/ecoflow-hid.c: fix voltage type
- drivers/ecoflow-hid.c, ecoflow-hid.h ⇒ drivers/ecoflow-hid.h, ecoflow-hid.c: mapping attempted
- drivers/Makefile.am, drivers/usbhid-ups.c, ecoflow-hid.c, ecoflow-hid.h: i followed the gen-usbhid-subdriver.sh recipe. needs mapping

### 2.168. 2025-03-06 Jim Klimov <jimklimov+nut@gmail.com>

- clients/status.h: note that "ECO" in "ups.status" should no longer happen with in-tree code [#2708]
- clients/upsmon.c: pollups(), parse_status(), parse_status(), get_var(): consider "output.inverter.mode" for "vendor:VENDORNAME:MODENAME" containing ECO equivalents [#2708]
- clients/upsmon.c: get_var(): only strcmp() for further tokens if none before matched Avoid extra work in the loop

### 2.169. 2025-03-05 Jim Klimov <jimklimov+nut@gmail.com>

- NEWS.adoc, docs/nut.dict: introduce WITH_LIBGPIO_VERSION [#2833] Should also serve for actual fix of the drivers for new libgpio API, but not sure if that would land in NUT v2.8.3 timeframe or after the release.
- configure.ac, m4/nut_check_libgpiod.m4: introduce detection and exposure to C code of WITH_LIBGPIO_VERSION [#2833]

### 2.170. 2025-03-04 Lukáš Turek <lukas@turek.eu>

- drivers/nutdrv_qx_gtec.c: multiple status letters can be reported at once

### 2.171. 2025-03-03 Jim Klimov <jimklimov+nut@gmail.com>

- docs/nut-names.txt, docs/nut.dict: docs/nut-names.txt: propose and describe names for `output.inverter.mode{,.description}` and `output.inverter.latency` [#2708]
- docs/nut-names.txt: clarify "device.usb.version" description
- docs/nut-names.txt: fix NOTE block for `battery.charger.status` [#2708]
- include/common.h, common/common.c, drivers/dstate.c: generalize status_set() into str_add_unique_token() with a custom callback, and status_get() into str_contains_token() [#2708]
- tests/driver_methods_utest.c: check that ignorelb works (now via callback from status_set()) [#2708]
- tools/nutconf/nutconf-cli.cpp: avoid "NULL" keyword in C+\+ code
- tools/nutconf/nutconf-cli.cpp: teach the tool some respect to NUT_CONFPATH; update a few comments
- UPGRADING.adoc: document `--with-dev-libnutconf` option and its impact on packaging [#2828]

### 2.172. 2025-03-02 Jim Klimov <jimklimov+nut@gmail.com>

- configure.ac, docs/configure.txt: change interaction of --with-all and --with-dev-libnutconf The original independence of settings led to CI failures, where explicit `--with-nutconf=auto --with-all=yes` correctly turned `with_nutconf` to `no` on systems or build scenarios without the required level of C+\+ support, but the defaulted `with_dev_libnutconf` became `yes` (following `with_all`).
- docs/configure.txt: --with-dev-libnutconf: update the description
- docs/configure.txt: --with-dev: clarify the effect of --without-dev
- docs/configure.txt: --with-dev-libnutconf: clarify use of "auto" value
- docs/configure.txt: add intro chapter about autotools and typical syntax of configure options

### 2.173. 2025-03-01 Jim Klimov <jimklimov+nut@gmail.com>

- scripts/Windows/build-mingw-nut.sh: when the proto area installation completes, report SUCCESS more visibly
- common/setenv.c: update closing comment
- common/Makefile.am: avoid @LTLIBOBJS@ in libnutconf_la_LIBADD because we already use it in libcommonclient.la
- ci_build.sh: add alias for "windows" build
- common/Makefile.am, configure.ac, docs/configure.txt, docs/nut.dict, include/Makefile.am, lib/Makefile.am, tests/Makefile.am: configure.ac, */Makefile.am: introduce WITH_DEV_LIBNUTCONF (to deliver lib\+headers) and WITH_LIBNUTCONF (at least one of tool or lib)
- common/Makefile.am: add libnutconf_la version-info declaration (0.1.0 experimental) to generate the shared object file
- common/Makefile.am: EXTRA_DIST *.cpp sources if not depending on rolling them into a library
- drivers/Makefile.am: "if SOME_DRIVERS": fix the obsolete extraneous addition of "skel"
- Makefile.am, clients/Makefile.am, docs/Makefile.am, drivers/Makefile.am, server/Makefile.am: */Makefile.am: annotate automake else/endif with respective condition names
- ci_build.sh: typo fixes
- docs/configure.txt: document --with-nut-scanner and --with-nutconf options
- NEWS.adoc, docs/nut.dict: announce automake optimization for NUT `make -j` [#2825]
- drivers/Makefile.am: reword default NUTSW_DRIVERLIST_DUMMY_UPS to avoid automake rewrites and actually not-conflict building dummy-ups twice
- Makefile.am: all/drivers: avoid passing empty KEY= via SUBDIR_TGT_MAKEFLAGS

### 2.174. 2025-02-28 Jim Klimov <jimklimov+nut@gmail.com>

- Makefile.am: revise comments for all-drivers definition
- Makefile.am, clients/Makefile.am: clients/Makefile.am: include libupsclient-version.h into all-libs-local deliverables Dependency on it from some consumers might cause unwanted parallel builds of same directory.
- scripts/Windows/Makefile.am: code here does not directly consume nut_version.h
- Makefile.am, include/Makefile.am: include/Makefile.am: formally declare "all-libs-local: nut_version.h" for consistency
- Makefile.am: ensure prep-src-docs/docs are built before main all/docs rule (just in case)
- Makefile.am: define prep-src-docs/docs/man and prep-src-docs/docs more neatly
- Makefile.am: update comments for SUBDIR_* dependencies, to clarify who depends on whom (as of now)
- Makefile.am: SUBDIRS_ALL_RECURSIVE: re-order all/docs (with heavy pdf/html renders) to start before all/docs/man (easier parallelization with cheap artifacts)
- docs/Makefile.am: order ChangeLog.{html,pdf} first, so in parallel builds it can have one core while the rest of docs take turns on another
- scripts/external_apis/Makefile.am: revise "make clean" to not break subsequent "make all"
- docs/Makefile.am: revise "make clean" to not break subsequent "make all"
- Makefile.am, docs/Makefile.am, docs/man/Makefile.am: formalize definition and use of prep-src-docs targets
- Makefile.am: reorder SUBDIRS_ALL_RECURSIVE so docs are in the end, after binary products (like in SUBDIRS) Some make implementations troll us, with sub-makes running their goals apparently in parallel, but the top-level goals (or rather dependencies of a goal?) like the ones we list here happen to be handled largely sequentially. On such underwhelming "make"'s, we prefer to get programs built first. On better ones (e.g. recent GNU make versions) we do actually get unrestrained parallelism.
- Makefile.am, drivers/Makefile.am: introduce NUTSW_DRIVERLIST_DUMMY_UPS and SUBDIR_TGT_MAKEFLAGS to let "all/drivers" be built independently of (and not including) dummy-ups, so the new "all-drivers" target can parallelize the two sets of goals

### 2.175. 2025-02-27 Jim Klimov <jimklimov@gmail.com>

- docs/Makefile.am, docs/man/Makefile.am: fix "find … -newer" tests Barring errors (like files not found), `find` always exits with 0; it is the stdout that we should check (like we do everywhere else)
- docs/man/Makefile.am: .prep-src-docs: avoid overlapping runs from docs/Makefile.am

### 2.176. 2025-02-27 Jim Klimov <jimklimov+nut@gmail.com>

- docs/Makefile.am: .adoc.adoc-parsed: double-check if target already exists and is new enough; report more with MAINTAINER_ASCIIDOCS_CHANGELOG_DEBUG=yes
- Makefile.am: Makefile: dummy-ups should depend on all-libs-local/drivers too
- Makefile.am: depend both all/docs and all/docs/man on .prep-src-docs/docs/man to complete first
- docs/man/Makefile.am: introduce configurable MAINTAINER_DOCS_PREP_MAN_DELAY for docs/man/.prep-src-docs
- docs/Makefile.am: avoid `find` reporting that file does not exist
- Makefile.am: all/docs: log-trace pre-creation of ChangeLog artifacts (if we do it)
- Makefile.am: forfeit SUBDIR_TGT_RULE-driven pre-make of ChangeLog.adoc in . or abs_top_builddir Some make implementations mangle the build argument of that form, and we try to change into an absurd subdir.
- Makefile.am: all/docs: make MAINTAINER_ASCIIDOCS_CHANGELOG_DELAY configurable
- Makefile.am: all/docs: pre-create ChangeLog.adoc-parsed as a singular target before iterating into multiple DOC_BUILD_LIST goals; use MAINTAINER_ASCIIDOCS_CHANGELOG_DELAY to reduce or eliminate the wait
- docs/Makefile.am: ChangeLog.adoc: make MAINTAINER_ASCIIDOCS_CHANGELOG_DELAY configurable (or skippable); log-trace it better when sleeping on it
- Makefile.am: fix recipe for dummy-ups/drivers to honour EXEEXT
- Makefile.am: document circumstances of dummy-ups/drivers target
- docs/Makefile.am: ChangeLog.adoc: revise loop waiting for competition Avoid `expr` returning code 1 because resulting number was 0 (on some platforms)
- docs/Makefile.am: fix re-runs of DOC-HTML-CHUNKED with some "make" implementations Also use TABs to report DOC-* waypoints
- docs/man/Makefile.am: add rules for NUT-Monitor-py2gtk2.html and NUT-Monitor-py3qt5.html
- docs/Makefile.am: ChangeLog.*: hide filesystem detail troubleshooting behind MAINTAINER_ASCIIDOCS_CHANGELOG_DEBUG toggle
- Makefile.am: ChangeLog: do not update builddir/ChangeLog from srcdir/ChangeLog if already identical Also revise build log reporting of different use-cases
- Makefile.am: ChangeLog: keep original timestamp when Using distributed ChangeLog file from sources
- docs/Makefile.am: ChangeLog.adoc: revise reporting of (re-)generation
- docs/Makefile.am: .ChangeLog.adoc-parsed.latest: fix make syntax
- docs/Makefile.am: make sure to create a relevant .ChangeLog.adoc-parsed.latest as soon as possible
- Makefile.am: $(abs_top_builddir)/ChangeLog: fix log-tracing of cases where we do (re-)generate the original file from Git metadata

### 2.177. 2025-02-26 Jim Klimov <jimklimov+nut@gmail.com>

- common/Makefile.am, configure.ac, include/Makefile.am, lib/.gitignore, lib/Makefile.am, lib/libnutconf.pc.in: PoC: Introduce delivery of libnutconf.pc and library itself * FIXME: Enable SO build, API version, etc. like in clients/Makefile.am and nut-scanner * Headers somewhere there too
- docs/Makefile.am: try to untangle ChangeLog dynamic vs. repeatable-static dependency
- lib/Makefile.am: Revert "lib/Makefile.am: be sure to EXTRA_DIST the template files" This reverts commit da2874be836fd1b81ff3afcc5052fdb1cb5a4c47 - breaks "make distcheck" (somehow interferes with "make dist" done inside its _build/sub dir).
- common/Makefile.am: be quieter about $(builddir)/common.c re-runs, but report the first time it is done
- common/Makefile.am: remove symlink $(builddir)/common.c when we "make clean"
- common/Makefile.am: avoid re-symlinking $(builddir)/common.c from srcdir when !BUILDING_IN_TREE to avoid extra rebuilds of libs
- common/Makefile.am: it seems that the comments should not be indented in Make syntax
- tools/nut-scanner/Makefile.am: Make sure generated sources are there when needed
- Makefile.am: all-fanout-maybe: fix for shells without comma-separated case clause expansion
- Makefile.am: revise again the dependencies on all-libs* targets, even if transitive
- Makefile.am: add a dev-test target "all-fanout-staged"
- Makefile.am: put out SUBDIRS_* based dependencies to "all-recursive", not just "all" per se In automake, "all: all-recursive" seems to be always defined, so we must be a dependency of that, otherwise we ended up building BOTH the default "all-recursive" and the optimized parallel sub-make, so they wrote into same files and crashed.
- Makefile.am: revise dependencies for SUBDIRS_ALL_RECURSIVE to consider quicker SUBDIRS_ALL_LIBS_LOCAL
- Makefile.am: revise dependency for all/scripts/Windows to follow conditionals in scripts/Windows/Makefile.am (note HAVE_MINGW_RESGEN too)
- scripts/Windows/Makefile.am: streamline use of top_builddir based libcommon.la and nut_version.h
- Makefile.am: refine handling of SUBDIRS_ALL_LIBS_LOCAL
- Makefile.am, clients/Makefile.am, common/Makefile.am, drivers/Makefile.am, tests/Makefile.am, tools/nut-scanner/Makefile.am: */Makefile.am: define a special target for all-libs-local to be (pre-)built
- Makefile.am: revise dependencies of SUBDIR_TGT targets
- Makefile.am: revise dependency of all-recursive/scripts: all/scripts/Windows (target-dependent)
- lib/Makefile.am: annotate automake "else" and "endif" tags
- lib/Makefile.am: be sure to EXTRA_DIST the template files
- Makefile.am, lib/Makefile.am: all/lib is only about metadata, not actual libs
- Makefile.am: nutconf depends on (lib)nut-scanner
- Makefile.am: SUBDIR_TGT_RULE: revise progress messages, report failures more visibly
- Makefile.am: re-introduce (commented away) re-make attempt of "doc" after "all"
- Makefile.am: redefine SUBDIRS list to handle docs after code builds On the one hand, code builds are well-parallelized, easy to avoid extra work when re-making, and are more useful in typical development cycles. The ChangeLog HTML/PDF generation is a time-consuming hog when enabled, and with automake’s "all-recursive" implementation handling SUBDIRS only sequentially, it blocks the useful part of build for a long time when we e.g. `git commit` the code changes during development.
- Makefile.am: redefine "all" target to complete "common" dir first, then do "all-recursive" and no longer retry "doc" just-in-case
- docs/Makefile.am, docs/.gitignore: only check HTML and/or PDF renders once (for unmodified sources)
- docs/man/Makefile.am, docs/man/.gitignore: only check man page sources and renders once (for unmodified sources)
- configure.ac, NEWS.adoc: default --with-valgrind=no for now
- scripts/valgrind/.valgrind.supp.in: generalize suppression of "blocks are possibly lost in loss record" in malloc in printf (on OpenIndiana)
- scripts/valgrind/.valgrind.supp.in: "blocks are possibly lost in" printf() called from report_pass() on OpenIndiana [#2823] Example fault reports: 13:27:00 ==228221== 4,104 bytes in 1 blocks are possibly lost in loss record 1 of 1 13:27:00 ==228221== at 0x7FFF64A22: malloc (vg_replace_malloc.c:458) 13:27:00 ==228221== by 0x7FFDC5CAD: _findbuf (in /lib/amd64/libc.so.1) 13:27:00 ==228221== by 0x7FFDAEBDF: _ndoprnt (in /lib/amd64/libc.so.1) 13:27:00 ==228221== by 0x7FFDB112E: printf (in /lib/amd64/libc.so.1) 13:27:00 ==228221== by 0x408F8C: report_pass (in /tmp/jenkins-swarm/jenkins-nutci/nut_nut_PR-2823/tests/driver_methods_utest) 13:27:00 ==228221== by 0x408F55: report_0_means_pass (in /tmp/jenkins-swarm/jenkins-nutci/nut_nut_PR-2823/tests/driver_methods_utest) 13:27:00 ==228221== by 0x40875A: main (in /tmp/jenkins-swarm/jenkins-nutci/nut_nut_PR-2823/tests/driver_methods_utest)
- configure.ac, scripts/Makefile.am, scripts/valgrind/.gitignore, scripts/valgrind/{.valgrind.supp ⇒ .valgrind.supp.in}: scripts/valgrind/.valgrind.supp: rename to .in template so it is easy to resolve in SCRIPTDIR for out-of-tree builds
- configure.ac, NEWS.adoc: default to --with-valgrind=auto [#2823]
- configure.ac: re-order --with-valgrind(=PROG) parameter handling to happen before testing if we can use that implementation (and want to at all)
- configure.ac: refactor test for usable valgrind with a custom program to succeed
- configure.ac: document a problem between some OI versions and Valgrind
- docs/config-prereqs.txt: recommend GDB to be installed on various platforms

### 2.178. 2025-02-25 Jim Klimov <jimklimov+nut@gmail.com>

- docs/man/nutdrv_qx.txt: document the Gtec subdriver/protocol support [#2818]
- drivers/nutdrv_qx_gtec.c: gtec_process_status(): fix setting of ups.alarm, comment about setting of ups.status (multi-token) [#2818]
- drivers/nutdrv_qx_gtec.c: mark gtec_process_status() as a static method [#2818]
- NEWS.adoc, docs/nut.dict: mention nutdrv_qx gtec subdriver was added [#2818]
- drivers/nutdrv_qx.c: bump DRIVER_VERSION due to added Gtec subdriver [#2818]
- tests/Makefile.am: "make all" should build all binaries used by possible "make check" later
- Makefile.am: install-as-root: retry with udevadm if did not do/succeed its systemd unit
- Makefile.am: un-indent the bulk of "install-as-root" implementation
- scripts/external_apis/enphase/enphase-monitor@.service.in: GPLv2 licensed [#2813]

### 2.179. 2025-02-24 Scott Shambarger <devel@shambarger.net>

- scripts/external_apis/enphase/README.adoc, scripts/external_apis/enphase/enphase-monitor.in: scripts/external_apis/enphase/enphase-monitor - GPLv2 licensed

### 2.180. 2025-02-24 Lukáš Turek <lukas@turek.eu>

- drivers/Makefile.am, drivers/nutdrv_qx.c, drivers/nutdrv_qx_gtec.c, drivers/nutdrv_qx_gtec.h: Add nutdrv_qx driver for Gtec ZP120N

### 2.181. 2025-02-24 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/libhid.c: HIDGetItemData(): debug-trace failures due to string_to_path() or FindObject_with_Path() [#2816]
- docs/man/NUT-Monitor.txt, NEWS.adoc, docs/man/Makefile.am: added man page (with aliases) for the `NUT-Monitor{,-py2gtk2,-py3qt5}` Python UI client and its shell wrapper script
- docs/man/Makefile.am: EXTRA_DIST nut.exe.txt if not building it
- scripts/python/app/NUT-Monitor: make PREFER_PY2 configurable as an envvar
- scripts/systemd/nut-driver-enumerator-daemon-activator.path.in, scripts/systemd/nut-driver-enumerator-daemon-activator.service.in, scripts/systemd/nut-driver-enumerator-daemon.service.in, scripts/systemd/nut-driver-enumerator.path.in, scripts/systemd/nut-driver-enumerator.service.in, scripts/systemd/nut-driver.target.in, scripts/systemd/nut-driver@.service.in, scripts/systemd/nut-logger.service.in, scripts/systemd/nut-monitor.service.in, scripts/systemd/nut-server.service.in, scripts/systemd/nut-sleep.service, scripts/systemd/nut-systemd.preset, scripts/systemd/nut.target.in, scripts/systemd/nutshutdown.in: scripts/systemd/*: typo fix in © heading
- docs/nut.dict, scripts/external_apis/Makefile.am, scripts/external_apis/enphase/README.adoc, scripts/external_apis/enphase/enphase-monitor.in: scripts/external_apis/Makefile.am: enable spellcheck of scripts/external_apis/enphase/README.adoc, fix corresponding typos or update the dictionary [#2813]
- scripts/external_apis/enphase/README.adoc: update about tmpfs or not for the enphase data file [#2813]
- scripts/external_apis/enphase/enphase-monitor.in, …/enphase/enphase-monitor@.service.in: scripts/external_apis/enphase/enphase-monitor@.service.in, scripts/external_apis/enphase/enphase-monitor.in: parameterize config/state file locations to defaults with NUT configuration and locations made by package or make-install [#2813]
- …/enphase/enphase-monitor@.service.in: scripts/external_apis/enphase/enphase-monitor@.service.in: add © header, parameterize installed script location and NUT run-time user [#2813]
- NEWS.adoc, configure.ac, docs/configure.txt, docs/nut.dict, scripts/external_apis/Makefile.am: introduce `configure --enable-extapi-enphase` installation [#2813]
- configure.ac, scripts/external_apis/Makefile.am, scripts/external_apis/enphase/.gitignore, …/external_apis/enphase/{enphase-monitor ⇒ enphase-monitor.in}, configure.ac, scripts/external_apis/*: convert enphase script and unit sources into .in templates [#2813]
- scripts/external_apis/README.adoc, scripts/external_apis/enphase/README.adoc: adjust wording in layman English parts of the text [#2813] Note that scripts/external_apis/enphase/README.adoc is not spell-checked because it includes text from a bash script and its many variable names.

### 2.182. 2025-02-23 Scott Shambarger <devel@shambarger.net>

- Makefile.am, NEWS.adoc, configure.ac, docs/nut.dict, scripts/Makefile.am, scripts/external_apis/Makefile.am, scripts/external_apis/README.adoc, scripts/external_apis/enphase/README.adoc, scripts/external_apis/enphase/enphase-monitor, …/external_apis/enphase/enphase-monitor@.service: scripts/external_apis: add example external protocol script New scripts directory for external_apis, including one integrating the Enphase IQ Gateway web-API with NUT.

### 2.183. 2025-02-23 Jim Klimov <jimklimov+nut@gmail.com>

- UPGRADING.adoc, NEWS.adoc, drivers/mge-utalk.c, docs/nut.dict: fix to not status_set() nonstandard values [#2708]
- drivers/dstate.c, tests/driver_methods_utest.c: if a driver uses status_set("ALARM") and later proper alarm_set(), report only the content provided by the latter [#2801, #2708]
- drivers/clone.c, drivers/powerp-txt.c: fix dstate_setinfo() format from "%g" to "%f" to match NUT naming spec [#2807]
- docs/nut-names.txt: add a chapter to define Numeric format for values in NUT reported variables [#2807]
- docs/nut-names.txt: add a note about opaque strings that just happen to convey date/time [#2807]
- drivers/dstate.c, tests/driver_methods_utest.c: fix status_set("ALARM") cases to automatically alarm_commit() if the injected value is all the alarm we have [#2801, #2708]
- drivers/dstate.c, tests/driver_methods_utest.c: track status_set("ALARM") cases to set the ups.status token [#2801, #2708]
- drivers/dstate.c, tests/driver_methods_utest.c: fix that ALARM status would not appear twice: delay status_set("ALARM") effect and make it reasonable [#2801, #2708]
- drivers/dstate.c: status_set()/status_get(): fence extra tracing with #ifdef DEBUG not #if 0 [#2801]
- drivers/dstate.c, tests/driver_methods_utest.c: note that ALARM status may still appear twice [#2801, #2708]
- tests/driver_methods_utest.c: wrap one of test alarms in brackets as some drivers do for readability [#2801, #2708]

### 2.184. 2025-02-21 Jim Klimov <jimklimov+nut@gmail.com>

- Makefile.am, docs/Makefile.am, docs/man/Makefile.am: fix up with a DOCS_NO_MAN option to simplify parallel work from top-level Makefile while allowing legacy "cd docs && make" to still do the right thing

### 2.185. 2025-02-20 Jim Klimov <jimklimov+nut@gmail.com>

- Makefile.am: introduce $(SUBDIRS_ALL_RECURSIVE) and $(SUBDIR_TGT_RULE), and detail the dependencies

### 2.186. 2025-02-14 Jim Klimov <jimklimov+nut@gmail.com>

- Makefile.am: reorder a few top lines and document sequential handling of automake SUBDIRS and how it hurts parallel builds of NUT
- drivers/netvision-mib.c: stash older netvision_output_info[] mapping from before the fix in PR #2803
- NEWS.adoc, UPGRADING.adoc, docs/nut.dict: UPGRADING.adoc, NEWS.adoc: describe fix of drivers/netvision-mib.c [#2803]
- drivers/netvision-mib.c: bump version, fix whitespace in comments [#2803]

### 2.187. 2025-02-14 Bill Elliot <bill@wreassoc.com>

- docs/man/Makefile.am: Additions to docs/man/Makefile.am.

### 2.188. 2025-02-12 Manuel Bouyer <bouyer@antioche.eu.org>

- drivers/netvision-mib.c: netvision-mib: sync netvision_output_info with SOCOMECUPS-MIB.txt The netvision_output_info array doens’t match the upsOutputSource values from SOCOMECUPS-MIB.txt (the only Socomec MIB publically available) and also doesn’t match values observed on our MASTERYS 3/3 SYSTEM which has a Net Vision v6.32 card.

### 2.189. 2025-02-11 Viktor Drobot <linux776@gmail.com>

- drivers/nutdrv_qx.c, drivers/nutdrv_qx.h, drivers/nutdrv_qx_q2.c: Fix battery runtime calculation for Q2 protocol

### 2.190. 2025-02-11 Jim Klimov <jimklimov+nut@gmail.com>

- Makefile.am: hush forced "make docs" and repetitive doc-checks as the recipes were hopefully rectified
- drivers/main.c: avoid declaring "mutex" in WIN32 builds without main() for test mocks [#2708]
- drivers/dstate.c: status_get(): properly handle tokens that are substrings of another [#2708, #2565]
- tests/driver_methods_utest.c: test ups.status sub-token detection [#2708]
- tests/driver_methods_utest.c: test ALARM contents (with dupes) [#2708]
- tests/driver_methods_utest.c: test ALARM status [#2708]
- tests/driver_methods_utest.c: refactor pass.fail reporting [#2708]
- tests/.gitignore, tests/Makefile.am, tests/driver_methods_utest.c, tests/generic_gpio_utest.c: Introduce tests/driver_methods_utest [#2708] Relocated code tried earlier in generic_gpio_utest.c (not as portable a container - far from everyone builds it)
- appveyor.yml: ensure we can create version-less snapshot dir symlink The fault puzzled me though: we do pre-remove .inst whole… [00:36:07] CHECKING if any executable files were installed to locations other than those covered by this recipe, so might not have needed DLLs bundled near them [00:36:08] ln: ./.inst/NUT-for-Windows-x86_64-SNAPSHOT: cannot overwrite directory [00:36:08] Command exited with code 1

### 2.191. 2025-02-11 Bill Elliot <bill@wreassoc.com>

- data/driver.list.in, docs/man/powervar-cx.txt, drivers/powervar-cx.h: Documentation updates.
- drivers/powervar-cs.c, drivers/powervar-cu.c, drivers/powervar-cx.h: Cleaned up for testing.
- drivers/powervar-cs.c, drivers/powervar-cu.c, drivers/powervar-cx.h: USB disconnect/reconnect seems to be working.

### 2.192. 2025-02-10 Jim Klimov <jimklimov+nut@gmail.com>

- docs/new-drivers.txt: describe in ups.status values also that/how ARALM can be added [#2708]
- tests/generic_gpio_utest.c: check that whitespace chars around status_set() args are stripped [#2708]
- drivers/dstate.c, NEWS.adoc: status_set(): if we are reluctantly adding "A FEW TOKENS" at once, recurse to add one by one and so avoid duplicates [#2708] As a side effect, should also strip surrounding whitespace characters.
- drivers/dstate.c: fix status_get(), got inverted maths in a check [#2565, #2708]
- tests/generic_gpio_utest.c: piggy-back to test for duplicates with status_set() [#2708]
- drivers/liebert-gxe.c: do not use whitespace in status_set() args [#2708]
- drivers/bestfortress.c: do not use whitespace in status_set() args [#2708]

### 2.193. 2025-02-09 Viktor Drobot <linux776@gmail.com>

- drivers/nutdrv_qx_innovart31.c, drivers/nutdrv_qx_q2.c, drivers/nutdrv_qx_q6.c: Separate code and variable declarations
- docs/nut.dict, drivers/nutdrv_qx_innovart31.c, drivers/nutdrv_qx_q2.c, drivers/nutdrv_qx_q6.c: Remove phase detection in updateinfo. Calm down spellchecker
- docs/man/nutdrv_qx.txt, docs/nut.dict, docs/nutdrv_qx-subdrivers.txt, drivers/Makefile.am, drivers/nutdrv_qx.c, drivers/nutdrv_qx.h, drivers/nutdrv_qx_blazer-common.c, drivers/nutdrv_qx_blazer-common.h, drivers/nutdrv_qx_innovart31.c, drivers/nutdrv_qx_q2.c, drivers/nutdrv_qx_q2.h, drivers/nutdrv_qx_q6.c, drivers/nutdrv_qx_q6.h: Add basic Q2 and Q6 protocol variants. Improve INNOVART31 protocol

### 2.194. 2025-02-09 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/nutdrv_qx_q2.c: q2_initinfo(): fix formatting string
- drivers/nutdrv_qx_q6.c: q6_initinfo(): fix formatting string
- docs/man/Makefile.am: "make clean all" should remain useful
- NEWS.adoc: introduction of Q2 and Q6 protocol support in nutdrv_qx
- drivers/nutdrv_qx_q6.c: q6_claim(): revise comment
- drivers/nutdrv_qx_q2.c: q2_claim(): revise comment
- drivers/nutdrv_qx.c: bump DRIVER_VERSION for Q2/Q6 addition [#2798]
- docs/man/nutdrv_qx.txt: typo fixes for `nooutstats` [#2798]
- docs/Makefile.am, docs/man/Makefile.am: pass MAN_SECTION* and NUT_WEBSITE_BASE to asciidoc attributes [#722, #2733, #2743] If we ever decide to forgo rewritting of man page numbers and website URLs during creation of *-prepped sources fed into asciidoc (as done by PRs above) and directly use expadable asciidoc attributes in text, the Makefiles are ready. One downside is that plaintext original docs would become barely useful, with all those links externalized…
- docs/man/nut_usb_addvars.txt, docs/man/ups.conf.txt: add libusb API link spelling for curious readers of asciidoc source (not html/man/pdf renditions that needed escaping)
- docs/Makefile.am, docs/man/Makefile.am: rewrite bottom reference to "home page" to consider @NUT_WEBSITE_BASE@ (for historic releases) [#722]
- configure.ac, Makefile.am, docs/Makefile.am, docs/man/Makefile.am: fix DOC_BUILD_LIST to include "man-man" recipe, not "man" which is a dirname
- ci_build.sh: do not say "No BUILD_TYPE" was specified, when we are actually building (developer-oriented) "inplace" or with certain "docs" request
- docs/man/Makefile.am: standardize on --attribute=KEY=VAL spelling for a2x args everywhere
- ci_build.sh: accept "doc*" arguments that would be passed to configure script of developer builds Finally allow to not skip doc builds when developing just them :)
- ci_build.sh: restructure aliasing of "$1" to certain BUILD_TYPEs
- ci_build.sh: comment about INPLACE_RUNTIME=true envvar support

### 2.195. 2025-02-08 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/mge-hid.c: cosmetic fixes
- scripts/python/Makefile.am: restore definition of PYNUT_COMMON_CODE (empty) for recipe to be fully defined [#2792]

### 2.196. 2025-02-07 cgarz <20268068+cgarz@users.noreply.github.com>

- configure.ac: Update configure.ac, remove nut_have_telnetlib checks
- scripts/python/module/setup.py.in: Update setup.py.in, remove install_requires lib
- scripts/python/README.adoc: Update README.adoc, remove telnetlib section
- NEWS.adoc: Update NEWS.adoc PyNUTClient mention to include PR
- scripts/python/Makefile.am: Update python Makefile.am, remove nut_telnetlib.py reference.
- scripts/python/module/Makefile.am: Update python module Makefile.am, remove nut_telnetlib.py references.
- COPYING: update COPYING, remove nut_telnetlib.py mention.
- scripts/python/module/PyNUT.py.in: Update PyNUT changelog, bump version to 1.8.0
- scripts/python/module/PyNUT.py.in: Use socket create_connection instead of connect, Handles choosing IPv4 and IPv6 automatically.

### 2.197. 2025-02-07 Jim Klimov <jimklimov+nut@gmail.com>

- docs/man/nut_usb_addvars.txt, docs/man/ups.conf.txt: fix links leading to libusb API docs with two underscores
- tests/NIT/nit.sh: update comment about use of two explicit localhost IPv4/6 addresses, not a name, for upsd.conf
- scripts/python/module/nut_telnetlib.py: Remove the copy of module we do not need anymore
- configure.ac: restore nut_with_pynut_py* checks from v2.8.2, but test for "socket" instead of "telnetlib" module [#2183]
- docs/download.txt: change wording and use asciidoc link to pass dblatex⇒PDF generation
- INSTALL.nut.adoc: suggest how to push back a locally fixed git branch
- INSTALL.nut.adoc, docs/download.txt, docs/developers.txt: suggest fetching git tags to have a saner NUT_SEMVER in custom builds

### 2.198. 2025-02-07 Bill Elliot <bill@wreassoc.com>

- drivers/powervar-cs.c, drivers/powervar-cu.c, drivers/powervar-cx.h: After testing on GTS and UPM. Still need USB dis/re-connect logic.

### 2.199. 2025-02-06 Jim Klimov <jimklimov+nut@gmail.com>

- data/html/README.adoc, lib/README.adoc, tests/NIT/README.adoc: Various other asciidocs: reconcile markup (multi-paragraph lists, etc.)
- data/html/README.adoc, docs/FAQ.txt, docs/config-prereqs.txt, docs/configure.txt, docs/man/pijuice.txt, docs/packager-guide.txt, docs/snmp.txt: Various docs: spell "man pages" as two words
- scripts/Windows/README.adoc, scripts/fuse/README.adoc, scripts/hotplug/README.adoc: Various scripts/ asciidocs: reconcile markup (multi-paragraph lists, etc.)
- INSTALL.nut.adoc, README.adoc, docs/cables.txt, docs/config-notes.txt, docs/config-prereqs.txt, docs/configure.txt, docs/daisychain.txt, docs/design.txt, docs/developer-guide.txt, docs/developers.txt, docs/download.txt, docs/features.txt, docs/hid-subdrivers.txt, docs/macros.txt, docs/net-protocol.txt, docs/new-clients.txt, docs/new-drivers.txt, docs/nut-names.txt, docs/nut-qa.txt, docs/packager-guide.txt, docs/security.txt, docs/snmp-subdrivers.txt, docs/solaris-usb.txt: Various main asciidocs: reconcile markup (multi-paragraph lists, etc.)
- docs/FAQ.txt: update some answers and a lot of asciidoc markup
- docs/download.txt: do not list NUT for Windows MSI 2.6.5 as if it were the latest option
- docs/developers.txt: refresh info about CI builds
- docs/developers.txt: fix links to NEWS.adoc and UPGRADING.adoc (now with .adoc extensions)
- docs/developers.txt, docs/nut.dict: docs/developers.txt: revise GitHub-based review and contribution process
- docs/developers.txt: mention more of our valgrind automation
- docs/developers.txt: mention plan for clang-format automation
- docs/developers.txt: link to "Documentation/CodingStyle" of Linux kernel fame
- docs/developers.txt: fix formatting of a paragraph with many mentions of "C+\+"
- docs/developers.txt: revise explanation of fatalx() et al - it is not always EXIT_FAILURE
- docs/developer-guide.txt: refer to NUT DDL repo
- docs/design.txt: update the HISTORY section with NUT for Windows named pipes, and driver-to-driver queries using local socket protocol [#1903]
- docs/configure.txt: clarify (again) that statepath is the default value for altpidpath, and expose why it is so named
- docs/design.txt, docs/nut.dict: docs/design.txt: explain the location and communication of the 3 layers in words
- docs/configure.txt: suggest use of "-R/lib/path" with non-standard locations
- docs/configure.txt: move LibGD header to its related content; pkg-config is a dependency of its own
- docs/configure.txt: reword what "state path" is
- docs/configure.txt: clarify --with-all=auto option
- docs/configure.txt: clarify libmodbus\+libusb requiring libusb-1.x API
- docs/configure.txt: clarify in-place builds wording
- docs/man/libupsclient-config.txt, docs/configure.txt: clarify `lib/libupsclient-config --config-flags` vs. `libupsclient.pc`
- docs/config-notes.txt: note the system-wide sleep support beginning in NUT v2.8.3
- docs/config-notes.txt: refer to nutshutdown script in NUT sources
- docs/config-notes.txt: suggest more typical locations for POWERDOWNFLAG file
- docs/config-notes.txt: Starting the driver(s): re-title that this is a chapter for legacy approach with upsdrvctl (keep same anchor)
- docs/config-notes.txt: Driver configuration: clarify dependency on built-in identifiers, and that they may be avoided
- docs/config-notes.txt: refer to nutconf; split the NOTE into paragraphs
- docs/man/adelsystem_cbi.txt, docs/man/al175.txt, docs/man/apcsmart-old.txt, docs/man/apcsmart.txt, docs/man/apcupsd-ups.txt, docs/man/asciidoc.conf, docs/man/asem.txt, docs/man/bcmxcp.txt, docs/man/bcmxcp_usb.txt, docs/man/belkinunv.txt, docs/man/bestfortress.txt, docs/man/blazer-common.txt, docs/man/gamatronic.txt, docs/man/generic_gpio.txt, docs/man/generic_modbus.txt, docs/man/genericups.txt, docs/man/hosts.conf.txt, docs/man/huawei-ups2000.txt, docs/man/hwmon_ina219.txt, docs/man/ivtscd.txt, docs/man/libnutclient_commands.txt, docs/man/libnutclient_devices.txt, docs/man/libnutclient_variables.txt, docs/man/liebert-esp2.txt, docs/man/liebert.txt, docs/man/macosx-ups.txt, docs/man/mge-shut.txt, docs/man/mge-utalk.txt, docs/man/netxml-ups.txt, docs/man/nhs_ser.txt, docs/man/nut-driver-enumerator.txt, docs/man/nut-ipmipsu.txt, docs/man/nut-recorder.txt, docs/man/nut-scanner.txt, docs/man/nut.conf.txt, docs/man/nut.exe.txt, docs/man/nut_usb_addvars.txt, docs/man/nutconf.txt, docs/man/nutdrv_atcl_usb.txt, docs/man/nutdrv_qx.txt, docs/man/nutdrv_siemens_sitop.txt, docs/man/nutscan_add_option_to_device.txt, docs/man/nutscan_cidr_to_ip.txt, docs/man/nutupsdrv.txt, docs/man/oneac.txt, docs/man/phoenixcontact_modbus.txt, docs/man/pijuice.txt, docs/man/powerman-pdu.txt, docs/man/richcomm_usb.txt, docs/man/skel.txt, docs/man/snmp-ups.txt, docs/man/sockdebug.txt, docs/man/socomec_jbus.txt, docs/man/tripplite_usb.txt, docs/man/ups.conf.txt, docs/man/upsc.txt, docs/man/upscli_splitaddr.txt, docs/man/upscli_splitname.txt, docs/man/upscmd.txt, docs/man/upsd.conf.txt, docs/man/upsd.txt, docs/man/upsd.users.txt, docs/man/upsdrvctl.txt, docs/man/upsdrvsvcctl.txt, docs/man/upsimage.cgi.txt, docs/man/upslog.txt, docs/man/upsmon.conf.txt, docs/man/upsmon.txt, docs/man/upsrw.txt, docs/man/upsset.cgi.txt, docs/man/upsset.conf.txt, docs/man/upsstats.cgi.txt, docs/man/upsstats.html.txt, docs/man/usbhid-ups.txt, docs/man/victronups.txt, docs/nut.dict: docs/man/*.txt: revise asciidoc markup and man page contents * Align multi-paragraph blocks to render with correct indentation * Upper-case program description sentences on top, and start of text in NOTE/WARNING blocks * Apply linkman/linkmanext instead of direct emphasis * Apply backtick verbatim format in more places for files, commands, etc. * Do not state that a driver "is not built by default", but that it "may be not built by default" (`configure --with-all=auto` is now default for some time) * Assorted typos * Short content clarifications and extensions here and there (long/significant ones tracked by other commits)
- drivers/upsdrvctl.c: wrap long line in help()
- docs/man/usbhid-ups.txt: "Selecting a specific UPS": clarify use of serial number, allow_duplicates, etc.
- docs/man/upslog.txt: clarify that "-N" does not do sanity checks
- docs/asciidoc-vars.conf, docs/asciidoc.conf, docs/man/asciidoc.conf: introduce linkmanext and linkmanext2 macros for non-NUT man pages
- docs/man/upsdrvctl.txt: mention "list" and "status" as commands (chapter intro)
- docs/man/upsdrvctl.txt: revise note of upsdrvsvcctl, and add reasons to run drivers directly sometimes
- docs/man/upsd.users.txt, docs/man/upsmon.txt: revise "upsmon" as more of a role than a set of actions
- docs/man/hosts.conf.txt, docs/man/upsset.conf.txt: docs/man/{hosts,upsset}.conf.txt: considerations on FS and HTTPS access security
- docs/man/upsmon.txt: document NUT_QUIET_INIT_UPSNOTIFY and NUT_QUIET_INIT_BANNER support
- docs/man/upsd.txt: document NUT_QUIET_INIT_UPSNOTIFY and NUT_QUIET_INIT_BANNER support
- docs/man/ups.conf.txt, docs/man/upsd.conf.txt, docs/man/upsd.users.txt, docs/man/upsmon.conf.txt: docs/man/{ups.conf,upsd.conf,upsd.users,upsmon.conf}.txt: extend IMPORTANT NOTES with considerations on FS access security, slightly different for each file
- docs/man/upsd.txt: clarify that driver shutdown commands need no upsd

### 2.200. 2025-02-05 Jim Klimov <jimklimov+nut@gmail.com>

- docs/man/nutupsdrv.txt: document NUT_QUIET_INIT_UPSNOTIFY and NUT_QUIET_INIT_BANNER support; link to ups.conf and nut.conf man pages
- docs/man/nutconf.txt: fix IPMI cipher suite option representation as a table
- docs/man/nut_usb_addvars.txt: fix libusb docs URL rendering (double underscore is special)
- docs/man/nut.conf.txt: fix DIRECTIVES section rendering
- docs/man/nut-scanner.txt: fix NETWORK OPTIONS "NOTE" block markup
- docs/man/nut-scanner.txt: fix "-U…" table markup
- docs/man/nut-recorder.txt: link to upslog as a similar program
- docs/man/metasys.txt: link to copy of the protocol in NUT website library
- docs/man/index.txt: reference recent API and nutconf man pages
- docs/man/libnutclient.txt, docs/man/libnutclient_commands.txt, docs/man/libnutclient_devices.txt, docs/man/libnutclient_general.txt, docs/man/libnutclient_misc.txt, docs/man/libnutclient_tcp.txt, docs/man/libnutclient_variables.txt, docs/man/libupsclient-config.txt, docs/man/nutscan.txt, docs/man/nutscan_add_device_to_device.txt, docs/man/nutscan_add_ip_range.txt, docs/man/nutscan_add_option_to_device.txt, docs/man/nutscan_cidr_to_ip.txt, docs/man/nutscan_display_parsable.txt, docs/man/nutscan_display_sanity_check.txt, docs/man/nutscan_display_sanity_check_serial.txt, docs/man/nutscan_display_ups_conf.txt, …/nutscan_display_ups_conf_with_sanity_check.txt, docs/man/nutscan_free_device.txt, docs/man/nutscan_free_ip_ranges.txt, docs/man/nutscan_get_serial_ports_list.txt, docs/man/nutscan_init.txt, docs/man/nutscan_init_ip_ranges.txt, docs/man/nutscan_ip_ranges_iter_inc.txt, docs/man/nutscan_ip_ranges_iter_init.txt, docs/man/nutscan_new_device.txt, docs/man/nutscan_scan_avahi.txt, docs/man/nutscan_scan_eaton_serial.txt, docs/man/nutscan_scan_ipmi.txt, docs/man/nutscan_scan_nut.txt, docs/man/nutscan_scan_nut_simulation.txt, docs/man/nutscan_scan_snmp.txt, docs/man/nutscan_scan_usb.txt, docs/man/nutscan_scan_xml_http_range.txt, docs/man/nutscan_stringify_ip_ranges.txt, docs/man/upscli_add_host_cert.txt, docs/man/upscli_cleanup.txt, docs/man/upscli_connect.txt, docs/man/upscli_disconnect.txt, docs/man/upscli_fd.txt, docs/man/upscli_get.txt, docs/man/upscli_init.txt, docs/man/upscli_list_next.txt, docs/man/upscli_list_start.txt, docs/man/upscli_readline.txt, docs/man/upscli_sendline.txt, docs/man/upscli_splitaddr.txt, docs/man/upscli_splitname.txt, docs/man/upscli_ssl.txt, docs/man/upscli_strerror.txt, docs/man/upscli_upserror.txt, docs/man/upsclient.txt: docs/man/{lib,nutscan,upscli}*: update markup of API docs to be consistent * Block-quoting and indentation of SYNOPSIS * Bullet-lists for numerous methods and args * Slight wording changes * Single-quote integer return values
- Backtick-quote program and config file names * Cross-link to some other pages with linkman macro
- docs/man/upscli_splitaddr.txt: fix description of the method
- docs/man/upsc.txt: refer to "See also" the upslog client and ups.conf man pages; revise markup
- docs/man/solis.txt: use standard markup for "Extra Arguments" and "Supported Commands"; refer to "See also" the microsol-apc driver
- docs/man/rhino.txt: use standard markup for "Extra Arguments" and "Supported Commands"
- docs/man/microsol-apc.txt: use standard markup for "Extra Arguments" and "Supported Commands"; refer to "See also" the solis driver
- docs/man/libupsclient-config.txt: note the pkg-config alternative to the older-style script
- docs/man/clone.txt, docs/man/clone-outlet.txt, docs/man/dummy-ups.txt: update wording and cross-links of the virtual device drivers
- docs/man/sockdebug.txt, docs/nut.dict: clarify the two separate sources of the program (POSIX/WIN32)
- AUTHORS, MAINTAINERS, docs/nut.dict: add Jim Klimov Just half a decade as maintainer; better late than never :)

### 2.201. 2025-02-04 cgarz <20268068+cgarz@users.noreply.github.com>

- scripts/python/module/PyNUT.py.in: Remove walrus op for older python compatibility.

### 2.202. 2025-02-04 Jim Klimov <jimklimov+nut@gmail.com>

- NEWS.adoc, drivers/main.c: exit_cleanup(): avoid upsnotify() at exit if CLI args were fatally useless Note also earlier change in commit d6112a3fa732f0881c3759870d51f1dad7348886
- NEWS.adoc: fix misplaced entry for baytech-rpc3nc-mib [#2779]
- docs/Makefile.am: EXTRA_DIST sms-brazil-protocol.txt and comment why it is not among ALL_TXT_SRC [#2090]
- docs/sms-brazil-protocol.txt: wrap long lines in intro paragraph [#2090]
- docs/man/sms_ser.txt: fix reference to docs/sms-brazil-protocol.txt [#2090]

### 2.203. 2025-02-04 Bill Elliot <bill@wreassoc.com>

- drivers/powervar-cs.c, drivers/powervar-cu.c, drivers/powervar-cx.h: Text tweaks and help text sequence change(s).

### 2.204. 2025-02-03 Bill Elliot <bill@wreassoc.com>

- drivers/powervar-cs.c, drivers/powervar-cu.c, drivers/powervar-cx.h: Generally working drivers prior to command testing.

### 2.205. 2025-01-31 cgarz <20268068+cgarz@users.noreply.github.com>

- scripts/python/module/PyNUT.py.in: Switch to socket timeout, fix its init argument
- scripts/python/module/PyNUT.py.in: switch to socket send and replacement read_until
- scripts/python/module/PyNUT.py.in: added replacement read_until and leftover buffer

### 2.206. 2025-01-29 RikyPlaza <rikyrod2001@gmail.com>

- drivers/phoenixcontact_modbus.c: implemented reading of more variables for TRIO and TRIO-2G models.

### 2.207. 2025-01-29 Jim Klimov <jimklimov+nut@gmail.com>

- ci_build.sh: Revert "ci_build.sh: tolerate OpenSSL headers on OmniOS" This reverts commit c8927a525ff754467796635bdc3a866126377358: a more general fix posted to m4/nut_check_libopenssl.m4
- m4/nut_check_libopenssl.m4: refactor to parse relevant dirs as "-isystem" from depCFLAGS
- drivers/optiups.c: rename global variables to not start with underscore clang-19: error: identifier pollv_ps is reserved because it starts with at global scope [-Werror,-Wreserved-identifier]
- m4/nut_check_libopenssl.m4, m4/nut_compiler_family.m4: m4/nut_check_libopenssl.m4: inject -isystem settings for OpenSSL-3 where needed
- configure.ac: add -Wno-missing-include-dirs to clang(-19) relaxation

### 2.208. 2025-01-28 Jim Klimov <jimklimov+nut@gmail.com>

- scripts/Windows/build-mingw-prereqs.sh: use libmodbus-git fork/branch recommended by NUT instructions
- scripts/Windows/build-mingw-prereqs.sh: revise git-usecase recovery from bad checkout (force-push to upsteram etc.)
- drivers/powerman-pdu.c: use same enum type for two variants of result
- drivers/libusb1.c, drivers/nut-libfreeipmi.c, tools/nut-scanner/scan_ipmi.c: Various: reconcile formatting strings and int-ish casting
- ci_build.sh: tolerate OpenSSL headers on OmniOS

### 2.209. 2025-01-27 Jim Klimov <jimklimov+nut@gmail.com>

- docs/config-prereqs.txt: update OmniOS and OpenIndiana pointers to current gcc/clang in rolling distro releases
- Jenkinsfile-dynamatrix: fix typo in comment
- m4/nut_compiler_family.m4: fix detection of actually unsupported compiler flags [#1352]

### 2.210. 2025-01-26 Jim Klimov <jimklimov+nut@gmail.com>

- NEWS.adoc, docs/nut.dict: NEWS.adoc: update for baytech-rpc3nc-mib [#2779]

### 2.211. 2025-01-25 Jim Klimov <jimklimov@gmail.com>

- scripts/valgrind/valgrind.sh.in: revise detection of VALGRIND and LIBTOOL values

### 2.212. 2025-01-25 Jim Klimov <jimklimov+nut@gmail.com>

- tests/generic_gpio_utest.c: Revert "tests/generic_gpio_utest.c: Be sure the internal gpioupsfd in driver code is freed before we (re?)init it in test" This reverts commit bf59f10950246f1dd8ea22e58d501502c7bd499d.
- drivers/generic_gpio_common.c: generic_gpio_open(): reshuffle to optimize * Less lookups to testval/getval * Do not xalloc and fatalx if got no rules (avoid leak)
- tests/generic_gpio_utest.c: fix inverted strcmp() result treatment
- tests/generic_gpio_utest.c: Be sure the internal gpioupsfd in driver code is freed before we (re?)init it in test
- drivers/generic_gpio_common.c, drivers/generic_gpio_common.h, tests/generic_gpio_utest.c: drivers/generic_gpio_common.{c,h}, tests/generic_gpio_utest.c: refactor generic_gpio_close() to take a pointer to pointer and nullify it
- drivers/generic_gpio_common.c: generic_gpio_close(): free(gpioupsfdlocal→rules) itself too, not just entries in the list
- tests/generic_gpio_utest.c: do upsdrv_cleanup() now that it is safe to occasionally repeat the attempt
- drivers/generic_gpio_common.c: upsdrv_cleanup(): only free resources once Check if (gpioupsfd!=NULL) and nullify it afterwards. Should not be a problem in the real driver, but confused the repetitive use of this code in unit test case.
- drivers/generic_gpio_common.c: fix code markup to adhere closer to NUT coding style
- tests/generic_gpio_utest.c: dstate_free() after the test run
- tests/generic_gpio_utest.c: comment away upsdrv_cleanup() in codepath which we did not upsdrv_init()
- tests/generic_gpio_utest.c: refactor work with generic_gpio_close() to avoid use after free
- tests/nutconf_ut.cpp: NutConfigUnitTest::testUpsmonConfiguration(): fix memory leak with temporary BoolInt instances
- common/nutstream.cpp: checkExistsWritableDir(): fix memory leak with opened DIRFD
- scripts/valgrind/.valgrind.supp: add suppressions for dash interpreter
- scripts/valgrind/.valgrind.supp: add suppressions for C+\+ tests (CPPUNIT leaky internals)
- scripts/valgrind/valgrind.sh.in: comment about --gen-suppressions=all option
- configure.ac, scripts/valgrind/.gitignore, scripts/valgrind/README.adoc, scripts/valgrind/{valgrind.sh ⇒ valgrind.sh.in}, tests/Makefile.am: configure.ac, scripts/valgrind/valgrind.sh.in, tests/Makefile.am: make the helper script a template
- tests/Makefile.am: memcheck: use the NUT-customized wrapper for valgrind
- scripts/valgrind/valgrind.sh: allow to customize the VALGRIND to be used
- tests/Makefile.am: memcheck: report OVERALL FAILED cases (if any)
- Makefile.am: separate meaning of memcheck vs. distcheck-valgrind targets

### 2.213. 2025-01-24 Jim Klimov <jimklimov@gmail.com>

- configure.ac, Makefile.am: DISTCHECK_FLAGS*: inherit CFLAGS/CXXFLAGS values used by configure of the main build (e.g. passed some time ago from ci_build.sh or user), add CPPFLAGS and LDFLAGS to the mix

### 2.214. 2025-01-24 Jim Klimov <jimklimov+nut@gmail.com>

- ci_build.sh: hot-fix issue #2782 on OmniOS
- tests/Makefile.am: refactor "memcheck" recipe to be usable stand-alone, and not only with C+\+ builds
- Makefile.am: only proceed to "make memcheck" if we HAVE_VALGRIND
- tools/gitlog2version.sh: fix getver_default() determination of NUT_VERSION_DEFAULT3 and thus NUT_SOURCE_GITREV_IS_RELEASE in configure.ac (for distcheck or tarball builds) [#1949]
- Makefile.am: do not evaluate DISTCHECK_CONFIGURE_FLAGS right when calling sub-"make distcheck" [#2541, fixes #2542 fallout]
- Makefile.am: embed PKG_CONFIG_PATH we were built with into DISTCHECK_CONFIGURE_FLAGS
- docs/config-prereqs.txt, docs/nut.dict: docs/config-prereqs.txt: revise OmniOS chapter to note run-time linking troubles with OOCE (Extra repo) [#2782]
- docs/config-prereqs.txt: revise OmniOS chapter to better reflect current LTS 151046

### 2.215. 2025-01-23 RikyPlaza <rikyrod2001@gmail.com>

- drivers/phoenixcontact_modbus.c: Added management for TRIO-2G UPS of output.voltage variable
- drivers/phoenixcontact_modbus.c: added management of new ups models for OB, OL, CHRG and LB flags.
- drivers/phoenixcontact_modbus.c: Added new ups models in enumeration and updated upsdrv_initinfo function.
- drivers/phoenixcontact_modbus.c: Added entries for new models.

### 2.216. 2025-01-23 Jim Klimov <jimklimov@gmail.com>

- ci_build.sh: apply compiler/linker flags possibly adjusted by detect_platform_PKG_CONFIG_PATH_and_FLAGS() in BUILD_TYPE=""/inplace cases
- ci_build.sh: normalize_path() the PATH and CCACHE_PATH after guesswork and before build

### 2.217. 2025-01-23 Jim Klimov <jimklimov+nut@gmail.com>

- ci_build.sh: avoid exporting compiler flags for "windows-msys2" semi-native builds with ccache Nothing wrong in theory, but in practice either autotools or ccache build on that platform handles the expanded flags as if they were a path to non-existing location of a source file :\
- docs/config-prereqs.txt: add pkg name for libltdl on OmniOS
- m4/nut_check_libltdl.m4: fix re-detection with CFLAGS added
- ci_build.sh: refactor detect_platform_PKG_CONFIG_PATH_and_FLAGS() with normalize_path() even more
- ci_build.sh: refactor detect_platform_PKG_CONFIG_PATH_and_FLAGS() with normalize_path()
- ci_build.sh: refactor detect_platform_PKG_CONFIG_PATH_and_FLAGS() for many logic paths on Solaris/illumos
- ci_build.sh: also handle CANBUILD_WITH_LIBMODBUS_USB in parameter-less/BUILD_TYPE="" builds
- ci_build.sh: fix "[" tests to use "=" not "==" for comparisons
- appveyor.yml: pass CANBUILD_WITH_LIBMODBUS_USB tweak to ci_build.sh
- ci_build.sh: introduce CANBUILD_WITH_LIBMODBUS_USB tweak

### 2.218. 2025-01-23 Bill Elliot <bill@wreassoc.com>

- drivers/powervar-cs.c, drivers/powervar-cu.c, drivers/powervar-cx.h: Adding commands and variables. General cleanups.

### 2.219. 2025-01-22 Jim Klimov <jimklimov+nut@gmail.com>

- docs/config-prereqs.txt: update for OmniOS r151052
- ci_build.sh: clean up indentations
- ci_build.sh: teach developer-oriented runs some tricks from CI When BUILD_TYPE=="" or "inplace", make use of newly separated methods like optional_ensure_ccache(), optional_prepare_compiler_family(), detect_platform_PKG_CONFIG_PATH_and_FLAGS()
- ci_build.sh: add OmniOS CE "Extra" repository binaries to PATH if present
- ci_build.sh: prepare also BUILTIN_PKG_CONFIG_PATH as part of the equation (least priority)
- docs/config-prereqs.txt: update for OmniOS r151052
- ci_build.sh: detect OmniOS CE extra repo as part of SYS_PKG_CONFIG_PATH
- appveyor.yml: when installing, "set -e" to fail if any script actions fail, and finish with "date -u" to check how long "7z" takes subsequently
- m4/nut_check_libusb.m4: enable libusb-1.0 on mingw/MSYS2 if we also want --with-modbus\+usb=yes [#1507]
- m4/nut_check_libmodbus.m4, m4/nut_check_libusb.m4: comment to remind that libusb-1.0 is required by libmodbus with rtu_usb
- configure.ac, drivers/Makefile.am: fix condition for linking apc_modbus against libusb
- m4/nut_check_libmodbus.m4: remember tuned depLIBS and depCFLAGS if re-checks succeed
- m4/nut_check_libmodbus.m4: tests on Windows may require -lws2_32 and/or -liphlpapi
- scripts/Windows/build-mingw-prereqs.sh: report *.pc files in the "production" install area [#1491]
- appveyor.yml: Revert "appveyor.yml: force rebuild/reinstall of custom prereqs (TBD: disable later)" This reverts commit 24829c5ddbb1ced12372afeffdfb691352713930.
- appveyor.yml: Revert "appveyor.yml: TEMPORARY: Constrain to only re-build NUT prerequisites and fit into the 1-hour time slot" This reverts commit 0901f35b7cdd131788abd4a16b2ce7a4e28540dd.
- scripts/Windows/build-mingw-prereqs.sh: inject MSYS2 ccache symlink location if present [#1491]
- scripts/Windows/build-mingw-prereqs.sh: report resulting PATH
- scripts/Windows/build-mingw-prereqs.sh: fix shell expansion style for PREFIX in gitrepo case
- scripts/Windows/build-mingw-prereqs.sh: fix shell expansion style for PREFIX in tarball case
- scripts/Windows/build-mingw-prereqs.sh: only fix up PATH if PREFIX/bin is not yet there
- appveyor.yml: TEMPORARY: Constrain to only re-build NUT prerequisites and fit into the 1-hour time slot
- appveyor.yml: pepper CCACHE location into PATH for explicit MAKE calls and build-mingw-prereqs.sh [#1491] We are only sort of guaranteed to use ccache out of the box when arranged by ci_build.sh, but might not benefit from it in other cases.
- appveyor.yml: parallelize spellcheck a bit more
- appveyor.yml: use faster compression in APPVEYOR_CACHE_ENTRY_ZIP_ARGS
- scripts/Windows/build-mingw-prereqs.sh: normalize away extra slashes from PREFIX
- scripts/Windows/build-mingw-prereqs.sh: fetch with curl non-verbosely

### 2.220. 2025-01-22 Jim Klimov <jim@jimklimov.com>

- ci_build.sh: refactor with logic moved from BUILD_TYPE=default* to reusable methods * ensure_CI_CCACHE_SYMLINKDIR_envvar() * optional_prepare_ccache() * optional_prepare_compiler_family() and helpers is_gnucc(), is_clang(), filter_version(), ver_gnucc(), ver_clang() * optional_ensure_ccache() * detect_platform_CANBUILD_LIBGD_CGI() * detect_platform_PKG_CONFIG_PATH_and_FLAGS()

### 2.221. 2025-01-22 Bill Elliot <bill@wreassoc.com>

- drivers/powervar-cs.c, drivers/powervar-cu.c, drivers/powervar-cx.h: GTS USB working well for Init and Update.

### 2.222. 2025-01-21 Jim Klimov <jimklimov+nut@gmail.com>

- scripts/Windows/build-mingw-prereqs.sh: report the prepared environment variables [#1491]

### 2.223. 2025-01-20 Noah Jacobson <noah@noahjacobson.com>

- drivers/snmp-ups.c: chore: bump snmp-ups version
- drivers/Makefile.am, drivers/baytech-rpc3nc-mib.c, drivers/baytech-rpc3nc-mib.h, drivers/snmp-ups.c: feat: add SNMP support for Baytech RPC3-NC PDUs Some models of Baytech RPC3-NC PDUs do not have a value at ".1.3.6.1.4.1.4779.1.3.5.2.1.24.1", causing the sysOID match to fail. Added a 2nd MIB that looks at ".1.3.6.1.4.1.4779.1.3.5.5.1.3.2.1" instead. This patch would fall under the "various RPC" entry in the hardware compatibility list, thus the list does not need updating.

### 2.224. 2025-01-20 Jim Klimov <jimklimov+nut@gmail.com>

- scripts/Windows/build-mingw-prereqs.sh: if component "configure" script fails, print its config.log [#1491]
- appveyor.yml: force rebuild/reinstall of custom prereqs (TBD: disable later)
- scripts/Windows/build-mingw-prereqs.sh: document that libmodbus is also covered [#1491]
- scripts/Windows/build-mingw-prereqs.sh: document example usage for non-Windows targets [#1491]
- scripts/Windows/build-mingw-prereqs.sh: avoid use of "true" program [#1491]
- scripts/Windows/build-mingw-prereqs.sh: revise determination of PREFIX with PREFIX_ROOT [#1491]
- scripts/Windows/build-mingw-prereqs.sh: revise determination of ARCH and PREFIX, so they can be customized (e.g. for non-Windows prereq builds eventually) [#1491]
- scripts/Windows/build-mingw-prereqs.sh: comment progression through the script (whether we skip a component as already installed, or we fetch/build/install it [#1491]
- appveyor.yml: skip installing packaged mingw-w64-x86_64-libmodbus-git, use the custom-built one (like net-snmp)
- scripts/Windows/build-mingw-prereqs.sh: only chmod/remove builddir if it exists before rebuild [#1491]
- scripts/Windows/build-mingw-prereqs.sh: minimize local filesystem changes when checking remote Git for changes [#1491]
- scripts/Windows/build-mingw-prereqs.sh: use libmodbus branch fix-mingw-build temporarily
- scripts/Windows/build-mingw-prereqs.sh: add a way to provide_libmodbus_git() [#2609, #1473, #1491]
- …/ci/jenkins-nut-large-with-plateborder.pdn, docs/images/ci/jenkins-nut-vector.svg: Update docs/images/ci/jenkins-nut-large-with-plateborder.pdn, add vector docs/images/ci/jenkins-nut-vector.svg
- scripts/Windows/build-mingw-prereqs.sh: separate MAKEFLAGS from MAKE [#1491]
- scripts/Windows/build-mingw-prereqs.sh: default to "gmake" if available by such name
- scripts/Windows/build-mingw-prereqs.sh: minor fixes to layout; use "rsync -c" to only modify dest if needed
- scripts/Windows/build-mingw-prereqs.sh: bump © and license blurb
- appveyor.yml: pre-remove mingw-w64-i686-gdb-multiarch if present

### 2.225. 2025-01-19 Jim Klimov <jimklimov+nut@gmail.com>

- .github/workflows/PyNUTClient.yml: test with python-3.13 [#2733]
- scripts/python/module/README.adoc: update list of regularly touched Python 3.x versions [#2733]
- scripts/python/module/setup.py.in: update list of classifiers [#2733]
- NEWS.adoc, UPGRADING.adoc, scripts/python/module/Makefile.am, scripts/python/module/README.adoc, scripts/python/module/setup.py.in: scripts/python/module, docs: adjust PyNUTClient tarball name to PEP-0625 requirements [#2773]
- scripts/python/README.adoc: update wording [#2773]

### 2.226. 2025-01-18 Jim Klimov <jimklimov+nut@gmail.com>

- clients/cgilib.c, clients/upssched.c, clients/upsset.c, clients/upsstats.c, common/common.c, common/upsconf.c, common/wincompat.c, drivers/clone-outlet.c, drivers/clone.c, drivers/dstate.c, drivers/dummy-ups.c, drivers/main.c, drivers/snmp-ups.c, drivers/upsdrvctl.c, drivers/upsdrvquery.c, drivers/upsdrvquery.h, scripts/Windows/wininit.c, server/conf.c, server/desc.c, server/pipedebug.c, server/sstate.c, server/upsd.c, server/user.c: Various: use NUT_PATH_MAX instead of SMALLBUF for file/sock/pipe names [#2764]
- clients/upssched.c, common/common.c, common/nutstream.cpp, drivers/hwmon_ina219.c, drivers/nhs_ser.c, include/wincompat.h, scripts/Windows/wininit.c, server/sstate.c: Various: use NUT_PATH_MAX instead of PATH_MAX, MAX_PATH, MAXPATHLEN, UNIX_PATH_MAX etc. [#2764]
- common/common.c: use NUT_PATH_MAX instead of ifdef UNIX_PATH_MAX tricks [#2764]
- include/common.h: introduce NUT_PATH_MAX as the longest of several possible variants [#2764]
- server/sstate.c: report full path to expected UPS named pipe (WIN32) when we fail to connect [#2764]
- NEWS.adoc, conf/nut.conf.sample, drivers/dstate.c: introduce NUT_QUIET_INIT_LISTENER envvar [#2764]
- drivers/dstate.c: fix some WIN32 code markup
- drivers/dstate.c: sock_open(): report path to sockfn (or WIN32 named pipe) the driver now listens on [#2764]
- server/sstate.c: report full path to expected UPS socket file when we fail to connect [#2764]
- server/upstype.h: comment upstype_s→fn
- configure.ac: diligently check for various integer types

### 2.227. 2025-01-16 Jim Klimov <jimklimov@gmail.com>

- tools/gitlog2changelog.py.in: adapt to Python 3.13 deprecation of positional "maxsplit" parameter to re.split()
- scripts/python/Makefile.am, scripts/python/module/Makefile.am: be sure to install nut_telnetlib.py along with PyNUT.py file [#2183, #2501, #2505] Deliver nut_telnetlib.py with Python 3.13 that lacks its own. Some use-cases did ensure its presence, but not all cases yet.

### 2.228. 2025-01-16 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/nutdrv_qx_voltronic.c, NEWS.adoc: fix battery.runtime for newer protocol dialect [#2765]

### 2.229. 2025-01-15 Jim Klimov <jimklimov@gmail.com>

- docs/config-prereqs.txt: update the MacOS chapter a bit

### 2.230. 2025-01-11 Jim Klimov <jimklimov+nut@gmail.com>

- clients/upslog.c, docs/man/upslog.txt, NEWS.adoc: Added `-N` to prefix `%UPSHOST%%t` before the format string
- NEWS.adoc, clients/upslog.c, clients/upslog.h: clients/upslog.{c,h}, NEWS.adoc: refactor to pass monhost_ups_t* to methods and avoid shared global vars for single UPS NOTE: The logbuffer and logformat remain shared, the former is cleaned before use in run_flist() anyway. Might be passed around, too, but why keep re-allocating and freeing memory (or tossing more stack bytes with pointer and size to static variable of that method)?..
- clients/upslog.c: main loop: do not rely on "ups" variable as such
- clients/upslog.c, clients/upslog.h: clients/upslog.{c,h}: move definitions of logtarget_t and monhost_ups_t to header, rename the latter with "_t"
- docs/config-prereqs.txt: update instructions for OpenIndiana (as of 2024.04)
- Makefile.am: install-as-root: SMF: fix path to svcadm [#1298]
- scripts/Solaris/Makefile.am: combine "package-solaris-svr4" into one shell block (keep ISA vars defined)
- scripts/Solaris/Makefile.am: consider ISA info (specific 32/64-bit CPU support) of build target host in package naming as NUT/NUTx - Makefile typo fix
- configure.ac: fix fallback PROBE_OS_GROUP definition
- Makefile.am: install-as-root: update comment [#1298]
- Makefile.am: install-as-root: fix NDE retcode 42 behaviour [#1298]
- Makefile.am: install-as-root: separate service-stopping from "make install" of new files and creation/ownership/restart of new artifacts [#1298]
- configure.ac: refine NUT_VERSION_DEPLOYED (seen when we ./configure --enable-inplace-runtime)
- INSTALL.nut.adoc, docs/config-notes.txt: update with info on `(sudo) make install-as-root` [#1298]
- scripts/Solaris/Makefile.am: consider ISA info (specific 32/64-bit CPU support) of build target host in package naming as NUT/NUTx
- Makefile.am: install-as-root: avoid chmod/chown of common OS locations like /run /var/run /etc [#1298]

### 2.231. 2025-01-10 Jim Klimov <jimklimov+nut@gmail.com>

- Makefile.am, configure.ac, NEWS.adoc: implement install-as-root [#1298]

### 2.232. 2025-01-09 Jim Klimov <jimklimov+nut@gmail.com>

- NEWS.adoc, docs/nut.dict, scripts/Windows/.gitignore, scripts/Windows/README.adoc, scripts/Windows/build-mingw-nut.sh: scripts/Windows/build-mingw-nut.sh et al: extend to use
- m4/nut_check_libnetsnmp.m4: fix detection of WITH_SNMP_STATIC for hosts/targets where it is needed [#2673]
- scripts/Windows/README.adoc: update with instructions how to build cppunit
- scripts/Windows/README.adoc: update the paragraph about native builds with Windows MSYS2 environment
- docs/config-prereqs.txt: termux/cppunit: static lib not needed after all

### 2.233. 2025-01-08 Jim Klimov <jimklimov+nut@gmail.com>

- tests/cpputest-client.cpp: use HAVE_PRAGMA_CLANG_DIAGNOSTIC_IGNORED_DEPRECATED_DECLARATIONS for new clang-19
- Makefile.am: fix install-man activity (wrong dir)
- docs/Makefile.am: simplify DOCBUILD_FILTER_GITHUB_LINKS and DOCBUILD_CONVERT_GITHUB_LINKS that were not re-used into a single block of code Helps against docs/Makefile.am: warning: escaping \# comment markers is not portable Fix inspired by https://github.com/ddclient/ddclient/issues/745
- include/nutipc.hpp: add default label to an old case

### 2.234. 2025-01-07 Jim Klimov <jimklimov+nut@gmail.com>

- tests/cpputest.cpp, tests/example.cpp, tests/nutclienttest.cpp, tests/nutconf_parser_ut.cpp, tests/nutconf_ut.cpp, tests/nutipc_ut.cpp, tests/nutstream_ut.cpp: tests/*.cpp: use HAVE_PRAGMA_CLANG_DIAGNOSTIC_IGNORED_DEPRECATED_DECLARATIONS for new clang-19
- m4/ax_c_pragmas.m4: introduce HAVE_PRAGMA_CLANG_DIAGNOSTIC_IGNORED_DEPRECATED_DECLARATIONS detection
- docs/config-prereqs.txt, docs/nut.dict: clarify about cppunit on Termux
- tests/generic_gpio_liblocal.c: add default label to an old case
- m4/nut_check_pkgconfig.m4: extend comment
- NEWS.adoc, clients/upscmd.c, clients/upslog.c, clients/upsmon.c, clients/upsmon.h, clients/upsrw.c, common/common.c, common/parseconf.c, drivers/adelsystem_cbi.c, drivers/al175.c, drivers/apc-hid.c, drivers/bcmxcp.c, drivers/bcmxcp_ser.c, drivers/bcmxcp_usb.c, drivers/blazer_usb.c, drivers/cps-hid.c, drivers/dstate.c, drivers/etapro.c, drivers/everups.c, drivers/generic_modbus.c, drivers/huawei-ups2000.c, drivers/libhid.c, drivers/libshut.c, drivers/libusb1.c, drivers/liebert-esp2.c, drivers/liebert-gxe.c, drivers/liebert.c, drivers/microdowell.c, drivers/microsol-common.c, drivers/netxml-ups.c, drivers/nhs_ser.c, drivers/nutdrv_qx.c, drivers/nutdrv_qx_innovart31.c, drivers/nutdrv_qx_voltronic-qs-hex.c, drivers/powercom.c, drivers/riello_ser.c, drivers/riello_usb.c, drivers/serial.c, drivers/snmp-ups.c, drivers/socomec_jbus.c, drivers/solis.c, drivers/tripplite.c, drivers/tripplite_usb.c, drivers/tripplitesu.c, drivers/upsdrvctl.c, drivers/usbhid-ups.c, drivers/ydn23.h, tests/getexponenttest-belkin-hid.c, tests/getvaluetest.c, tools/nut-scanner/scan_nut.c, tools/nut-scanner/scan_xml_http.c: Reconcile int-ish data types with formatting strings [#823] New checks in clang-18/19 brought new findings, some of them reasonable :) * "%x" style formatting requires an (unsigned int) variable * numeric literals and macros are (int) by default * results of math with (uint16_t), done in some cases, are upscaled into (int) by default * char, unsigned or not, seems to be also upscaled into (int) Overall, had to change formatting strings in some cases, variable types in others (e.g. flags or notification types do not make sense as signed) and added casting in a few places that remained.
- drivers/huawei-ups2000.c: fix whitespace (trailing, indentation)
- drivers/adelsystem_cbi.c: fix whitespace (trailing, indentation)
- common/common.c: add default label to an old case
- docs/nut.dict: "tuples" are not understood by some distros

### 2.235. 2025-01-06 Jim Klimov <jimklimov+nut@gmail.com>

- NEWS.adoc, clients/upsclient.c: clients/upsclient.c: upscli_splitname(): handle "upsname:port" shortcut attempts
- clients/upslog.c: bump © years
- clients/upslog.c, docs/man/upslog.txt, NEWS.adoc: handle "*" as UPS name to query for currently served devices
- clients/upslog.c: default pointer vars to NULL
- clients/upslog.c, docs/man/upslog.txt, NEWS.adoc: Added `-D` for debugging (and foregrounding by default), like with other NUT daemons
- clients/upslog.c, docs/man/upslog.txt, NEWS.adoc: Same log file may now safely be used in different logging tuples
- common/common.c, drivers/adelsystem_cbi.h, drivers/generic_gpio_common.c, drivers/generic_gpio_libgpiod.c, tests/generic_gpio_utest.c: Fix parameter order for xcalloc() in various offences
- clients/upslog.c, docs/man/upslog.txt, NEWS.adoc: Fixed printing of `%UPSHOST%` when multiple systems are being logged
- clients/upslog.c, docs/man/upslog.txt, NEWS.adoc: A `%t` for a TAB character can now be used in the formatting string
- clients/upslog.c, docs/man/upslog.txt, NEWS.adoc: support legacy and tuple logging specs together

### 2.236. 2025-01-05 Jim Klimov <jimklimov+nut@gmail.com>

- clients/upslog.c: fix max loops CLI arg processing [#2753]
- NEWS.adoc, UPGRADING.adoc: report that upslog is now also a service [#1803]
- tests/NIT/nit.sh: testcase_sandbox_upsc_query_timer(): use upslog for a second opinion [#1803]
- drivers/cps-hid.c, NEWS.adoc: try to fix frequency scaling dynamically [#2717]
- clients/Makefile.am: upslog is now an integrated service, use the full library [#1803]
- scripts/systemd/nut-logger.service.in: revise systemd integration mishaps [#1803]

### 2.237. 2025-01-04 William Goodspeed <86338960+goodspeed34@users.noreply.github.com>

- drivers/liebert-gxe.c: fix bad backup time report It seems `battery.runtime` should be used for battery backup time instead `.low` one. Also the division was also faulty probably because I copied and pasted the code from previous lines but the manual says it shouldn’t be there. The commit should give correct backup time readings and corrected variable name.

### 2.238. 2025-01-03 Jim Klimov <jimklimov+nut@gmail.com>

- clients/upslog.c, docs/man/upslog.txt: clients/upslog.c: support limit of loop count
- clients/upslog.c: revise code markup
- tests/NIT/nit.sh: stop_daemons(): first stop upsmon by its own command, then kill it As of now we `make check-NIT-sandbox-devel` and eventually `kill $UPSMON_PID` but this only stops the parent process, but the forked-off child keeps running.
- drivers/main.c: main(): fix comment markup
- NEWS.adoc, drivers/main.c: drivers/main.c: main(): try harder to kill off older driver instances when we run to do_forceshutdown [#2666]
- drivers/main.c: main(): do try to chdir(dflt_statepath()) when we (do_forceshutdown |\| dump_data) also, just keep it non-fatal [#2666]
- drivers/main.c: main(): rearrange code written for WIN32 builds (markup and variable definitions before code)
- scripts/Windows/README.adoc: remind about prerequisite installation
- scripts/Windows/README.adoc: fix markup for pthreads installation
- scripts/Windows/README.adoc: clarify envvar persistence for the build
- Makefile.am: enable distcheck --with-systemdsystempresetdir
- docs/Makefile.am, docs/man/Makefile.am: .prep-src-docs: play nice with different MKDIR_P as we "cd" around [#722]

### 2.239. 2025-01-02 Jim Klimov <jimklimov@gmail.com>

- docs/Makefile.am, docs/man/Makefile.am: .prep-src-docs for out-of-tree builds: only rewrite "linkman" references for doc text sources that have them [#722] Spare asciidoc.conf, docinfo.xml and similar resource files, as well as docs that do not have those tags in the first place.
- docs/Makefile.am, docs/man/Makefile.am: .prep-src-docs for out-of-tree builds with Sun make: handle plain filenames in $(PREP_SRC) without a prefixed directory Looking at generated docinfo.xml and linkman-* files respectively.
- docs/configure.txt: clarify that --with-docs-man-* options do not enable doc building by themselves

### 2.240. 2025-01-02 Jim Klimov <jimklimov+nut@gmail.com>

- common/common.c, common/nutipc.cpp, NEWS.adoc, docs/nut.dict: support writepid() calls by non-root programs [#1717]
- scripts/systemd/Makefile.am: wrap long lines in EXTRA_DIST
- configure.ac, scripts/systemd/.gitignore, scripts/systemd/Makefile.am, scripts/systemd/{nut-driver.target ⇒ nut-driver.target.in}: scripts/systemd/nut-driver.target et al: make it a .in template [#722]
- scripts/systemd/nut-driver-enumerator-daemon-activator.path.in, scripts/systemd/nut-driver-enumerator-daemon-activator.service.in, scripts/systemd/nut-driver-enumerator-daemon.service.in, scripts/systemd/nut-driver-enumerator.path.in, scripts/systemd/nut-driver-enumerator.service.in, scripts/systemd/nut-driver.target, scripts/systemd/nut-driver@.service.in, scripts/systemd/nut-monitor.service.in, scripts/systemd/nut-server.service.in, scripts/systemd/nut-sleep.service, scripts/systemd/nut.target.in, scripts/systemd/nutshutdown.in: scripts/systemd/nut*.in: bump © to 2025
- UPGRADING.adoc, scripts/systemd/Makefile.am, scripts/systemd/nut-systemd.preset: scripts/systemd/nut-systemd.preset, UPGRADING.adoc: introduce the file, document the units and why they are enabled or disabled by default [#2721]
- scripts/systemd/nut-sleep.service: typo fix, bump ©
- configure.ac, docs/configure.txt, NEWS.adoc, docs/nut.dict: introduce --with-systemdsystempresetdir setting
- configure.ac: refactor detection of systemd directories (yes/auto mode via pkg-config)
- clients/upslog.c: help(): clarify that "-m tuple" option(s) can override "-s ups -l file" in effect
- docs/man/upslog.txt: clarify that "-m tuple" option(s) can override "-s ups -l file" in effect
- configure.ac, scripts/Solaris/.gitignore, scripts/Solaris/Makefile.am, scripts/Solaris/nut-logger.xml.in, scripts/Solaris/svc-nut-logger.in, scripts/systemd/.gitignore, scripts/systemd/Makefile.am, scripts/systemd/nut-logger.service.in, scripts/systemd/nut.target.in: Introduce service wrapping for upslog client daemon [#1803]
- common/common.c, common/nutipc.cpp, NEWS.adoc, docs/nut.dict: support writepid() calls by non-root programs [#1717]

### 2.241. 2025-01-01 Jim Klimov <jimklimov+nut@gmail.com>

- docs/man/Makefile.am: fix typo of recent change

### 2.242. 2024-12-31 Jim Klimov <jimklimov+nut@gmail.com>

- include/nutconf.hpp: fix getStr() for string literals after refactoring for case-sensitivity [#694]
- common/nutconf.cpp, include/nutconf.hpp: allow to get some entries by case-insensitive names [#2739]

### 2.243. 2024-12-30 Jim Klimov <jimklimov@gmail.com>

- configure.ac, scripts/Solaris/nut-driver-enumerator.xml.in, scripts/Solaris/nut-driver.xml.in, scripts/Solaris/nut-monitor.xml.in, scripts/Solaris/nut-server.xml.in, scripts/Solaris/nut.xml.in, scripts/upsdrvsvcctl/nut-driver-enumerator.sh.in: configure.ac, scripts/upsdrvsvcctl/nut-driver-enumerator.sh.in, scripts/Solaris/*.xml.in: when suggesting man pages in service metadata, refer to packaged NUT_MANDIR [#722]
- common/common.c, scripts/Solaris/nut-driver-enumerator.xml.in, scripts/Solaris/nut-driver.xml.in, scripts/Solaris/nut-monitor.xml.in, scripts/Solaris/nut-server.xml.in, scripts/Solaris/nut.xml.in, …/nut-driver-enumerator-daemon-activator.path.in, …/nut-driver-enumerator-daemon-activator.service.in, scripts/systemd/nut-driver-enumerator-daemon.service.in, scripts/systemd/nut-driver-enumerator.path.in, scripts/systemd/nut-driver-enumerator.service.in, scripts/systemd/nut-driver@.service.in, scripts/systemd/nut-monitor.service.in, scripts/systemd/nut-server.service.in, scripts/systemd/nut.target, scripts/upsdrvsvcctl/nut-driver-enumerator.sh.in: common/common.c, scripts/upsdrvsvcctl/nut-driver-enumerator.sh.in, scripts/systemd/nut*.in, scripts/Solaris/*.xml.in: when suggesting man pages for further reading, refer to correct (configurable) section identifier [#722]
- autogen.sh: fix typo in message
- docs/Makefile.am, docs/man/Makefile.am: */Makefile.am: Use *.txt-prepped files not as symlinks but as sources to provide corrected man page sections where needed
- configure.ac: fix fallback for NUT_WEBSITE_BASE [#722]
- scripts/upsdrvsvcctl/nut-driver-enumerator.sh.in: complete smf_setDocLink() for actual SMF command syntax [#722]
- scripts/Solaris/precheck.py.in: handle new string semantics for Python 3
- scripts/Solaris/pkginfo.in: refer to NUT_WEBSITE_BASE as vendor URL [#722]
- UPGRADING.adoc, docs/nut.dict, scripts/Solaris/Makefile.am: scripts/Solaris/Makefile.am: consider ISA info (specific 32/64-bit CPU support) of build target host in package naming
- scripts/Solaris/precheck.py.in: consider ISA info (specific 32/64-bit CPU support) of installation host vs. build target host
- Makefile.am, UPGRADING.adoc, scripts/Solaris/Makefile.am: */Makefile.am: name HPUX and Solaris package files with a dash before the SEMVER part
- scripts/Solaris/nut-driver-enumerator.xml.in: fix envvar passing to NDE script launch
- scripts/Solaris/nut-driver-enumerator.xml.in: missed one set of documentation links [#722]
- INSTALL.nut.adoc, Jenkinsfile-dynamatrix, NEWS.adoc, README.adoc, UPGRADING.adoc, ci_build.sh, clients/nutclient.cpp, docs/asciidoc-vars.conf, docs/config-prereqs.txt, drivers/apc-mib.c, drivers/bcmxcp_usb.c, drivers/blazer_ser.c, drivers/blazer_usb.c, drivers/delta_ups-hid.c, drivers/dstate.c, drivers/hidparser.c, drivers/nutdrv_qx_voltronic.c, scripts/installer/common/shutdown, tests/getvaluetest.c, tests/nutlogtest.c, tools/nut-dumpdiff.sh, tools/nut-scanner/nutscan-ip.c: Standardize wording of "vs." over "vs" (comments, messages, docs) to be consistent

### 2.244. 2024-12-30 Jim Klimov <jimklimov+nut@gmail.com>

- NEWS.adoc, UPGRADING.adoc, configure.ac, docs/configure.txt, docs/man/.gitignore, docs/man/Makefile.am, docs/nut.dict: configure.ac, docs/man/Makefile.am, et al: allow configuring man page section names Certain distributions have to patch built NUT artifacts for their packaging with their man page sectioning standards. Make life easier, be friendlier out of the box :)
- include/nutconf.hpp: add support for STATEPATH in ups.conf [#694]
- scripts/augeas/nutupsconf.aug.tpl: add support for STATEPATH in ups.conf [#694]
- configure.ac, scripts/systemd/.gitignore, scripts/systemd/Makefile.am, scripts/systemd/{nut.target ⇒ nut.target.in}: scripts/systemd/nut.target et al: make it a .in template [#722]

### 2.245. 2024-12-29 Jim Klimov <jimklimov+nut@gmail.com>

- scripts/augeas/nutupsconf.aug.tpl: USB drivers should now accept a `LIBUSB_DEBUG=INTEGER` setting in `ups.conf` [#2616]
- NEWS.adoc, UPGRADING.adoc, conf/ups.conf.sample, conf/upsd.conf.sample, docs/man/ups.conf.txt, docs/man/upsd.conf.txt, server/conf.c: server/conf.c and docs: allow setting STATEPATH via ups.conf [#694]
- NEWS.adoc, conf/ups.conf.sample, docs/man/ups.conf.txt, drivers/main.c: drivers/main.c and docs: allow setting STATEPATH via ups.conf [#694]
- docs/man/upsd.conf.txt, conf/upsd.conf.sample: clarify STATEPATH entanglement of upsd and drivers, and envvar override [#694]

### 2.246. 2024-12-28 Yevgeniy Kuksenko <2882631+ykuksenko@users.noreply.github.com>

- drivers/Makefile.am, drivers/ecoflow-hid.c, drivers/ecoflow-hid.h, drivers/usbhid-ups.c, scripts/upower/95-upower-hid.hwdb: EcoFlow River 3\+ and Delta 3+ support Basic status works (charging, discharging, online, onbattery, …). Charge level works. Discharge level from app shows correctly. Any sort of control does not seem to work for load or beeper/light. See code comments for details.

### 2.247. 2024-12-25 Jim Klimov <jimklimov+nut@gmail.com>

- scripts/Windows/wininit.c: refer to local man (ifdef WITH_DOCS) and website page for nut.exe wrapper [#722]
- scripts/upsdrvsvcctl/nut-driver-enumerator.sh.in: smf_setDocLink(): complete the proposed SMF implementation [#722]

### 2.248. 2024-12-24 Jim Klimov <jimklimov+nut@gmail.com>

- common/common.c: suggest_doc_links(): do not preallocate buf2, ensure use of only basename of a program [#722]
- drivers/upsdrvctl.c: refer to local man (ifdef WITH_DOCS) and website page for this tool [#722]
- scripts/upsdrvsvcctl/upsdrvsvcctl.in: refer to local man and website pages for this tool [#722]
- scripts/upsdrvsvcctl/nut-driver-enumerator.sh.in: refer to local man and website pages for this tool [#722]
- clients/upsc.c, clients/upscmd.c, clients/upsrw.c, clients/upslog.c, clients/upsmon.c, clients/upssched.c: refer to local man (ifdef WITH_DOCS) and website page for these tools [#722]
- tools/nutconf/nutconf-cli.cpp: refer to local man (ifdef WITH_DOCS) and website page for the nutconf tool [#722]
- tools/nut-scanner/nut-scanner.c, tools/nut-scanner/Makefile.am: refer to local man (ifdef WITH_DOCS) and website page for this tool [#722]

### 2.249. 2024-12-23 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/main.c: main(): avoid notification at exit after just showing help
- drivers/main.c: move WIN32 var declarations up in main()
- server/upsd.c: refer to local man (ifdef WITH_DOCS) and website page for the data server [#722]
- server/sockdebug.c, server/pipedebug.c: refer to local man (ifdef WITH_DOCS) and website page for these tools [#722] Reminder: both sources are built as `sockdebug` for different platforms and share the man page.
- NEWS.adoc, common/common.c, drivers/main.c, include/common.h: common/common.c, include/common.h, drivers/main.c: introduce suggest_doc_links() [#722]

### 2.250. 2024-12-22 hajar97 <ehajiyev@gmail.com>

- data/driver.list.in: Update driver.list.in Added report for Greencell PowerProof 2000

### 2.251. 2024-12-22 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/blazer_ser.c, drivers/blazer_usb.c, drivers/main.c, drivers/nutdrv_qx.c, drivers/usbhid-ups.c: drivers/main.c: refer to local man (ifdef WITH_DOCS) and website page for the driver [#722]
- scripts/upsdrvsvcctl/nut-driver-enumerator.sh.in: introduce *_setDocLink() to refer to specific driver man pages, provide systemd implementation [#722]

### 2.252. 2024-12-21 Jim Klimov <jimklimov+nut@gmail.com>

- NEWS.adoc, configure.ac, …/nut-driver-enumerator-daemon-activator.path.in, …t-driver-enumerator-daemon-activator.service.in, …/nut-driver-enumerator-daemon.service.in, scripts/systemd/nut-driver-enumerator.path.in, scripts/systemd/nut-driver-enumerator.service.in, scripts/systemd/nut-driver.target, scripts/systemd/nut-driver@.service.in, scripts/systemd/nut-monitor.service.in, scripts/systemd/nut-server.service.in, scripts/systemd/nut.target: scripts/systemd/nut* units: add documentation links [#722]
- scripts/Solaris/nut-driver-enumerator.xml.in, scripts/Solaris/nut-driver.xml.in, scripts/Solaris/nut-monitor.xml.in, scripts/Solaris/nut-server.xml.in: scripts/Solaris/*.xml.in: revise heading comments and documentation links [#722]
- configure.ac: derive NUT_WEBSITE_BASE from PACKAGE_URL [#722]

### 2.253. 2024-12-19 RikyPlaza <158032745+RikyPlaza@users.noreply.github.com>

- scripts/Windows/README.adoc: corrected instructions of pthread installation

### 2.254. 2024-12-19 Jim Klimov <jimklimov+nut@gmail.com>

- m4/nut_check_libmodbus.m4: do not detect other libmodbus features if header was not found [#2289] …in requested location, e.g. wrong path provided by the `--with-modbus-includes=-I.../include` parameter without the `/modbus` sub-directory.
- m4/nut_check_libavahi.m4, m4/nut_check_libfreeipmi.m4, m4/nut_check_libgd.m4, m4/nut_check_libgpiod.m4, m4/nut_check_libmodbus.m4, m4/nut_check_libneon.m4, m4/nut_check_libnetsnmp.m4, m4/nut_check_libnss.m4, m4/nut_check_libopenssl.m4, m4/nut_check_libpowerman.m4, m4/nut_check_libregex.m4, m4/nut_check_libsystemd.m4, m4/nut_check_libusb.m4: m4/nut_check_lib*.m4: use AC_REQUIRE([NUT_CHECK_PKGCONFIG]) etc, not plain macro calls

### 2.255. 2024-12-19 Bill Elliot <bill@wreassoc.com>

- drivers/powervar-cu.c, drivers/powervar-cx.h: Move toward working USB driver — BROKENgit diff

### 2.256. 2024-12-18 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/cps-hid.c: cps_fix_report_desc(): complete the original fix-up for input_logmin/input_logmax vs. high voltage transfer [#1245, #2718]
- docs/nut.dict, scripts/Windows/README.adoc: scripts/Windows/README.adoc: pthreads: comment on issues with "timespec" [#2724]
- scripts/Windows/README.adoc: pthreads: built directly by `make`, should not use $BUILD_FLAG
- scripts/Windows/README.adoc: add a note about not-running builds as root
- scripts/Windows/README.adoc: update markup at start of doc

### 2.257. 2024-12-17 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/mge-hid.c: check that KSTAR is the maker of KSTAR_VENDORID hits [#2661]
- drivers/cps-hid.c: cps_fix_report_desc(): take the higher ground [#2718]
- drivers/cps-hid.c: cps_fix_report_desc(): simplify sizeMax now that original error was caught [#2718]
- drivers/hidparser.c, drivers/cps-hid.c: add comments about presumed LogMin/LogMax error origins [#1024, #1512, #2718]

### 2.258. 2024-12-16 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/mge-hid.c, data/driver.list.in, docs/nut.dict, NEWS.adoc, scripts/upower/95-upower-hid.hwdb: added support for 0x09d6:0x0001 (KSTAR) UPSes using MGE HID [#2661]
- drivers/cps-hid.c: cps_fix_report_desc(): fix powers of 2 maths [#2718]
- drivers/cps-hid.c: cps_fix_report_desc(): update debug-logging [#2718]
- docs/man/usbhid-ups.txt: warn that (some?) CPS models can not use ondelay [#625] …according to support, per https://github.com/networkupstools/nut/issues/625#issuecomment-1790213635
- NEWS.adoc, UPGRADING.adoc, docs/man/usbhid-ups.txt, drivers/cps-hid.c, drivers/usbhid-ups.c, drivers/usbhid-ups.h: drivers/usbhid-ups.{c,h}, docs/man/usbhid-ups.txt, NEWS.adoc, UPGRADING.adoc: introduce DEFAULT_ONDELAY_CPS and DEFAULT_OFFDELAY_CPS on CPS devices [#1394, #432]
- NEWS.adoc, UPGRADING.adoc, docs/man/usbhid-ups.txt, drivers/usbhid-ups.c, drivers/usbhid-ups.h: drivers/usbhid-ups.{c,h}, docs/man/usbhid-ups.txt, NEWS.adoc, UPGRADING.adoc: introduce DEFAULT_POLLFREQ_CPS and suggest pollonly on CPS devices [#1689]
- drivers/usbhid-ups.c: upsdrv_initups(): update comments about logical progression through init
- UPGRADING.adoc: typo fix

### 2.259. 2024-12-13 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/cps-hid.c, NEWS.adoc: cps_fix_report_desc(): address mismatched LogMax for input/output voltages [#1512] Note: not bumping version, as it was done in another commit of same PR #2718
- drivers/cps-hid.c, NEWS.adoc: cps_fix_report_desc(): do actually "set Input Voltage" for a fix [#1245]
- drivers/hidparser.c, drivers/hidtypes.h, NEWS.adoc: track the fact of assumed_LogMax [#1512]
- drivers/cps-hid.c: cps_fix_report_desc(): debug-log if we skipped work, to be clear in troubleshooting
- drivers/cps-hid.c: cps_fix_report_desc(): comment HEX variants of ReportIDs
- NEWS.adoc, drivers/cps-hid.c: drivers/cps-hid.c: cps_fix_report_desc(): line-wrap big comments and debug prints
- NEWS.adoc: regroup "USB-capable drivers generally" entries

### 2.260. 2024-12-12 RikyPlaza <158032745+RikyPlaza@users.noreply.github.com>

- drivers/phoenixcontact_modbus.c: Updated author
- drivers/phoenixcontact_modbus.c: corrected placeholder of fatalx log
- drivers/phoenixcontact_modbus.c: corrected placeholder of fatalx log
- drivers/phoenixcontact_modbus.c: corrected placeholder of fatalx log
- drivers/phoenixcontact_modbus.c: corrected placeholder of fatalx log

### 2.261. 2024-12-12 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/usbhid-ups.c, NEWS.adoc: apply disable_fix_report_desc, interruptsize and interruptonly before comm_driver→open_dev() [#1512, #1575]
- docs/nut-names.txt: update markup and a bit of wording
- NEWS.adoc: highlight recent fixes to .circleci/config.yml
- .circleci/config.yml: fetch git tags to help SEMVER look right (optionally) [#1949]
- data/driver.list.in: add Ippon Innova RT 3/1 models [#2712]
- NEWS.adoc: update for phoenixcontact_modbus PR list [#2716]
- drivers/phoenixcontact_modbus.c: fix "Uknown" typo [#2716]
- drivers/phoenixcontact_modbus.c: fix conversion/printing of certain data types [#2716]
- drivers/phoenixcontact_modbus.c: fix trailing whitespace and indentations [#2716]
- drivers/phoenixcontact_modbus.c: constrain DRIVER_VERSION format, add recent author [#2716]

### 2.262. 2024-12-11 RikyPlaza <158032745+RikyPlaza@users.noreply.github.com>

- drivers/phoenixcontact_modbus.c: Removed break after fatalx func.
- drivers/phoenixcontact_modbus.c: corrected placeholder of fatalx log
- drivers/phoenixcontact_modbus.c: Corrected fatalx logs.
- drivers/phoenixcontact_modbus.c: inserted comment for new method and updated version.
- drivers/phoenixcontact_modbus.c: Corrected alarms1 register reading for QUINT4 UPS.
- drivers/phoenixcontact_modbus.c: Added management for different QUINT and QUINT4 UPS models.
- drivers/phoenixcontact_modbus.c: Corrected register concatenation.
- drivers/phoenixcontact_modbus.c: Added part number variable in exit message when it’s not recognized.
- drivers/phoenixcontact_modbus.c: First implementation of the new logic to establish UPS model.

### 2.263. 2024-12-10 Viktor Drobot <linux776@gmail.com>

- drivers/nutdrv_qx_innovart31.c: We can use full Blazer claiming and initialization routines now
- drivers/nutdrv_qx_innovart31.c: Giving up on reading firmware and serial number data from UPS
- drivers/nutdrv_qx_innovart31.c: Firmware reading leads to the driver stale state
- drivers/nutdrv_qx_innovart31.c: Checked remaining classic Qx commands (beeper toggle removed as not recognized by hardware). Added firmware version and serial number of UPS. Reorganized readings to minimize data between host and UPS according to the developer docs. Added known input, output and bypass readings as comments for future development (3/3 versions).

### 2.264. 2024-12-10 Jim Klimov <jimklimov+nut@gmail.com>

- .circleci/config.yml: uncomment HOMEBREW_NO_AUTO_UPDATE=1 to cut down pre-build CI overhead for faster turnaround (1hr timeout) [#1579] Currently Homebrew auto-update done before we install anything takes 45-50 minutes, so we often don’t have time to complete even configuration for our actual CI tests (subject to CircleCI server farm congestion, I guess). This also bites a big chunk from the monthly opensource credits available for the builds. Note the baseline image currently uses a slightly older Python as well. But the speedup frmo 45\+ to 3.5min is commendable!

### 2.265. 2024-12-09 Viktor Drobot <linux776@gmail.com>

- drivers/nutdrv_qx_innovart31.c: Use battery runtime and charge data from UPS

### 2.266. 2024-12-09 Jim Klimov <jimklimov+nut@gmail.com>

- docs/nut.dict: add MGE "designator" [#2713]
- drivers/nhs_ser.c: pass buffer sizes as size_t not int [#2692]
- drivers/nhs_ser.c: interpret_pkt_data(): cache ah, pf, va, numbat, vbat and min_input_power in static vars [#2692]
- docs/nut-names.txt: stress that `DOMAIN.CONTEXT.SPEC` suffixes are not complete names
- drivers/nhs_ser.c: upsdrv_updateinfo(): refactor away interpret_pkt_hwinfo() and interpret_pkt_data() logic, separated by domain [#2692] Also rename some data points that do not conform to NUT standards, or drop if redundant.
- drivers/nhs_ser.c: upsdrv_updateinfo(): revise byte-reading loop vs. packet data interpretation; un-indent more code [#2692] Add range-check to not overflow the datapacket[] buffer.

### 2.267. 2024-12-09 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- data/cmdvartab: remove typo
- data/cmdvartab: typo for rerun CI

### 2.268. 2024-12-08 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/nhs_ser.c: size porta[] as PATH_MAX [#2692]
- drivers/nhs_ser.c: use strncpy() to init porta[] [#2692]
- drivers/nhs_ser.c: upsdrv_updateinfo(): refactor with reconnect_ups_if_needed() [#2692]
- drivers/nhs_ser.c: upsdrv_updateinfo(): revise reconnections with data-stale related messages and status changes [#2692]
- drivers/nhs_ser.c: upsdrv_updateinfo(): simplify reconnect-check, un-indent main code a bit [#2692] Fixed the retries from being an infinite loop along the way…
- drivers/nhs_ser.c: reshuffle HW init code between upsdrv_initups() and upsdrv_initups() [#2692]
- docs/new-drivers.txt: clarify relation of dstate_addcmd() and upsh.instcmd and upsdrv_initinfo()
- drivers/nutdrv_qx.c: bump DRIVER_VERSION due to addition of innovart31 subdriver [#2712]
- docs/nutdrv_qx-subdrivers.txt, drivers/nutdrv_qx.c, docs/nut.dict: clarify that "subdriver" is for Serial-over-USB dialect, and "protocol" is for Qx dialect [#2712]
- NEWS.adoc: introduced `innovart31` in nutdrv_qx [#2712]

### 2.269. 2024-12-08 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- data/cmdvartab, docs/nut-names.txt: some more vars added
- docs/nut-names.txt: add device.usb.version to nut-names.txt
- data/cmdvartab: add device.x descrptions \+ more to cmdvartab
- data/cmdvartab, docs/nut-names.txt: battery.charger.type description changed
- data/cmdvartab, docs/nut-names.txt: spme missing vars added

### 2.270. 2024-12-06 Viktor Drobot <linux776@gmail.com>

- docs/nut.dict: Fix aspell complaining about InnovaRT
- docs/man/nutdrv_qx.txt, docs/nutdrv_qx-subdrivers.txt, drivers/Makefile.am, drivers/nutdrv_qx.c, drivers/nutdrv_qx_blazer-common.c, drivers/nutdrv_qx_blazer-common.h, drivers/nutdrv_qx_innovart31.c, drivers/nutdrv_qx_innovart31.h: First attempt to add support for Innova RT 3/1

### 2.271. 2024-12-06 Jim Klimov <jimklimov+nut@gmail.com>

- clients/upsmon.c: upsmon_cleanup(): free(configfile) in the end
- clients/upsmon.c: ups_free(): release ups→status_tokens if needed [#415, #2709]
- tests/NIT/nit.sh: refer to scripts/valgrind for debugging in a sandbox
- tests/NIT/nit.sh: generatecfg_upsmon_trivial() allow to toggle NOTIFYFLAG targets
- common/common.c: Revert "common/common.c: only close_sdbus_once() if we are the same PID that originally opened it [#1070]" This reverts commit a6496a6af1c1b90ca4b836bd0f0cf9c07d6ade3b: close from a child process does not seem to impact parent, but a non-close is a memory leak when such child exits.
- clients/upsmon.c: addups(): start with definitive states of all fields Kudos to `make check-NI-sandbox-devel` and LD_LIBRARY_PATH=`pwd`/clients/.libs valgrind --leak-check=full --show-leak-kinds=all --track-origins=yes ./clients/.libs/upsmon -F
- clients/upsmon.c: redefine_ups(): comment a concern about "pv" changes

### 2.272. 2024-12-05 RikyPlaza <158032745+RikyPlaza@users.noreply.github.com>

- drivers/phoenixcontact_modbus.c: Updated driver version with beta one
- drivers/phoenixcontact_modbus.c: Added NONE value for models enumeration and managed in switch statemets

### 2.273. 2024-12-05 Jim Klimov <jimklimov+nut@gmail.com>

- clients/upsmon.c: parse_status(): fix releasing of ups→status_tokens [#415, #2709]
- clients/upsmon.c: notify(): clarify (when debug-logging) upsmon-centric messages if upsname==NULL [#415, #2709]
- clients/upsmon.c: change time maths in delay between main loop cycles from time_t to more precise timeval [#1070]
- clients/upsmon.c: report start/end/duration of the "sleepval" delay between main loop cycles [#1070]
- clients/upsmon.c: break the main sub-loop where we check sleep_inhibitor_status also if exit_flag gets raised (e.g. Ctrl\+C during the wait) [#1070]
- common/common.c: only close_sdbus_once() if we are the same PID that originally opened it [#1070]
- common/common.c: debug-log isPreparingForSleep() outcomes (when extremely high verbosity level is on) [#1070]
- common/common.c: refactor upsnotify_suggest_NUT_QUIET_INIT_UPSNOTIFY_once() [#1590, #2136]
- tests/NIT/nit.sh: generatecfg_upsmon_trivial(): refer to NOTIFYCMD=…notifyme-debug where possible [#2709]
- tests/NIT/nit.sh: testcase_sandbox_upsc_query_timer(): add a retry with longer delay [#2709]
- tests/NIT/Makefile.am: allow to pass custom NUT_PORT and NIT_CASE [#2709] …default the latter to `testgroup_sandbox_upsmon_master` now (includes the earlier `testcase_sandbox_start_drivers_after_upsd`)
- scripts/misc/notifyme-debug: honour TEMPDIR or TMPDIR set by caller; fall back to /dev/shm or /tmp otherwise [#2709]
- conf/upsmon.conf.sample.in: suggest NOTIFYFLAG for OTHER/NOTOTHER too [#415]

### 2.274. 2024-12-04 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/cps-hid.c, NEWS.adoc: add ups.temperature [#2711] Kudos to Cyber Energy (affiliate of CPS) per https://alioth-lists.debian.net/pipermail/nut-upsdev/2024-December/008069.html

### 2.275. 2024-12-03 Jim Klimov <jimklimov+nut@gmail.com>

- clients/upsmon.h, conf/upsmon.conf.sample.in, docs/man/upsmon.conf.txt: clients/upsmon.h, docs: default "ALARM" message format to two "%s" placeholders [#415]
- clients/upsmon.c: ups_is_alarm(): track if ups.alarm value changed, re-notify [#415]
- clients/upsmon.c: allow to get_var(ups, "alarm"…) and use it in ups_is_alarm() notification [#415]
- docs/new-drivers.txt: in "Status data", stress the life-cycle of `ups.status` flag tokens [#2708]
- NEWS.adoc, clients/upsmon.c, clients/upsmon.h, common/nutconf.cpp, common/nutwriter.cpp, conf/upsmon.conf.sample.in, docs/man/nutconf.txt, docs/man/upsmon.conf.txt, docs/man/upsmon.txt, docs/nut.dict, include/nutconf.hpp, scripts/augeas/nutupsmonconf.aug.in, tools/nutconf/nutconf-cli.cpp: upsmon code, docs, conf: introduce "OTHER"/"NOTOTHER" notifications for unknown tokens in `ups.status` [#415]
- NEWS.adoc, clients/upsmon.c, clients/upsmon.h: clients/upsmon.{c,h}, NEWS.adoc: revise do_notify() to allow passing an extra arg into formatting strings with two "%s" placeholders [#415]
- clients/upsmon.c, NEWS.adoc: optimize parse_status() by not checking further strings if we had a match; report unexpected tokens [#415, #2708]
- drivers/usbhid-ups.c, drivers/netxml-ups.c, NEWS.adoc, UPGRADING.adoc: handle STATUS_BIT(NOBATTERY) to also status_set("RB") [#415]
- clients/upsmon.c, clients/upsmon.h, conf/upsmon.conf.sample.in, docs/man/upsmon.conf.txt, docs/man/upsmon.txt: clients/upsmon.{c,h}, docs, conf: apply suggestions from issue #415 discussion adding to PR #2658 changes Previously merged-in the couple of commits from issue https://github.com/networkupstools/nut/issues/415 proposal at https://github.com/networkupstools/nut/tree/upsmon_alarm for posterity, now cherry-picking some changes and further discussion ideas from mailing list thread at http://lists.alioth.debian.org/pipermail/nut-upsuser/2017-April/010591.html Closes: #415

### 2.276. 2024-12-03 Bill Elliot <bill@wreassoc.com>

- drivers/powervar-cu.c: Change comment above VENDORID so USB is identified correctly as Powervar.
- drivers/Makefile.am, drivers/powervar-c.h, drivers/powervar-cs.c, drivers/powervar-cu.c, drivers/{powervar-c.c ⇒ powervar-cx.h}: USB building and communicating. Trying common variable and function file for serial and usb drivers.

### 2.277. 2024-12-02 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/mge-hid.c: simplify debug printouts with NUT_STRARG() [#2684, #1737]
- NEWS.adoc, docs/nut.dict, drivers/upsdrvquery.c: drivers/upsdrvquery.c, NEWS.adoc: upsdrvquery_read_timeout(): fix private use of timeval={-1,-1} as select(…, NULL) for indefinite wait [#1922, #2392, #2686, #2670]
- clients/upscmd.c, clients/upsrw.c: clients/ups{rw,cmd}.c: enable use of NUT_DEBUG_LEVEL envvar
- clients/upscmd.c, clients/upsrw.c: clients/ups{rw,cmd}.c: when reporting "OK" without "TRACKING", issue a debug message about its limited usefullness
- data/cmdvartab: document CMDDESC shutdown.default [#2686]
- drivers/dstate.c: revise logging of "Got INSTCMD, but driver lacks a handler" [#2686]

### 2.278. 2024-12-02 Greg Troxel <gdt@lexort.com>

- tests/nutipc_ut.cpp: tests: Do not expect signals to be messages POSIX does not require 1:1 delivery per kill() call. Adjust the test to not require behavior that 1) POSIX does not require and 2) is only probabalistically observed to happen, even if "most of the time".
- include/nutipc.hpp: core ipc: Handle select returning EINTR

### 2.279. 2024-12-02 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- drivers/mge-hid.c: typo space removed

### 2.280. 2024-12-01 desertwitch <24509509+desertwitch@users.noreply.github.com>

- drivers/mge-hid.c: comment regarding ChargerType

### 2.281. 2024-12-01 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/mge-hid.c: restore white-space (TAB indentation and between decl type and varname)
- drivers/mge-hid.c: restore white-space (TAB indentation and between decl type and varname) [#2684]
- docs/snmp-subdrivers.txt: update with snmp_info_default() macro example [#2285]
- docs/new-drivers.txt: quote driver names; note modbus unrelated drivers so far [#50, #1765]
- NEWS.adoc: moved phoenixcontact_modbus update to other drivers [#2689]
- drivers/phoenixcontact_modbus.c: fix use of pragmas for default switch cases [#2689]
- drivers/phoenixcontact_modbus.c: no break after fatalx() [#2689]

### 2.282. 2024-12-01 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- drivers/mge-hid.c: add debug message for bypass/eco outside limits
- drivers/mge-hid.c: Fix for bypass/eco when no values or outside of limits

### 2.283. 2024-11-30 Jim Klimov <jimklimov@gmail.com>

- drivers/nhs_ser.c: populate missed explicit method parameter [#2692]

### 2.284. 2024-11-30 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- drivers/mge-hid.c: add debug log when enter to eco/bypass modes
- drivers/mge-hid.c: fix eco vars in debug meassage
- drivers/mge-hid.c: Fix for bypass limit In case we dont have Bypass transfer limit variables but still have ability to enter Bypass mode

### 2.285. 2024-11-29 RikyPlaza <158032745+RikyPlaza@users.noreply.github.com>

- drivers/phoenixcontact_modbus.c: Handled default case with error
- drivers/phoenixcontact_modbus.c: Re-implemented default cases.
- drivers/phoenixcontact_modbus.c: Extended comment to "default" label example

### 2.286. 2024-11-29 Jim Klimov <jimklimov@gmail.com>

- NEWS.adoc, configure.ac, docs/man/Makefile.am, docs/man/nhs_ser.txt, docs/nut.dict, drivers/Makefile.am: configure.ac, drivers/Makefile.am, docs/man/Makefile.am, docs/man/nhs_ser.txt, NEWS.adoc: temporarily constrain nhs_ser to Linux-only NUT builds [#2692]

### 2.287. 2024-11-29 Jim Klimov <jimklimov+nut@gmail.com>

- data/driver.list.in: add usbhid-ups supported Ippon models [#2702]
- drivers/nhs_ser.c: hide upsdrv_updateinfo() debug log of processing at verbosity 3-4_ [#2692]
- drivers/nhs_ser.c: keep debug log of main milestones and errors at verbosity 1, add func [#2692]
- drivers/nhs_ser.c: quieter logging in print_pkt_hwinfo() and print_pkt_data() [#2692]
- drivers/nhs_ser.c: log method starting/ending quieter and with use of func [#2692]
- drivers/nhs_ser.c: upsdrv_updateinfo(): rename "nhs." datapoints into "experimental.nhs." namespace [#2692]
- drivers/nhs_ser.c: upsdrv_updateinfo(): FIXME commented - same criteria used for 3 alarms [#2692]
- drivers/nhs_ser.c: memory robustness: strcpy⇒strncpy [#2692]
- drivers/nhs_ser.c: memory robustness: sprintf⇒snprintf [#2692]
- drivers/nhs_ser.c: fix code markup into NUT style [#2692] * indent with TAB characters, * separate declaration type and varname with TAB(s), * use space after comma
- drivers/nhs_ser.c: fix "for (int i…)" to use of pre-declared variables [#2692]
- drivers/nhs_ser.c: fix DEFAULLTPERC ⇒ DEFAULTPERC typo in the macro name [#2692]
- drivers/nhs_ser.c: fix comment markup, wrap long lines, inject TABs in structs [#2692] Also drop comments from standalone program legacy now that this driver is an integrated part of NUT codebase.
- drivers/nhs_ser.c: drivers/nhs-nut.c: fix compiler complaints - sprintf() from and to same variable [#2692] nhs_ser.c: In function ‘upsdrv_updateinfo’: nhs_ser.c:1858:37: error: ‘sprintf’ argument 3 overlaps destination object ‘alarm’ [-Werror=restrict] 1858 \| sprintf(alarm,"%s %s",alarm,"|UPS IN BATTERY MODE|"); \| ^~~~~~~~~~~~~~~~~~~~~~~~~~\
- drivers/nhs_ser.c: upsdrv_updateinfo(): refactor debug of bad mains [#2692]

### 2.288. 2024-11-29 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- drivers/mge-hid.c: change voltage limit setting same as frequency in eco function also
- drivers/mge-hid.c: change voltage limit setting same as frequency
- drivers/mge-hid.c: move NUT_UNUSED_VARIABLE(value); back down
- drivers/mge-hid.c: change the state for debug when no eco transfer limits avalible to use defaults
- drivers/mge-hid.c: change vars in eaton_input_eco_mode_check_range()
- drivers/mge-hid.c: change vars in eaton_input_bypass_check_range()
- data/cmdvartab, docs/nut-names.txt: much clear description for input.transfer.bypass.forced

### 2.289. 2024-11-28 fenugrec <fenugrec@users.sourceforge.net>

- drivers/libusb1.c: fix wrong return value of nut_libusb_get_interrupt() cf github #2401. When global var interrupt_size is not set, a transfer size of SMALLBUF (512) is requested when calling libusb_interrupt_transfer(). Our function nut_libusb_get_interrupt() should return the actual transferred size. Otherwise, the caller will attempt to parse any uninitialized data in the buffer after the response. In libusb0.c this was done correctly by using the return value of usb_interrupt_read(). With libusb1, the transferred size is written to tmpbufsize, and should therefore be used as the return val.

### 2.290. 2024-11-28 RikyPlaza <158032745+RikyPlaza@users.noreply.github.com>

- drivers/phoenixcontact_modbus.c: Added pragma statemets as per tip to avoid compiler complains on "default" label in switch statements.

### 2.291. 2024-11-28 Lucas Bocchi <lucas.bocchii@gmail.com>

- drivers/nhs_ser.c: Another miscalculation in battery time duration.
- drivers/nhs_ser.c: Change on line 1936 - Battery voltage hardcoded in 12.0 v

### 2.292. 2024-11-28 Jim Klimov <jimklimov+nut@gmail.com>

- docs/developers.txt, docs/nut.dict: docs/developers.txt: clarify pragmas in switch/case/default vs. enum [#2689, #823]
- NEWS.adoc, drivers/dstate.c: drivers/dstate.c: fflush(stdout) after dstate_dump() [#2695]
- drivers/libusb1.c: nut_libusb_open(): fix if-clause typo to report that no devices were accessible (and none others matched) [#2699]
- NEWS.adoc, drivers/libusb0.c, drivers/libusb1.c: drivers/libusb{0,1}.c, NEWS.adoc: report if some devices WERE accessible but did not match [#2699]

### 2.293. 2024-11-28 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- drivers/mge-hid.c: 9PX added to comments
- drivers/mge-hid.c: add 9PX models also
- drivers/mge-hid.c: change to small chars
- drivers/mge-hid.c: added Eaton 9SX

### 2.294. 2024-11-27 Lucas Bocchi <lucas.bocchii@gmail.com>

- drivers/nhs_ser.c: Error on line 1717, on function to reopen serial in case of problem. We have default values but I set with variable porta and baudrate the correct port and speed.

### 2.295. 2024-11-27 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/nhs_ser.c: drivers/nhs-nut.c: fix compiler complaints - float overflow [#2692] CodeQL alert: * Multiplication result converted to larger type High * Multiplication result may overflow float before it is converted to double.
- drivers/nhs_ser.c: drivers/nhs-nut.c: fix compiler complaints - unused methods [#2692] Hide them away: nhs_ser.c:939:15: error: unused function strtolow [-Werror,-Wunused-function] static char
- strtolow(char* s) { ^ nhs_ser.c:902:12: error: unused function write_serial [-Werror,-Wunused-function] static int write_serial(int fd, const char * dados, int size) { \^ 2 errors generated.
- docs/man/nhs_ser.txt, drivers/nhs_ser.c: introduce option flags for debug_pkt_raw, debug_pkt_data, debug_pkt_hwinfo [#2692] Also helps avoid dead code and this warning: nhs_ser.c:467:13: error: unused function print_pkt_data [-Werror,-Wunused-function] static void print_pkt_data(pkt_data data) { \^
- drivers/nhs_ser.c: drivers/nhs-nut.c: fix compiler complaints - shadowed variables (serial_fd) [#2692]
- drivers/nhs_ser.c: drivers/nhs-nut.c: update © heading [#2692]
- drivers/nhs_ser.c: drivers/nhs-nut.c: fix compiler complaints - comparing floating-points [#2692] nhs_ser.c:1873:74: error: comparing floating point with == or != is unsafe [-Werror,-Wfloat-equal] perc = get_vin_perc("vin_low_warn_perc") == get_vin_perc("vin_low_crit_perc") ? 2 : 1; ~~~~~~~~~~~~~~~~ \^ ~~~~~~~~~~~~~~~~\
- drivers/nhs_ser.c: drivers/nhs-nut.c: fix compiler complaints - casting round() to int/long [#2692] This is an odd one, see https://stackoverflow.com/a/43481925/4715872 nhs_ser.c:1865:74: error: cast from function call of type double to non-matching type int [-Werror,-Wbad-function-cast] dstate_setinfo("ups.realpower","%d",(int)round(vpower)); ^~~~~~\~ The `lrint()` family of methods should be part of C99 and above, returning a `long` approximation of a `double` or `float` argument. Had to adjust dstate_setinfo() parameters from (unsigned) int to long.
- drivers/nhs_ser.c: drivers/nhs-nut.c: fix compiler complaints - variable length array [#2692] nhs_ser.c:897:21: error: variable length array used [-Werror,-Wvla] uint8_t message[size]; ^~\
- drivers/nhs_ser.c: drivers/nhs-nut.c: fix compiler complaints - mixing declarations and code [#2692] nhs_ser.c:904:17: error: mixing declarations and code is incompatible with standards before C99 [-Werror,-Wdeclaration-after-statement] ssize_t bytes_written = write(serial_fd, message,size); \^
- drivers/nhs_ser.c: drivers/nhs-nut.c: fix compiler complaints - shadowed variables [#2692] nhs_ser.c:519:32: error: declaration shadows a variable in the global scope [-Werror,-Wshadow] static int openfd(const char * porta, int BAUDRATE) { ^ nhs_ser.c:247:13: note: previous declaration is here static char porta[1024] = DEFAULTPORT; ^ nhs_ser.c:1943:42: error: declaration shadows a local variable [-Werror,-Wshadow] for (int i = 0; i < 5; i+\+) { ^ nhs_ser.c:1657:18: note: previous declaration is here unsigned int i = 0; \^
- drivers/nhs_ser.c: drivers/nhs-nut.c: fix compiler complaints - static vars/methods and strict parameters [#2692] * Static internal methods and pre-declarations on top of file: nhs_ser.c:1549:14: error: no previous prototype for function get_va [-Werror,-Wmissing-prototypes] unsigned int get_va(int equipment) { ^ nhs_ser.c:1549:1: note: declare static if the function is not intended to be used outside of this translation unit unsigned int get_va(int equipment) { ^ static * Explicit void args: nhs_ser.c:1571:20: error: this old-style function definition is not preceded by a prototype [-Werror,-Wstrict-prototypes] unsigned int get_ah() { \^
- drivers/Makefile.am: Rename "nhs-nut" to "nhs_ser" follow-up [#2692]
- drivers/nhs_ser.c: update comment about use of "clang --analyze" [#2692]
- data/driver.list.in: update with devices supported by nhs_ser driver [#2692] List extracted from current driver code with grep strcpy(data.upsdesc drivers/nhs_ser.c | \ sed s/\^ strcpy(data.upsdesc,"\(.\)".*$/"NHS Sistemas Eletronicos LTDA"\t"ups"\t"2"\t"\1"\t"Serial port"\t"nhs_ser"/ \ >> data/driver.list.in
- NEWS.adoc, docs/man/nhs_ser.txt, docs/nut.dict: NEWS.adoc, docs/man/nhs_ser.txt: rephrase naming of devices covered by nhs_ser driver [#2692]
- NEWS.adoc, docs/man/Makefile.am, docs/man/{nhs-nut.txt ⇒ nhs_ser.txt}, drivers/Makefile.am, drivers/{nhs-nut.c ⇒ nhs_ser.c}: Rename "nhs-nut" to "nhs_ser" [#2692]
- docs/man/Makefile.am, docs/man/nhs-nut.txt, docs/nut.dict: docs/man/nhs-nut.txt: introduce new driver manpage [#2692]
- drivers/nhs-nut.c: revise upsdrv_makevartable(): fix help messages [#2692]
- drivers/nhs-nut.c: revise upsdrv_makevartable(): use snprintf() and fix some more markup [#2692]
- drivers/nhs-nut.c: revise upsdrv_makevartable() content and markup [#2692]
- drivers/nhs-nut.c: fix DRIVER_VERSION to double-digits [#2692]
- NEWS.adoc, docs/nut.dict: NEWS.adoc: introduce nhs-nut (sic) driver [#2692]
- drivers/nhs-nut.c: fix upsdrv_shutdown() [#2692]
- drivers/nhs-nut.c: fix trailing whitespace [#2692]
- drivers/nhs-nut.c: fix compiler complaints [#2692] nhs-nut.c: In function ‘mount_hwinfo’: nhs-nut.c:786:5: error: missing initializer for field ‘end_marker’ of ‘pkt_hwinfo’ [-Werror=missing-field-initializers] 786 | }; | ^ nhs-nut.c:177:18: note: ‘end_marker’ declared here 177 \| unsigned int end_marker; | ^~~~~\~
- drivers/nhs-nut.c: fix compiler complaints [#2692] Copy-paste typo? nhs-nut.c: In function ‘mount_datapacket’: nhs-nut.c:693:29: error: operation on ‘pktdata.icarregrms_real’ may be undefined [-Werror=sequence-point] 693 \| pktdata.icarregrms_real = pktdata.icarregrms_real = pktdata.icarregrms * 30; \| ~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~\
- drivers/nhs-nut.c: fix compiler complaints [#2692] nhs-nut.c: In function ‘get_bit_in_position’: nhs-nut.c:357:22: error: comparison of integer expressions of different signedness: ‘int’ and ‘size_t’ {aka ‘long unsigned int’} [-Werror=sign-compare] 357 \| if (bit_position >= size * 8) { | ^\~
- drivers/nhs-nut.c: fix compiler complaints [#2692] nhs-nut.c: In function ‘upsdrv_makevartable’: nhs-nut.c:2090:88: error: format ‘%f’ expects argument of type ‘double’, but argument 3 has type ‘int’ [-Werror=format=] 2090 \| sprintf(help,"Voltage In Percentage to calculate warning low level. Default is %0.2f",DEFAULLTPERC); \| ~~^ \| | \| double \| %0.2d etc. for other default macros
- drivers/nhs-nut.c: fix compiler complaints [#2692] nhs-nut.c: In function ‘upsdrv_updateinfo’: nhs-nut.c:1733:53: error: format not a string literal and no format arguments [-Werror=format-security] 1733 \| upsdebugx(1,alarm); | ^~\~
- drivers/nhs-nut.c: fix compiler complaints [#2692] nhs-nut.c:797:29: error: iteration 6 invokes undefined behavior [-Werror=aggressive-loop-optimizations] 797 \| pkthwinfo.status[i] = get_bit_in_position(&datapacket[14],sizeof(datapacket[14]),i,0); \| ~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\~
- drivers/nhs-nut.c: fix compiler complaints [#2692] nhs-nut.c:713:43: error: suggest braces around empty body in an ‘if’ statement [-Werror=empty-body] 713 \| if (pktdata.perc_output > 100); \| ^ nhs-nut.c:713:13: error: this ‘if’ clause does not guard… [-Werror=misleading-indentation] 713 \| if (pktdata.perc_output > 100); | ~ nhs-nut.c:714:17: note: …this statement, but the latter is misleadingly indented as if it were guarded by the ‘if’ 714 \| pktdata.perc_output = 100; | ~~\
- drivers/nhs-nut.c: fix compiler complaints [#2692] nhs-nut.c:604:59: error: unused parameter ‘size’ [-Werror=unused-parameter] 604 \| pkt_data mount_datapacket(unsigned char * datapacket, int size, double tempodecorrido,pkt_hwinfo pkt_upsinfo) { \| ~~~\ nhs-nut.c:604:72: error: unused parameter ‘tempodecorrido’ [-Werror=unused-parameter] 604 \| pkt_data mount_datapacket(unsigned char * datapacket, int size, double tempodecorrido,pkt_hwinfo pkt_upsinfo) { \| ~~~~~~~~~\~
- drivers/nhs-nut.c: fix compiler complaints [#2692] nhs-nut.c: In function ‘print_pkt_data’: nhs-nut.c:464:17: error: zero-length gnu_printf format string [-Werror=format-zero-length] 464 \| upsdebugx(1,""); | ^\~
- drivers/Makefile.am: add nhs-nut to SERIAL_DRIVERLIST [#2692]

### 2.296. 2024-11-27 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- data/cmdvartab, docs/nut-names.txt: more clear description for input.transfer.bypass.forced
- data/cmdvartab: change enable/disable to (enabled or disabled) in cmdvartab

### 2.297. 2024-11-26 RikyPlaza <158032745+RikyPlaza@users.noreply.github.com>

- drivers/phoenixcontact_modbus.c: Removed default case label since clang complains.

### 2.298. 2024-11-26 Lucas Bocchi <lucas.bocchii@gmail.com>

- drivers/nhs-nut.c: Some fixes in 1) Miscalculations of battery voltage and amps 2) Miscalculations in battery capacity 3) Miscalculations in time remaining
- drivers/nhs-nut.c: Function have some errors and again need to re-commit code.
- drivers/nhs-nut.c: Some small fixes in get_bit_in_position()
- drivers/nhs-nut.c: Some minor alterations

### 2.299. 2024-11-25 RikyPlaza <158032745+RikyPlaza@users.noreply.github.com>

- drivers/phoenixcontact_modbus.c: Corrected enum definition.
- NEWS.adoc: Updated NEWS.adoc
- drivers/phoenixcontact_modbus.c: Used enum for model type instead of defines
- drivers/phoenixcontact_modbus.c: Alligned device.model variable
- drivers/phoenixcontact_modbus.c: Review of variable declaration due to clang build failure

### 2.300. 2024-11-25 Lucas Bocchi <lucas.bocchii@gmail.com>

- drivers/nhs-nut.c: First commit of NHS drivers/nhs-nut.c

### 2.301. 2024-11-25 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- drivers/mge-hid.c: fix strcmp

### 2.302. 2024-11-24 RikyPlaza <158032745+RikyPlaza@users.noreply.github.com>

- drivers/phoenixcontact_modbus.c: Avoid to use uint32_t* reading more than one modbus address and corrected alarm trigger (wrong bit used)

### 2.303. 2024-11-24 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- drivers/mge-hid.c: change getinfo for better results

### 2.304. 2024-11-23 RikyPlaza <158032745+RikyPlaza@users.noreply.github.com>

- drivers/phoenixcontact_modbus.c: First review of the driver for pull request #2689

### 2.305. 2024-11-23 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- drivers/mge-hid.c: set value to unused
- data/cmdvartab, docs/nut-names.txt: add info to nut-names,cmdvartab
- drivers/mge-hid.c: cosmetic fix
- drivers/mge-hid.c: rename ecomode.auto.start to ecomode.start.auto
- drivers/mge-hid.c: remove unneeded code from function
- drivers/mge-hid.c: typo fixed
- drivers/mge-hid.c: finalise the function
- drivers/mge-hid.c: remove static from vars
- drivers/mge-hid.c: drop down function for fix
- drivers/mge-hid.c: fix static
- drivers/mge-hid.c: fix if
- drivers/mge-hid.c: more work for function

### 2.306. 2024-11-22 RikyPlaza <rikyrod2001@gmail.com>

- drivers/phoenixcontact_modbus.c: Added management for newer models which have different modbus addresses. Choice is made basing on firmware version.

### 2.307. 2024-11-22 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- drivers/mge-hid.c: str fix
- drivers/mge-hid.c: comments added
- drivers/mge-hid.c: ecomode.auto.start added trying to automate enter to ECO Mode NOT FINISHED !!
- drivers/mge-hid.c: ecomode.auto.start added

### 2.308. 2024-11-21 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- drivers/mge-hid.c, drivers/usbhid-ups.h: comments changes
- drivers/mge-hid.c: more small comments changes
- docs/nut-names.txt: fix again
- docs/nut-names.txt: fix nut-names.txt

### 2.309. 2024-11-20 Jim Klimov <jimklimov+nut@gmail.com>

- scripts/python/app/NUT-Monitor: improve portability (especially in testing) by not relying on only shebang
- scripts/python/app/NUT-Monitor-py2gtk2.in, scripts/python/app/NUT-Monitor-py3qt5.in: scripts/python/app/NUT-Monitor-py3qt5.in and NUT-Monitor-py2gtk2.in: if SCRIPTDIR/../module/PyNUT.py exists, import it preferentially

### 2.310. 2024-11-20 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- drivers/mge-hid.c: small comments added
- drivers/mge-hid.c: small comments change
- drivers/usbhid-ups.h: small comment added
- drivers/usbhid-ups.c, drivers/usbhid-ups.h: add ess mode
- drivers/mge-hid.c: small comments change
- data/cmdvartab, docs/nut-names.txt, drivers/mge-hid.c: rename input.transfer.forced to input.transfer.bypass.forced

### 2.311. 2024-11-19 desertwitch <24509509+desertwitch@users.noreply.github.com>

- drivers/mge-hid.c: reset ABM path when ABM not enabled

### 2.312. 2024-11-19 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/main.c: do_loop_shutdown_commands(): handle "shutdown.default" as upsdrv_shutdown() in main loop too [#2670]
- drivers/dstate.c, drivers/main.c, drivers/main.h, drivers/skel.c: Revert "drivers/main.{c,h}, drivers/dstate.c: introduce main_instcmd_fallback() so drivers might implement their own "shutdown.default" at will [#2670]" This reverts commit 25250b02aea4e31ba20a17a33e6cf22cfaf27135: too messy in logs where driver.instcmd() think they are last in stack.
- drivers/main.c: move do_forceshutdown handling to be after upsdrv_initinfo() where we register INSTCMD handlers [#2670]
- drivers/adelsystem_cbi.c, drivers/al175.c, drivers/apc_modbus.c, drivers/apcsmart-old.c, drivers/apcsmart.c, drivers/apcupsd-ups.c, drivers/asem.c, drivers/bcmxcp.c, drivers/belkin.c, drivers/belkinunv.c, drivers/bestfcom.c, drivers/bestfortress.c, drivers/bestuferrups.c, drivers/bestups.c, drivers/bicker_ser.c, drivers/blazer.c, drivers/clone-outlet.c, drivers/clone.c, drivers/dummy-ups.c, drivers/etapro.c, drivers/everups.c, drivers/gamatronic.c, drivers/generic_gpio_common.c, drivers/generic_modbus.c, drivers/genericups.c, drivers/huawei-ups2000.c, drivers/hwmon_ina219.c, drivers/isbmex.c, drivers/ivtscd.c, drivers/liebert-esp2.c, drivers/liebert-gxe.c, drivers/liebert.c, drivers/macosx-ups.c, drivers/masterguard.c, drivers/metasys.c, drivers/mge-utalk.c, drivers/microdowell.c, drivers/microsol-common.c, drivers/netxml-ups.c, drivers/nut-ipmipsu.c, drivers/nutdrv_atcl_usb.c, drivers/nutdrv_qx.c, drivers/nutdrv_siemens_sitop.c, drivers/oneac.c, drivers/optiups.c, drivers/phoenixcontact_modbus.c, drivers/pijuice.c, drivers/powercom.c, drivers/powerman-pdu.c, drivers/powerpanel.c, drivers/rhino.c, drivers/richcomm_usb.c, drivers/riello_ser.c, drivers/riello_usb.c, drivers/safenet.c, drivers/skel.c, drivers/sms_ser.c, drivers/snmp-ups.c, drivers/socomec_jbus.c, drivers/solis.c, drivers/tripplite.c, drivers/tripplite_usb.c, drivers/tripplitesu.c, drivers/upscode2.c, drivers/usbhid-ups.c, drivers/victronups.c: drivers/*.c: simplify upsdrv_shutdown() back, as only "shutdown.default" implementations again [#2670]
- drivers/main.c: update some comments [#2670]
- drivers/main.c, drivers/main.h: drivers/main.{c,h}: introduce MAX_SDCOMMANDS_DEPTH for do_loop_shutdown_commands() [#2670]
- drivers/dstate.c, drivers/main.c, drivers/main.h: drivers/main.{c,h}, drivers/dstate.c: introduce main_instcmd_fallback() so drivers might implement their own "shutdown.default" at will [#2670]
- drivers/main.c: drivers/main.{c,h}: call upsdrv_shutdown_sdcommands_or_default() not default upsdrv_shutdown() as the implementation of forceshutdown() and "driver.killpower" INSTCMD (e.g. via `drivername -k`) [#2670]
- drivers/main.c, drivers/main.h: drivers/main.{c,h}: rename upsdrv_shutdown_default() ⇒ upsdrv_shutdown_sdcommands_or_default() less ambiguously [#2670]
- drivers/main.c: do_loop_shutdown_commands(): shortcut for "shutdown.default" support [#2670]
- drivers/main.c: implement INSTCMD "shutdown.default" as a way to call upsdrv_shutdown() in any driver [#2670]
- drivers/main.c: update some comments

### 2.313. 2024-11-19 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- data/cmdvartab, docs/nut-names.txt: change rest bypass to Bypass
- docs/nut-names.txt: bypass to Bypass in nut-names.txt
- data/cmdvartab, docs/nut-names.txt: added to cmdvartab and nut-names.txt
- drivers/mge-hid.c: added input.transfer.bypass.overload and input.transfer.bypass.outlimits
- drivers/mge-hid.c: added input.bypass.switchable

### 2.314. 2024-11-18 Jim Klimov <jimklimov+nut@gmail.com>

- NEWS.adoc, docs/man/ups.conf.txt, docs/nut-names.txt, drivers/main.c, drivers/main.h: drivers/main.{c,h}, docs: introduce `shutdown.default` INSTCMD concept and upsdrv_shutdown_default() shared method [#2670]
- drivers/powercom.c: drop checks for HAVE_ATTRIBUTENORETURN in instcmd() [#2670]
- drivers/ivtscd.c: comment about upsdrv_shutdown() oddness in this driver [#2670]
- NEWS.adoc, drivers/adelsystem_cbi.c, drivers/al175.c, drivers/apc_modbus.c, drivers/apcsmart-old.c, drivers/apcsmart.c, drivers/apcupsd-ups.c, drivers/asem.c, drivers/bcmxcp.c, drivers/belkin.c, drivers/belkinunv.c, drivers/bestfcom.c, drivers/bestfortress.c, drivers/bestuferrups.c, drivers/bestups.c, drivers/bicker_ser.c, drivers/blazer.c, drivers/clone-outlet.c, drivers/clone.c, drivers/dummy-ups.c, drivers/etapro.c, drivers/everups.c, drivers/gamatronic.c, drivers/generic_gpio_common.c, drivers/generic_modbus.c, drivers/genericups.c, drivers/huawei-ups2000.c, drivers/hwmon_ina219.c, drivers/isbmex.c, drivers/ivtscd.c, drivers/liebert-esp2.c, drivers/liebert-gxe.c, drivers/liebert.c, drivers/macosx-ups.c, drivers/main.c, drivers/main.h, drivers/masterguard.c, drivers/metasys.c, drivers/microdowell.c, drivers/microsol-common.c, drivers/netxml-ups.c, drivers/nut-ipmipsu.c, drivers/nutdrv_atcl_usb.c, drivers/nutdrv_qx.c, drivers/nutdrv_siemens_sitop.c, drivers/oneac.c, drivers/optiups.c, drivers/phoenixcontact_modbus.c, drivers/pijuice.c, drivers/powercom.c, drivers/powerman-pdu.c, drivers/powerpanel.c, drivers/rhino.c, drivers/richcomm_usb.c, drivers/riello_ser.c, drivers/riello_usb.c, drivers/safenet.c, drivers/skel.c, drivers/sms_ser.c, drivers/snmp-ups.c, drivers/socomec_jbus.c, drivers/solis.c, drivers/tripplite.c, drivers/tripplite_usb.c, drivers/tripplitesu.c, drivers/upscode2.c, drivers/usbhid-ups.c, drivers/victronups.c: drivers/*.c, drivers/main.h: introduce and use a common handling_upsdrv_shutdown flag to exit or not after upsdrv_shutdown() and individual power-state related INSTCMDs [#2670]
- drivers/al175.c, drivers/apcupsd-ups.c, drivers/asem.c, drivers/bcmxcp.c, drivers/bicker_ser.c, drivers/blazer.c, drivers/clone-outlet.c, drivers/clone.c, drivers/dummy-ups.c, drivers/generic_gpio_common.c, drivers/generic_modbus.c, drivers/genericups.c, drivers/huawei-ups2000.c, drivers/hwmon_ina219.c, drivers/isbmex.c, drivers/ivtscd.c, drivers/liebert.c, drivers/macosx-ups.c, drivers/main.c, drivers/netxml-ups.c, drivers/nut-ipmipsu.c, drivers/nutdrv_qx.c, drivers/phoenixcontact_modbus.c, drivers/powercom.c, drivers/powerman-pdu.c, drivers/riello_ser.c, drivers/riello_usb.c, drivers/safenet.c, drivers/skel.c, drivers/sms_ser.c, drivers/snmp-ups.c, drivers/socomec_jbus.c, drivers/usbhid-ups.c: drivers/*.c: use common EF_EXIT_FAILURE and EF_EXIT_SUCCESS arg values for set_exit_flag(int) methods [#2670]
- include/common.h, docs/new-drivers.txt, NEWS.adoc: define common EF_EXIT_FAILURE and EF_EXIT_SUCCESS for set_exit_flag(int) methods [#2670]
- drivers/usbhid-ups.c: update to use "sdcommands" (if customized by user), by default chain the originally used sequence in upsdrv_shutdown() [#2670]
- drivers/victronups.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/upscode2.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/tripplitesu.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/tripplite_usb.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/tripplite.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/solis.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/socomec_jbus.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/snmp-ups.c: update to use "sdcommands" (if customized by user), by default chain the originally used sequence in upsdrv_shutdown() [#2670]
- drivers/adelsystem_cbi.c, drivers/apc_modbus.c, drivers/generic_modbus.c, drivers/netxml-ups.c, drivers/nut-ipmipsu.c, drivers/phoenixcontact_modbus.c, drivers/powerman-pdu.c, drivers/snmp-ups.c: drivers/*.c: for networked drivers (snmp, netxml, IPMI, modbus/TCP) comment in upsdrv_shutdown() some limitations of the media that networked UPS-shutdown may not be generally possible in an endgame [#2770]
- drivers/sms_ser.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/skel.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/safenet.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/riello_usb.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/riello_ser.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/richcomm_usb.c: update to use "sdcommands" and move logic from upsdrv_shutdown() to upscmd("shutdown.return"); newly support INSTCMD at all [#2670]
- drivers/rhino.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/powerp-bin.c, drivers/powerp-txt.c, drivers/powerpanel.c: drivers/powerp*.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/powerman-pdu.c: drivers/powerman.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/powercom.c: update to use "sdcommands" (if customized by user) [#2670]

### 2.315. 2024-11-18 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- drivers/mge-hid.c: change double to %.1f of voltage and frequency
- drivers/mge-hid.c: add debug log in case out of limits for bypass/eco
- drivers/mge-hid.c: comment added
- drivers/mge-hid.c: rename eco function

### 2.316. 2024-11-17 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/pijuice.c: update to use "sdcommands" and move logic from upsdrv_shutdown() to upscmd("shutdown.stayoff"); newly support INSTCMD at all [#2670]
- drivers/phoenixcontact_modbus.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/optiups.c: update to use "sdcommands" (if customized by user) [#2670]

### 2.317. 2024-11-16 Jim Klimov <jimklimov@gmail.com>

- drivers/usbhid-ups.c: report unhandled negative HIDGetEvents() return values [#2681]
- NEWS.adoc, docs/man/usbhid-ups.txt, drivers/usbhid-ups.c, include/nutconf.hpp: drivers/usbhid-ups.c: fix fallout of #2671 and complete the feature with optional `interrupt_pipe_no_events_tolerance` setting [#2681]

### 2.318. 2024-11-16 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/oneac.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/nutdrv_qx.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/nutdrv_siemens_sitop.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/nutdrv_atcl_usb.c: update to use "sdcommands" and move logic from upsdrv_shutdown() to upscmd("shutdown.stayoff"); newly support INSTCMD at all [#2670]
- drivers/nut-ipmipsu.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/netxml-ups.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/microsol-apc.c, drivers/microsol-common.c: drivers/microsol*.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/microdowell.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/metasys.c: update to use "sdcommands" (if customized by user) [#2670]
- NEWS.adoc: fix for upsnotify references

### 2.319. 2024-11-15 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/masterguard.c: update to use "sdcommands" and move logic from upsdrv_shutdown() to upscmd("shutdown.return"); newly support INSTCMD at all [#2670]
- drivers/macosx-ups.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/liebert.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/liebert-gxe.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/liebert-esp2.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/ivtscd.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/isbmex.c: update to use "sdcommands" and move logic from upsdrv_shutdown() to upscmd("shutdown.stayoff"); newly support INSTCMD at all [#2670]
- drivers/hwmon_ina219.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/huawei-ups2000.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/genericups.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/generic_modbus.c: update to use "sdcommands" and move logic from upsdrv_shutdown() to upscmd("shutdown.stayoff") [#2670]
- drivers/generic_gpio_common.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/gamatronic.c: fix misplaced upslogx(1, …) by upsdebugx()
- drivers/gamatronic.c: update to use "sdcommands" and move logic from upsdrv_shutdown() to upscmd("shutdown.return"); newly support INSTCMD at all [#2670]
- drivers/etapro.c: update to use "sdcommands" and move logic from upsdrv_shutdown() to upscmd("shutdown.return") [#2670]
- NEWS.adoc, common/common.c, docs/nut.dict, include/common.h: common/common.c, include/common.h: follow-up for `upsnotify()` [#1590, #2136] * introduce `str_upsnotify_state()` for meaningful debug log messages; * suggest to `export NUT_QUIET_INIT_UPSNOTIFY=true` where we "will not spam more about it" for systems that do not currently expect to have notification support or need
- NEWS.adoc: document usbhid-ups fix for 0 HID Objects and lock-up on some devices [#2671] * Grew from https://github.com/user-attachments/files/17646606/0001-apc-fix.patch.txt proposed at https://github.com/networkupstools/nut/issues/2644#issuecomment-2459538691

### 2.320. 2024-11-15 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- drivers/mge-hid.c: fix commands func
- drivers/mge-hid.c: add check range for eco/bypass commands

### 2.321. 2024-11-14 Jim Klimov <jimklimov+nut@gmail.com>

- drivers/dummy-ups.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/clone.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/clone-outlet.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/blazer.c, drivers/blazer_ser.c, drivers/blazer_usb.c: drivers/blazer*.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/bicker_ser.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/bestups.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/bestuferrups.c: update to use "sdcommands" and move logic from upsdrv_shutdown() to upscmd("shutdown.return"); newly support INSTCMD at all [#2670]
- drivers/bestfortress.c: update to use "sdcommands" and move logic from upsdrv_shutdown() to upscmd("shutdown.return") [#2670]
- drivers/bestfcom.c: update to use "sdcommands" and move logic from upsdrv_shutdown() to upscmd("shutdown.return"); newly support INSTCMD at all [#2670]
- drivers/belkinunv.c: update to use "sdcommands" (if customized by user); revise warning message [#2670]
- drivers/belkin.c: update to use "sdcommands" and move logic from upsdrv_shutdown() to upscmd("shutdown.return") [#2670]
- drivers/bcmxcp.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/asem.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/apcupsd-ups.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/apcsmart.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/apcsmart-old.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/apc_modbus.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/al175.c: update to use "sdcommands" (if customized by user) [#2670]
- drivers/adelsystem_cbi.c: update to use "sdcommands" and move logic from upsdrv_shutdown() to upscmd("shutdown.stayoff") [#2670]
- drivers/everups.c: update to use "sdcommands" and have an instcmd() at all [#2670]
- drivers/mge-utalk.c: update to use "sdcommands" [#2670]
- drivers/mge-hid.c: bump subdriver version for added ECO code [#2637]
- drivers/mge-hid.c: drop ECO/ABM-related changes from PR #2637 (revised in later PR)
- clients/status.h: lower severity of ECO state [#2637]
- drivers/mge-hid.c: reshuffle whitespace/markup of ECO code to same standard as around [#2637]

### 2.322. 2024-11-12 Jim Klimov <jimklimov+nut@gmail.com>

- configure.ac: new distros' clang-medium warnings want -Wno-nullable-to-nonnull-conversion flag
- drivers/apc_modbus.c: actually, report USB support (also) in DRIVER_NAME [#2666]
- configure.ac, NEWS.adoc, UPGRADING.adoc: reshuffle defaulting of --with-modbus\+usb=yes and fix a typo checking --with-drivers there [#2666]
- NEWS.adoc, UPGRADING.adoc: NEWS.adoc: document fixes for libmodbus\+libusb support [#2666]
- drivers/apc_modbus.c: report (in debug traces) whether USB-capable libmodbus was used to build this driver [#2666]
- configure.ac, docs/configure.txt: configure.ac: introduce --with-modbus\+usb option to require USB-capable libmodbus [#2666]
- configure.ac: report "Modbus drivers" as plural [#2676]
- configure.ac: report if building modbus\+usb [#2666]
- m4/nut_check_libmodbus.m4: try re-detecting libmodbus support for libusb adding its CFLAGS and LIBS into the loop [#2666]
- docs/config-prereqs.txt: update Debian/Ubuntu/TermUX with explicit binutils (for ldd) [#2673]
- NEWS.adoc, configure.ac, m4/nut_report_feature.m4: configure.ac, m4/nut_report_feature.m4: group lines of first section better with NUT_REPORT_FEATURE, NUT_REPORT_DRIVER, NUT_REPORT_PROGRAM [#2676]

### 2.323. 2024-11-12 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- drivers/mge-hid.c: add ChargerType to ABM Table

### 2.324. 2024-11-11 Jim Klimov <jimklimov@gmail.com>

- clients/Makefile.am: consider LIBSSL_LDFLAGS_RPATH [#2674]
- m4/nut_check_libnss.m4: experiment more with LIBSSL_LDFLAGS_RPATH on Solarish platforms [#2674]
- drivers/Makefile.am, server/Makefile.am, tools/nut-scanner/Makefile.am: server/Makefile.am, drivers/Makefile.am: consider LIBSSL_LDFLAGS_RPATH also [#2674]

### 2.325. 2024-11-11 Bill Elliot <bill@wreassoc.com>

- drivers/Makefile.am, drivers/powervar-c.c, drivers/powervar-c.h, drivers/powervar-cu.c: Still trying to get USB driver to build.

### 2.326. 2024-11-10 Jim Klimov <jimklimov@gmail.com>

- ci_build.sh: OpenIndiana and 32-bit libgd, do not only check about that situation with GCC [#2673]
- m4/nut_check_libnetsnmp.m4: convert to use depCFLAGS etc. and mix them with build-common CFLAGS etc. for target-platform-relevant checks [#2673]
- m4/nut_check_libneon.m4: convert to use depCFLAGS etc. and mix them with build-common CFLAGS etc. for target-platform-relevant checks [#2673]
- m4/nut_check_libmodbus.m4: convert to use depCFLAGS etc. and mix them with build-common CFLAGS etc. for target-platform-relevant checks [#2673]
- m4/nut_check_libgpiod.m4: convert to use depCFLAGS etc. and mix them with build-common CFLAGS etc. for target-platform-relevant checks [#2673]
- m4/nut_check_libavahi.m4: convert to use depCFLAGS etc. and mix them with build-common CFLAGS etc. for target-platform-relevant checks [#2673]
- m4/nut_check_libwrap.m4: convert to use depCFLAGS etc. and mix them with build-common CFLAGS etc. for target-platform-relevant checks [#2673]
- m4/nut_check_libusb.m4: convert to use depCFLAGS etc. and mix them with build-common CFLAGS etc. for target-platform-relevant checks [#2673]
- m4/nut_check_libsystemd.m4: convert to use depCFLAGS etc. and mix them with build-common CFLAGS etc. for target-platform-relevant checks [#2673]
- m4/nut_check_libregex.m4: convert to use depCFLAGS etc. and mix them with build-common CFLAGS etc. for target-platform-relevant checks [#2673]
- m4/nut_check_libpowerman.m4: convert to use depCFLAGS etc. and mix them with build-common CFLAGS etc. for target-platform-relevant checks [#2673]
- m4/nut_check_libopenssl.m4: convert to use depCFLAGS etc. and mix them with build-common CFLAGS etc. for target-platform-relevant checks [#2673]
- m4/nut_check_libnss.m4: convert to use depCFLAGS etc. and mix them with build-common CFLAGS etc. for target-platform-relevant checks [#2673]
- m4/nut_check_libltdl.m4: convert to use depCFLAGS etc. and mix them with build-common CFLAGS etc. for target-platform-relevant checks [#2673]
- m4/nut_check_libfreeipmi.m4: convert to use depCFLAGS etc. and mix them with build-common CFLAGS etc. for target-platform-relevant checks [#2673]
- m4/nut_check_libgd.m4: convert to use depCFLAGS etc. and mix them with build-common CFLAGS etc. for target-platform-relevant checks [#2673]
- m4/nut_check_libgd.m4: in test program, check also the gdImageString() [#2673]

### 2.327. 2024-11-10 Jim Klimov <jimklimov+nut@gmail.com>

- NEWS.adoc, conf/ups.conf.sample, docs/man/ups.conf.txt, docs/nut.dict, drivers/main.c, drivers/main.h: Introduce "sdcommands" setting for all drivers [#2670]

### 2.328. 2024-11-10 Jim Klimov <jim@jimklimov.com>

- NEWS.adoc, docs/config-prereqs.txt, docs/nut.dict: NEWS.adoc, docs/config-prereqs.txt: document solutions for #2673 and #2674
- configure.ac, m4/nut_check_libnss.m4, m4/nut_check_libopenssl.m4, tools/nut-scanner/Makefile.am: m4/nut_check_libnss.m4, tools/nut-scanner/Makefile.am, etc: track LIBSSL_LDFLAGS_RPATH (custom on Solaris/illumos) [#2674]

### 2.329. 2024-11-09 Jim Klimov <jimklimov+nut@gmail.com>

- docs/config-prereqs.txt: update Mozilla NSS notes for OpenIndiana and OmniOS
- ci_build.sh: more CI clues to recognize target bitness

### 2.330. 2024-11-08 Jim Klimov <jimklimov+nut@gmail.com>

- docs/config-prereqs.txt, docs/nut.dict: docs/config-prereqs.txt: update for OpenIndiana packaging of Mozilla NSPR
- docs/config-prereqs.txt: extra header-nss package in OpenIndiana 2024.x
- ci_build.sh: revise build of CGI on OI (troublesome with 32-bit variant nowadays)

### 2.331. 2024-11-06 Michał Bogdziewicz <michal@bogdziewicz.xyz>

- drivers/usbhid-ups.c: handle zero HID events with reconnection

### 2.332. 2024-11-05 Jim Klimov <jimklimov+nut@gmail.com>

- docs/ci-farm-lxc-setup.txt, docs/config-prereqs.txt, docs/images/ci/jenkins-nut.txt, docs/nut.dict: docs/config-prereqs.txt, docs/ci-farm-lxc-setup.txt et al: update for NUT CI farm baseline JDK17 (per Jenkins core requirements since autumn 2024)

### 2.333. 2024-11-03 William Goodspeed <86338960+goodspeed34@users.noreply.github.com>

- drivers/ydn23.h: fix bad lchksum Fix a bad checksum in length field. However, ‘liebert-gxe’ was not affected because the frame never exceeds 2\^4-1.

### 2.334. 2024-10-28 desertwitch <24509509+desertwitch@users.noreply.github.com>

- drivers/mge-hid.c: improve path decisions and comments

### 2.335. 2024-10-28 DaRK AnGeL <28630321+masterwishx@users.noreply.github.com>

- drivers/mge-hid.c: remove unused eaton_abm_charger_type_fun()
